/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 28 "parser.y"


#define PARSER_VERSION_STRING "parser_version_3"

#include "config.h"
#include <stdlib.h>
#include <termios.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <setjmp.h>
#include <sys/stat.h>                    /* structure stat       */
#include <unistd.h>                      /* prototype for stat() */
#include <sys/wait.h>
#include <signal.h>
#include <stdarg.h>
#include <pwd.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#ifdef __linux__
#include <mntent.h>
#endif

#include "dosemu_config.h"
#include "emu.h"
#ifdef X86_EMULATOR
#include "cpu-emu.h"
#endif
#include "disks.h"
#include "port.h"
#define allow_io	port_allow_io
#include "lpt.h"
#include "video.h"
#include "vc.h"
#include "mouse.h"
#include "serial.h"
#include "timers.h"
#include "keyboard/keymaps.h"
#include "keyboard/keyb_server.h"
#include "memory.h"
#include "mapping.h"
#include "utilities.h"
#include "aspi.h"
#include "pktdrvr.h"
#include "iodev.h" /* for TM_BIOS / TM_PIT / TM_LINUX */

#define USERVAR_PREF	"dosemu_"
static int user_scope_level;

static int after_secure_check = 0;
static serial_t *sptr;
static serial_t nullser;
static mouse_t *mptr = &config.mouse;
static int c_ser = 0;

static struct disk *dptr;
static struct disk nulldisk;
static int c_hdisks = 0;
static int c_fdisks = 0;

int dexe_running = 0;
static int dexe_forbid_disk = 1;
char own_hostname[128];

static struct printer nullptr;
static struct printer *pptr = &nullptr;
static int c_printers = 0;

static int ports_permission = IO_RDWR;
static unsigned int ports_ormask = 0;
static unsigned int ports_andmask = 0xFFFF;
static unsigned int portspeed = 0;
static char dev_name[255]= "";

static int errors = 0;
static int warnings = 0;

static int priv_lvl = 0;
static int saved_priv_lvl = 0; 


static char *file_being_parsed;

			/* this to ensure we are parsing a new style */
static int parser_version_3_style_used = 0;
#define CONFNAME_V3USED "version_3_style_used"

	/* local procedures */

static void start_ports(void);
static void start_mouse(void);
static void stop_mouse(void);
static void start_debug(void);
static void start_video(void);
static void stop_video(void);
static void set_vesamodes(int width, int height, int color_bits);
static int detect_vbios_seg(void);
static int detect_vbios_size(void);
static void stop_ttylocks(void);
static void start_serial(void);
static void stop_serial(void);
static void start_printer(void);
static void stop_printer(void);
static void start_keyboard(void);
static void keytable_start(int layout);
static void keytable_stop(void);
static void dump_keytables_to_file(char *name);
static void stop_terminal(void);
static void start_disk(void);
static void do_part(char *);
static void start_floppy(void);
static void stop_disk(int token);
static void start_vnet(char *);
static FILE* open_file(char* filename);
static void close_file(FILE* file);
static void write_to_syslog(char *message);
static void set_irq_value(int bits, int i1);
static void set_irq_range(int bits, int i1, int i2);
static int undefine_config_variable(char *name);
static void check_user_var(char *name);
static char *run_shell(char *command);
static int for_each_handling(int loopid, char *varname, char *delim, char *list);
static void enter_user_scope(int incstackptr);
static void leave_user_scope(int incstackptr);
static void handle_features(int which, int value);
static void set_joy_device(char *devstring);
static int parse_timemode(const char *);

	/* class stuff */
#define IFCLASS(m) if (is_in_allowed_classes(m))

#define CL_ALL			-1
#define CL_VAR		    0x200
#define CL_VPORT	   0x2000
#define CL_PORT		  0x20000
#define CL_PCI		  0x40000
#define CL_IRQ		 0x200000
#define CL_HARDRAM	0x1000000
#define CL_NET		0x2000000

static int is_in_allowed_classes(int mask);

#define TOF(x) ( x.type == TYPE_REAL ? x.value.r : x.value.i )
#define V_VAL(x,y,z) \
do { x.type = y.type; if (x.type == TYPE_REAL) x.value.r = (z); \
      else x.value.i = (z); } \
while (0)

	/* variables in lexer.l */




	/* for unicode keyboard plugin */
static void keyb_mod(int wich, t_keysym keynum, int unicode);
static void dump_keytable_part(FILE *f, t_keysym *map, int size);



#include "translate/translate.h"
#include "translate/dosemu_charset.h"
	/* for translate plugin */

static void set_internal_charset(char *charset_name);
static void set_external_charset(char *charset_name);


#line 243 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_INTEGER = 3,                    /* INTEGER  */
  YYSYMBOL_L_OFF = 4,                      /* L_OFF  */
  YYSYMBOL_L_ON = 5,                       /* L_ON  */
  YYSYMBOL_L_AUTO = 6,                     /* L_AUTO  */
  YYSYMBOL_L_YES = 7,                      /* L_YES  */
  YYSYMBOL_L_NO = 8,                       /* L_NO  */
  YYSYMBOL_CHIPSET_TYPE = 9,               /* CHIPSET_TYPE  */
  YYSYMBOL_KEYB_LAYOUT = 10,               /* KEYB_LAYOUT  */
  YYSYMBOL_REAL = 11,                      /* REAL  */
  YYSYMBOL_STRING = 12,                    /* STRING  */
  YYSYMBOL_VARIABLE = 13,                  /* VARIABLE  */
  YYSYMBOL_EXPRTEST = 14,                  /* EXPRTEST  */
  YYSYMBOL_INTCAST = 15,                   /* INTCAST  */
  YYSYMBOL_REALCAST = 16,                  /* REALCAST  */
  YYSYMBOL_AND_OP = 17,                    /* AND_OP  */
  YYSYMBOL_OR_OP = 18,                     /* OR_OP  */
  YYSYMBOL_XOR_OP = 19,                    /* XOR_OP  */
  YYSYMBOL_SHR_OP = 20,                    /* SHR_OP  */
  YYSYMBOL_SHL_OP = 21,                    /* SHL_OP  */
  YYSYMBOL_NOT_OP = 22,                    /* NOT_OP  */
  YYSYMBOL_EQ_OP = 23,                     /* EQ_OP  */
  YYSYMBOL_GE_OP = 24,                     /* GE_OP  */
  YYSYMBOL_LE_OP = 25,                     /* LE_OP  */
  YYSYMBOL_26_ = 26,                       /* '='  */
  YYSYMBOL_27_ = 27,                       /* '<'  */
  YYSYMBOL_28_ = 28,                       /* '>'  */
  YYSYMBOL_NEQ_OP = 29,                    /* NEQ_OP  */
  YYSYMBOL_STR_EQ_OP = 30,                 /* STR_EQ_OP  */
  YYSYMBOL_STR_NEQ_OP = 31,                /* STR_NEQ_OP  */
  YYSYMBOL_L_AND_OP = 32,                  /* L_AND_OP  */
  YYSYMBOL_L_OR_OP = 33,                   /* L_OR_OP  */
  YYSYMBOL_34_ = 34,                       /* '+'  */
  YYSYMBOL_35_ = 35,                       /* '-'  */
  YYSYMBOL_36_ = 36,                       /* '*'  */
  YYSYMBOL_37_ = 37,                       /* '/'  */
  YYSYMBOL_UMINUS = 38,                    /* UMINUS  */
  YYSYMBOL_UPLUS = 39,                     /* UPLUS  */
  YYSYMBOL_BIT_NOT_OP = 40,                /* BIT_NOT_OP  */
  YYSYMBOL_STRLEN = 41,                    /* STRLEN  */
  YYSYMBOL_STRTOL = 42,                    /* STRTOL  */
  YYSYMBOL_STRNCMP = 43,                   /* STRNCMP  */
  YYSYMBOL_STRCAT = 44,                    /* STRCAT  */
  YYSYMBOL_STRPBRK = 45,                   /* STRPBRK  */
  YYSYMBOL_STRSPLIT = 46,                  /* STRSPLIT  */
  YYSYMBOL_STRCHR = 47,                    /* STRCHR  */
  YYSYMBOL_STRRCHR = 48,                   /* STRRCHR  */
  YYSYMBOL_STRSTR = 49,                    /* STRSTR  */
  YYSYMBOL_STRDEL = 50,                    /* STRDEL  */
  YYSYMBOL_STRSPN = 51,                    /* STRSPN  */
  YYSYMBOL_STRCSPN = 52,                   /* STRCSPN  */
  YYSYMBOL_SHELL = 53,                     /* SHELL  */
  YYSYMBOL_DEFINED = 54,                   /* DEFINED  */
  YYSYMBOL_DEFINE = 55,                    /* DEFINE  */
  YYSYMBOL_UNDEF = 56,                     /* UNDEF  */
  YYSYMBOL_IFSTATEMENT = 57,               /* IFSTATEMENT  */
  YYSYMBOL_WHILESTATEMENT = 58,            /* WHILESTATEMENT  */
  YYSYMBOL_FOREACHSTATEMENT = 59,          /* FOREACHSTATEMENT  */
  YYSYMBOL_ENTER_USER_SPACE = 60,          /* ENTER_USER_SPACE  */
  YYSYMBOL_LEAVE_USER_SPACE = 61,          /* LEAVE_USER_SPACE  */
  YYSYMBOL_CHECKUSERVAR = 62,              /* CHECKUSERVAR  */
  YYSYMBOL_DOSBANNER = 63,                 /* DOSBANNER  */
  YYSYMBOL_FASTFLOPPY = 64,                /* FASTFLOPPY  */
  YYSYMBOL_HOGTHRESH = 65,                 /* HOGTHRESH  */
  YYSYMBOL_SPEAKER = 66,                   /* SPEAKER  */
  YYSYMBOL_IPXSUPPORT = 67,                /* IPXSUPPORT  */
  YYSYMBOL_IPXNETWORK = 68,                /* IPXNETWORK  */
  YYSYMBOL_NOVELLHACK = 69,                /* NOVELLHACK  */
  YYSYMBOL_ETHDEV = 70,                    /* ETHDEV  */
  YYSYMBOL_TAPDEV = 71,                    /* TAPDEV  */
  YYSYMBOL_VDESWITCH = 72,                 /* VDESWITCH  */
  YYSYMBOL_SLIRPARGS = 73,                 /* SLIRPARGS  */
  YYSYMBOL_VNET = 74,                      /* VNET  */
  YYSYMBOL_DEBUG = 75,                     /* DEBUG  */
  YYSYMBOL_MOUSE = 76,                     /* MOUSE  */
  YYSYMBOL_SERIAL = 77,                    /* SERIAL  */
  YYSYMBOL_COM = 78,                       /* COM  */
  YYSYMBOL_KEYBOARD = 79,                  /* KEYBOARD  */
  YYSYMBOL_TERMINAL = 80,                  /* TERMINAL  */
  YYSYMBOL_VIDEO = 81,                     /* VIDEO  */
  YYSYMBOL_EMURETRACE = 82,                /* EMURETRACE  */
  YYSYMBOL_TIMER = 83,                     /* TIMER  */
  YYSYMBOL_MATHCO = 84,                    /* MATHCO  */
  YYSYMBOL_CPU = 85,                       /* CPU  */
  YYSYMBOL_CPUSPEED = 86,                  /* CPUSPEED  */
  YYSYMBOL_RDTSC = 87,                     /* RDTSC  */
  YYSYMBOL_BOOTDRIVE = 88,                 /* BOOTDRIVE  */
  YYSYMBOL_SWAP_BOOTDRIVE = 89,            /* SWAP_BOOTDRIVE  */
  YYSYMBOL_L_XMS = 90,                     /* L_XMS  */
  YYSYMBOL_L_DPMI = 91,                    /* L_DPMI  */
  YYSYMBOL_DPMI_LIN_RSV_BASE = 92,         /* DPMI_LIN_RSV_BASE  */
  YYSYMBOL_DPMI_LIN_RSV_SIZE = 93,         /* DPMI_LIN_RSV_SIZE  */
  YYSYMBOL_PM_DOS_API = 94,                /* PM_DOS_API  */
  YYSYMBOL_NO_NULL_CHECKS = 95,            /* NO_NULL_CHECKS  */
  YYSYMBOL_PORTS = 96,                     /* PORTS  */
  YYSYMBOL_DISK = 97,                      /* DISK  */
  YYSYMBOL_DOSMEM = 98,                    /* DOSMEM  */
  YYSYMBOL_EXT_MEM = 99,                   /* EXT_MEM  */
  YYSYMBOL_L_EMS = 100,                    /* L_EMS  */
  YYSYMBOL_UMB_A0 = 101,                   /* UMB_A0  */
  YYSYMBOL_UMB_B0 = 102,                   /* UMB_B0  */
  YYSYMBOL_UMB_F0 = 103,                   /* UMB_F0  */
  YYSYMBOL_EMS_SIZE = 104,                 /* EMS_SIZE  */
  YYSYMBOL_EMS_FRAME = 105,                /* EMS_FRAME  */
  YYSYMBOL_EMS_UMA_PAGES = 106,            /* EMS_UMA_PAGES  */
  YYSYMBOL_EMS_CONV_PAGES = 107,           /* EMS_CONV_PAGES  */
  YYSYMBOL_TTYLOCKS = 108,                 /* TTYLOCKS  */
  YYSYMBOL_L_SOUND = 109,                  /* L_SOUND  */
  YYSYMBOL_L_SND_OSS = 110,                /* L_SND_OSS  */
  YYSYMBOL_L_JOYSTICK = 111,               /* L_JOYSTICK  */
  YYSYMBOL_FULL_FILE_LOCKS = 112,          /* FULL_FILE_LOCKS  */
  YYSYMBOL_DEXE = 113,                     /* DEXE  */
  YYSYMBOL_ALLOWDISK = 114,                /* ALLOWDISK  */
  YYSYMBOL_FORCEXDOS = 115,                /* FORCEXDOS  */
  YYSYMBOL_XDOSONLY = 116,                 /* XDOSONLY  */
  YYSYMBOL_ABORT = 117,                    /* ABORT  */
  YYSYMBOL_WARN = 118,                     /* WARN  */
  YYSYMBOL_L_FLOPPY = 119,                 /* L_FLOPPY  */
  YYSYMBOL_EMUSYS = 120,                   /* EMUSYS  */
  YYSYMBOL_L_X = 121,                      /* L_X  */
  YYSYMBOL_L_SDL = 122,                    /* L_SDL  */
  YYSYMBOL_DOSEMUMAP = 123,                /* DOSEMUMAP  */
  YYSYMBOL_LOGBUFSIZE = 124,               /* LOGBUFSIZE  */
  YYSYMBOL_LOGFILESIZE = 125,              /* LOGFILESIZE  */
  YYSYMBOL_MAPPINGDRIVER = 126,            /* MAPPINGDRIVER  */
  YYSYMBOL_LFN_SUPPORT = 127,              /* LFN_SUPPORT  */
  YYSYMBOL_EMULATED = 128,                 /* EMULATED  */
  YYSYMBOL_NATIVE = 129,                   /* NATIVE  */
  YYSYMBOL_CPUEMU = 130,                   /* CPUEMU  */
  YYSYMBOL_CPU_VM = 131,                   /* CPU_VM  */
  YYSYMBOL_VM86 = 132,                     /* VM86  */
  YYSYMBOL_FULL = 133,                     /* FULL  */
  YYSYMBOL_VM86SIM = 134,                  /* VM86SIM  */
  YYSYMBOL_FULLSIM = 135,                  /* FULLSIM  */
  YYSYMBOL_KVM = 136,                      /* KVM  */
  YYSYMBOL_RAWKEYBOARD = 137,              /* RAWKEYBOARD  */
  YYSYMBOL_PRESTROKE = 138,                /* PRESTROKE  */
  YYSYMBOL_KEYTABLE = 139,                 /* KEYTABLE  */
  YYSYMBOL_SHIFT_MAP = 140,                /* SHIFT_MAP  */
  YYSYMBOL_ALT_MAP = 141,                  /* ALT_MAP  */
  YYSYMBOL_NUMPAD_MAP = 142,               /* NUMPAD_MAP  */
  YYSYMBOL_DUMP = 143,                     /* DUMP  */
  YYSYMBOL_DGRAVE = 144,                   /* DGRAVE  */
  YYSYMBOL_DACUTE = 145,                   /* DACUTE  */
  YYSYMBOL_DCIRCUM = 146,                  /* DCIRCUM  */
  YYSYMBOL_DTILDE = 147,                   /* DTILDE  */
  YYSYMBOL_DBREVE = 148,                   /* DBREVE  */
  YYSYMBOL_DABOVED = 149,                  /* DABOVED  */
  YYSYMBOL_DDIARES = 150,                  /* DDIARES  */
  YYSYMBOL_DABOVER = 151,                  /* DABOVER  */
  YYSYMBOL_DDACUTE = 152,                  /* DDACUTE  */
  YYSYMBOL_DCEDILLA = 153,                 /* DCEDILLA  */
  YYSYMBOL_DIOTA = 154,                    /* DIOTA  */
  YYSYMBOL_DOGONEK = 155,                  /* DOGONEK  */
  YYSYMBOL_DCARON = 156,                   /* DCARON  */
  YYSYMBOL_NETWORK = 157,                  /* NETWORK  */
  YYSYMBOL_PKTDRIVER = 158,                /* PKTDRIVER  */
  YYSYMBOL_DIRECTORY = 159,                /* DIRECTORY  */
  YYSYMBOL_NAMESTUB = 160,                 /* NAMESTUB  */
  YYSYMBOL_BINARY = 161,                   /* BINARY  */
  YYSYMBOL_BASE = 162,                     /* BASE  */
  YYSYMBOL_IRQ = 163,                      /* IRQ  */
  YYSYMBOL_DEVICE = 164,                   /* DEVICE  */
  YYSYMBOL_CHARSET = 165,                  /* CHARSET  */
  YYSYMBOL_BAUDRATE = 166,                 /* BAUDRATE  */
  YYSYMBOL_VIRTUAL = 167,                  /* VIRTUAL  */
  YYSYMBOL_VMODEM = 168,                   /* VMODEM  */
  YYSYMBOL_PSEUDO = 169,                   /* PSEUDO  */
  YYSYMBOL_RTSCTS = 170,                   /* RTSCTS  */
  YYSYMBOL_LOWLAT = 171,                   /* LOWLAT  */
  YYSYMBOL_PCCOM = 172,                    /* PCCOM  */
  YYSYMBOL_MICROSOFT = 173,                /* MICROSOFT  */
  YYSYMBOL_MS3BUTTON = 174,                /* MS3BUTTON  */
  YYSYMBOL_LOGITECH = 175,                 /* LOGITECH  */
  YYSYMBOL_MMSERIES = 176,                 /* MMSERIES  */
  YYSYMBOL_MOUSEMAN = 177,                 /* MOUSEMAN  */
  YYSYMBOL_HITACHI = 178,                  /* HITACHI  */
  YYSYMBOL_MOUSESYSTEMS = 179,             /* MOUSESYSTEMS  */
  YYSYMBOL_BUSMOUSE = 180,                 /* BUSMOUSE  */
  YYSYMBOL_PS2 = 181,                      /* PS2  */
  YYSYMBOL_IMPS2 = 182,                    /* IMPS2  */
  YYSYMBOL_INTERNALDRIVER = 183,           /* INTERNALDRIVER  */
  YYSYMBOL_EMULATE3BUTTONS = 184,          /* EMULATE3BUTTONS  */
  YYSYMBOL_CLEARDTR = 185,                 /* CLEARDTR  */
  YYSYMBOL_L_DISPLAY = 186,                /* L_DISPLAY  */
  YYSYMBOL_L_TITLE = 187,                  /* L_TITLE  */
  YYSYMBOL_X_TITLE_SHOW_APPNAME = 188,     /* X_TITLE_SHOW_APPNAME  */
  YYSYMBOL_ICON_NAME = 189,                /* ICON_NAME  */
  YYSYMBOL_X_KEYCODE = 190,                /* X_KEYCODE  */
  YYSYMBOL_X_BLINKRATE = 191,              /* X_BLINKRATE  */
  YYSYMBOL_X_SHARECMAP = 192,              /* X_SHARECMAP  */
  YYSYMBOL_X_MITSHM = 193,                 /* X_MITSHM  */
  YYSYMBOL_X_FONT = 194,                   /* X_FONT  */
  YYSYMBOL_X_FIXED_ASPECT = 195,           /* X_FIXED_ASPECT  */
  YYSYMBOL_X_ASPECT_43 = 196,              /* X_ASPECT_43  */
  YYSYMBOL_X_LIN_FILT = 197,               /* X_LIN_FILT  */
  YYSYMBOL_X_BILIN_FILT = 198,             /* X_BILIN_FILT  */
  YYSYMBOL_X_MODE13FACT = 199,             /* X_MODE13FACT  */
  YYSYMBOL_X_WINSIZE = 200,                /* X_WINSIZE  */
  YYSYMBOL_X_GAMMA = 201,                  /* X_GAMMA  */
  YYSYMBOL_X_FULLSCREEN = 202,             /* X_FULLSCREEN  */
  YYSYMBOL_VGAEMU_MEMSIZE = 203,           /* VGAEMU_MEMSIZE  */
  YYSYMBOL_VESAMODE = 204,                 /* VESAMODE  */
  YYSYMBOL_X_LFB = 205,                    /* X_LFB  */
  YYSYMBOL_X_PM_INTERFACE = 206,           /* X_PM_INTERFACE  */
  YYSYMBOL_X_MGRAB_KEY = 207,              /* X_MGRAB_KEY  */
  YYSYMBOL_X_BACKGROUND_PAUSE = 208,       /* X_BACKGROUND_PAUSE  */
  YYSYMBOL_SDL_HWREND = 209,               /* SDL_HWREND  */
  YYSYMBOL_VGA = 210,                      /* VGA  */
  YYSYMBOL_MGA = 211,                      /* MGA  */
  YYSYMBOL_CGA = 212,                      /* CGA  */
  YYSYMBOL_EGA = 213,                      /* EGA  */
  YYSYMBOL_NONE = 214,                     /* NONE  */
  YYSYMBOL_CONSOLE = 215,                  /* CONSOLE  */
  YYSYMBOL_GRAPHICS = 216,                 /* GRAPHICS  */
  YYSYMBOL_CHIPSET = 217,                  /* CHIPSET  */
  YYSYMBOL_FULLREST = 218,                 /* FULLREST  */
  YYSYMBOL_PARTREST = 219,                 /* PARTREST  */
  YYSYMBOL_MEMSIZE = 220,                  /* MEMSIZE  */
  YYSYMBOL_VBIOS_SIZE_TOK = 221,           /* VBIOS_SIZE_TOK  */
  YYSYMBOL_VBIOS_SEG = 222,                /* VBIOS_SEG  */
  YYSYMBOL_VGAEMUBIOS_FILE = 223,          /* VGAEMUBIOS_FILE  */
  YYSYMBOL_VBIOS_FILE = 224,               /* VBIOS_FILE  */
  YYSYMBOL_VBIOS_COPY = 225,               /* VBIOS_COPY  */
  YYSYMBOL_VBIOS_MMAP = 226,               /* VBIOS_MMAP  */
  YYSYMBOL_DUALMON = 227,                  /* DUALMON  */
  YYSYMBOL_VBIOS_POST = 228,               /* VBIOS_POST  */
  YYSYMBOL_FORCE_VT_SWITCH = 229,          /* FORCE_VT_SWITCH  */
  YYSYMBOL_PCI = 230,                      /* PCI  */
  YYSYMBOL_COLOR = 231,                    /* COLOR  */
  YYSYMBOL_ESCCHAR = 232,                  /* ESCCHAR  */
  YYSYMBOL_XTERM_TITLE = 233,              /* XTERM_TITLE  */
  YYSYMBOL_IO = 234,                       /* IO  */
  YYSYMBOL_PORT = 235,                     /* PORT  */
  YYSYMBOL_CONFIG = 236,                   /* CONFIG  */
  YYSYMBOL_READ = 237,                     /* READ  */
  YYSYMBOL_WRITE = 238,                    /* WRITE  */
  YYSYMBOL_KEYB = 239,                     /* KEYB  */
  YYSYMBOL_PRINTER = 240,                  /* PRINTER  */
  YYSYMBOL_WARNING = 241,                  /* WARNING  */
  YYSYMBOL_GENERAL = 242,                  /* GENERAL  */
  YYSYMBOL_HARDWARE = 243,                 /* HARDWARE  */
  YYSYMBOL_L_IPC = 244,                    /* L_IPC  */
  YYSYMBOL_SOUND = 245,                    /* SOUND  */
  YYSYMBOL_TRACE = 246,                    /* TRACE  */
  YYSYMBOL_CLEAR = 247,                    /* CLEAR  */
  YYSYMBOL_LPT = 248,                      /* LPT  */
  YYSYMBOL_COMMAND = 249,                  /* COMMAND  */
  YYSYMBOL_TIMEOUT = 250,                  /* TIMEOUT  */
  YYSYMBOL_L_FILE = 251,                   /* L_FILE  */
  YYSYMBOL_L_PARTITION = 252,              /* L_PARTITION  */
  YYSYMBOL_WHOLEDISK = 253,                /* WHOLEDISK  */
  YYSYMBOL_THREEINCH = 254,                /* THREEINCH  */
  YYSYMBOL_THREEINCH_720 = 255,            /* THREEINCH_720  */
  YYSYMBOL_THREEINCH_2880 = 256,           /* THREEINCH_2880  */
  YYSYMBOL_FIVEINCH = 257,                 /* FIVEINCH  */
  YYSYMBOL_FIVEINCH_360 = 258,             /* FIVEINCH_360  */
  YYSYMBOL_READONLY = 259,                 /* READONLY  */
  YYSYMBOL_LAYOUT = 260,                   /* LAYOUT  */
  YYSYMBOL_SECTORS = 261,                  /* SECTORS  */
  YYSYMBOL_CYLINDERS = 262,                /* CYLINDERS  */
  YYSYMBOL_TRACKS = 263,                   /* TRACKS  */
  YYSYMBOL_HEADS = 264,                    /* HEADS  */
  YYSYMBOL_OFFSET = 265,                   /* OFFSET  */
  YYSYMBOL_HDIMAGE = 266,                  /* HDIMAGE  */
  YYSYMBOL_HDTYPE1 = 267,                  /* HDTYPE1  */
  YYSYMBOL_HDTYPE2 = 268,                  /* HDTYPE2  */
  YYSYMBOL_HDTYPE9 = 269,                  /* HDTYPE9  */
  YYSYMBOL_DISKCYL4096 = 270,              /* DISKCYL4096  */
  YYSYMBOL_RDONLY = 271,                   /* RDONLY  */
  YYSYMBOL_WRONLY = 272,                   /* WRONLY  */
  YYSYMBOL_RDWR = 273,                     /* RDWR  */
  YYSYMBOL_ORMASK = 274,                   /* ORMASK  */
  YYSYMBOL_ANDMASK = 275,                  /* ANDMASK  */
  YYSYMBOL_RANGE = 276,                    /* RANGE  */
  YYSYMBOL_FAST = 277,                     /* FAST  */
  YYSYMBOL_SLOW = 278,                     /* SLOW  */
  YYSYMBOL_SILLYINT = 279,                 /* SILLYINT  */
  YYSYMBOL_USE_SIGIO = 280,                /* USE_SIGIO  */
  YYSYMBOL_HARDWARE_RAM = 281,             /* HARDWARE_RAM  */
  YYSYMBOL_SB_BASE = 282,                  /* SB_BASE  */
  YYSYMBOL_SB_IRQ = 283,                   /* SB_IRQ  */
  YYSYMBOL_SB_DMA = 284,                   /* SB_DMA  */
  YYSYMBOL_SB_HDMA = 285,                  /* SB_HDMA  */
  YYSYMBOL_MPU_BASE = 286,                 /* MPU_BASE  */
  YYSYMBOL_MPU_IRQ = 287,                  /* MPU_IRQ  */
  YYSYMBOL_MPU_IRQ_MT32 = 288,             /* MPU_IRQ_MT32  */
  YYSYMBOL_MIDI_SYNTH = 289,               /* MIDI_SYNTH  */
  YYSYMBOL_SOUND_DRIVER = 290,             /* SOUND_DRIVER  */
  YYSYMBOL_MIDI_DRIVER = 291,              /* MIDI_DRIVER  */
  YYSYMBOL_MUNT_ROMS = 292,                /* MUNT_ROMS  */
  YYSYMBOL_SND_PLUGIN_PARAMS = 293,        /* SND_PLUGIN_PARAMS  */
  YYSYMBOL_PCM_HPF = 294,                  /* PCM_HPF  */
  YYSYMBOL_MIDI_FILE = 295,                /* MIDI_FILE  */
  YYSYMBOL_WAV_FILE = 296,                 /* WAV_FILE  */
  YYSYMBOL_CDROM = 297,                    /* CDROM  */
  YYSYMBOL_ASPI = 298,                     /* ASPI  */
  YYSYMBOL_DEVICETYPE = 299,               /* DEVICETYPE  */
  YYSYMBOL_TARGET = 300,                   /* TARGET  */
  YYSYMBOL_FEATURE = 301,                  /* FEATURE  */
  YYSYMBOL_JOYSTICK = 302,                 /* JOYSTICK  */
  YYSYMBOL_JOY_DEVICE = 303,               /* JOY_DEVICE  */
  YYSYMBOL_JOY_DOS_MIN = 304,              /* JOY_DOS_MIN  */
  YYSYMBOL_JOY_DOS_MAX = 305,              /* JOY_DOS_MAX  */
  YYSYMBOL_JOY_GRANULARITY = 306,          /* JOY_GRANULARITY  */
  YYSYMBOL_JOY_LATENCY = 307,              /* JOY_LATENCY  */
  YYSYMBOL_CLI_TIMEOUT = 308,              /* CLI_TIMEOUT  */
  YYSYMBOL_TIMEMODE = 309,                 /* TIMEMODE  */
  YYSYMBOL_UNICODE = 310,                  /* UNICODE  */
  YYSYMBOL_SHIFT_ALT_MAP = 311,            /* SHIFT_ALT_MAP  */
  YYSYMBOL_CTRL_MAP = 312,                 /* CTRL_MAP  */
  YYSYMBOL_CTRL_ALT_MAP = 313,             /* CTRL_ALT_MAP  */
  YYSYMBOL_INTERNAL = 314,                 /* INTERNAL  */
  YYSYMBOL_EXTERNAL = 315,                 /* EXTERNAL  */
  YYSYMBOL_316_ = 316,                     /* ';'  */
  YYSYMBOL_317_ = 317,                     /* '{'  */
  YYSYMBOL_318_ = 318,                     /* '}'  */
  YYSYMBOL_319_ = 319,                     /* '('  */
  YYSYMBOL_320_ = 320,                     /* ')'  */
  YYSYMBOL_321_ = 321,                     /* ','  */
  YYSYMBOL_YYACCEPT = 322,                 /* $accept  */
  YYSYMBOL_lines = 323,                    /* lines  */
  YYSYMBOL_optdelim = 324,                 /* optdelim  */
  YYSYMBOL_line = 325,                     /* line  */
  YYSYMBOL_326_1 = 326,                    /* $@1  */
  YYSYMBOL_327_2 = 327,                    /* $@2  */
  YYSYMBOL_328_3 = 328,                    /* $@3  */
  YYSYMBOL_329_4 = 329,                    /* $@4  */
  YYSYMBOL_330_5 = 330,                    /* $@5  */
  YYSYMBOL_331_6 = 331,                    /* $@6  */
  YYSYMBOL_332_7 = 332,                    /* $@7  */
  YYSYMBOL_333_8 = 333,                    /* $@8  */
  YYSYMBOL_334_9 = 334,                    /* $@9  */
  YYSYMBOL_335_10 = 335,                   /* $@10  */
  YYSYMBOL_336_11 = 336,                   /* $@11  */
  YYSYMBOL_337_12 = 337,                   /* $@12  */
  YYSYMBOL_expression = 338,               /* expression  */
  YYSYMBOL_real_expression = 339,          /* real_expression  */
  YYSYMBOL_typed_expr = 340,               /* typed_expr  */
  YYSYMBOL_int_expr = 341,                 /* int_expr  */
  YYSYMBOL_bool_expr = 342,                /* bool_expr  */
  YYSYMBOL_real_expr = 343,                /* real_expr  */
  YYSYMBOL_variable_content = 344,         /* variable_content  */
  YYSYMBOL_string_unquoted = 345,          /* string_unquoted  */
  YYSYMBOL_string_expr = 346,              /* string_expr  */
  YYSYMBOL_strarglist = 347,               /* strarglist  */
  YYSYMBOL_strarglist_item = 348,          /* strarglist_item  */
  YYSYMBOL_check_user_var_list = 349,      /* check_user_var_list  */
  YYSYMBOL_x_flags = 350,                  /* x_flags  */
  YYSYMBOL_x_flag = 351,                   /* x_flag  */
  YYSYMBOL_sdl_flags = 352,                /* sdl_flags  */
  YYSYMBOL_sdl_flag = 353,                 /* sdl_flag  */
  YYSYMBOL_dexeflags = 354,                /* dexeflags  */
  YYSYMBOL_dexeflag = 355,                 /* dexeflag  */
  YYSYMBOL_sound_flags = 356,              /* sound_flags  */
  YYSYMBOL_sound_flag = 357,               /* sound_flag  */
  YYSYMBOL_joystick_flags = 358,           /* joystick_flags  */
  YYSYMBOL_joystick_flag = 359,            /* joystick_flag  */
  YYSYMBOL_video_flags = 360,              /* video_flags  */
  YYSYMBOL_video_flag = 361,               /* video_flag  */
  YYSYMBOL_term_flags = 362,               /* term_flags  */
  YYSYMBOL_term_flag = 363,                /* term_flag  */
  YYSYMBOL_debug_flags = 364,              /* debug_flags  */
  YYSYMBOL_debug_flag = 365,               /* debug_flag  */
  YYSYMBOL_mouse_flags = 366,              /* mouse_flags  */
  YYSYMBOL_mouse_flag = 367,               /* mouse_flag  */
  YYSYMBOL_keyboard_flags = 368,           /* keyboard_flags  */
  YYSYMBOL_keyboard_flag = 369,            /* keyboard_flag  */
  YYSYMBOL_370_13 = 370,                   /* $@13  */
  YYSYMBOL_keyboard_mods = 371,            /* keyboard_mods  */
  YYSYMBOL_keyboard_mod = 372,             /* keyboard_mod  */
  YYSYMBOL_373_14 = 373,                   /* $@14  */
  YYSYMBOL_374_15 = 374,                   /* $@15  */
  YYSYMBOL_375_16 = 375,                   /* $@16  */
  YYSYMBOL_376_17 = 376,                   /* $@17  */
  YYSYMBOL_377_18 = 377,                   /* $@18  */
  YYSYMBOL_378_19 = 378,                   /* $@19  */
  YYSYMBOL_379_20 = 379,                   /* $@20  */
  YYSYMBOL_keyboard_modvals = 380,         /* keyboard_modvals  */
  YYSYMBOL_keyboard_modval = 381,          /* keyboard_modval  */
  YYSYMBOL_ttylocks_flags = 382,           /* ttylocks_flags  */
  YYSYMBOL_ttylocks_flag = 383,            /* ttylocks_flag  */
  YYSYMBOL_serial_flags = 384,             /* serial_flags  */
  YYSYMBOL_serial_flag = 385,              /* serial_flag  */
  YYSYMBOL_printer_flags = 386,            /* printer_flags  */
  YYSYMBOL_printer_flag = 387,             /* printer_flag  */
  YYSYMBOL_floppy_flags = 388,             /* floppy_flags  */
  YYSYMBOL_floppy_flag = 389,              /* floppy_flag  */
  YYSYMBOL_disk_flags = 390,               /* disk_flags  */
  YYSYMBOL_disk_flag = 391,                /* disk_flag  */
  YYSYMBOL_port_flags = 392,               /* port_flags  */
  YYSYMBOL_port_flag = 393,                /* port_flag  */
  YYSYMBOL_trace_port_flags = 394,         /* trace_port_flags  */
  YYSYMBOL_trace_port_flag = 395,          /* trace_port_flag  */
  YYSYMBOL_sillyint_flags = 396,           /* sillyint_flags  */
  YYSYMBOL_sillyint_flag = 397,            /* sillyint_flag  */
  YYSYMBOL_ems_flags = 398,                /* ems_flags  */
  YYSYMBOL_ems_flag = 399,                 /* ems_flag  */
  YYSYMBOL_hardware_ram_flags = 400,       /* hardware_ram_flags  */
  YYSYMBOL_hardware_ram_flag = 401,        /* hardware_ram_flag  */
  YYSYMBOL_bool = 402,                     /* bool  */
  YYSYMBOL_floppy_bool = 403,              /* floppy_bool  */
  YYSYMBOL_int_bool = 404,                 /* int_bool  */
  YYSYMBOL_irq_bool = 405,                 /* irq_bool  */
  YYSYMBOL_speaker = 406,                  /* speaker  */
  YYSYMBOL_cpuemu = 407,                   /* cpuemu  */
  YYSYMBOL_cpu_vm = 408,                   /* cpu_vm  */
  YYSYMBOL_charset_flags = 409,            /* charset_flags  */
  YYSYMBOL_charset_flag = 410              /* charset_flag  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 224 "parser.y"

#include "lexer.h"

#line 691 "parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  245
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3081

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  322
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  89
/* YYNRULES -- Number of rules.  */
#define YYNRULES  509
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  946

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   563


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     319,   320,    36,    34,   321,    35,     2,    37,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   316,
      27,    26,    28,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   317,     2,   318,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    29,    30,    31,    32,    33,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   355,   355,   356,   357,   360,   361,   364,   366,   367,
     368,   369,   391,   394,   398,   403,   404,   405,   424,   425,
     435,   439,   440,   445,   450,   455,   460,   464,   468,   473,
     483,   492,   497,   512,   522,   532,   538,   544,   556,   560,
     571,   583,   587,   592,   599,   600,   605,   610,   615,   620,
     625,   630,   635,   640,   645,   646,   651,   652,   657,   658,
     666,   667,   668,   669,   670,   671,   672,   687,   686,   690,
     691,   694,   699,   698,   702,   701,   705,   709,   708,   713,
     712,   716,   715,   719,   725,   730,   729,   732,   734,   733,
     738,   737,   741,   754,   766,   765,   769,   770,   771,   772,
     773,   774,   776,   775,   778,   784,   786,   785,   791,   795,
     797,   803,   805,   808,   811,   816,   817,   818,   819,   821,
     823,   825,   829,   831,   833,   837,   841,   853,   856,   857,
     859,   861,   863,   865,   866,   867,   871,   875,   879,   885,
     891,   897,   903,   907,   911,   919,   921,   923,   925,   927,
     929,   931,   933,   935,   937,   939,   940,   941,   942,   943,
     944,   950,   951,   955,   972,   982,   983,   984,   997,  1009,
    1013,  1016,  1017,  1026,  1027,  1040,  1044,  1052,  1053,  1055,
    1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    1066,  1067,  1068,  1069,  1070,  1075,  1080,  1081,  1082,  1083,
    1084,  1085,  1086,  1088,  1089,  1090,  1091,  1095,  1096,  1098,
    1101,  1102,  1105,  1106,  1110,  1122,  1123,  1125,  1126,  1127,
    1128,  1129,  1130,  1131,  1132,  1133,  1134,  1135,  1141,  1142,
    1143,  1144,  1149,  1150,  1152,  1153,  1154,  1155,  1156,  1161,
    1162,  1164,  1165,  1166,  1167,  1168,  1169,  1174,  1175,  1178,
    1181,  1184,  1187,  1188,  1189,  1192,  1193,  1197,  1201,  1212,
    1223,  1224,  1225,  1226,  1227,  1230,  1235,  1236,  1238,  1239,
    1240,  1243,  1252,  1253,  1255,  1256,  1257,  1258,  1259,  1260,
    1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1280,
    1282,  1287,  1288,  1290,  1291,  1292,  1293,  1294,  1300,  1305,
    1310,  1316,  1321,  1326,  1331,  1336,  1341,  1346,  1351,  1353,
    1358,  1359,  1361,  1362,  1362,  1363,  1364,  1365,  1366,  1369,
    1372,  1373,  1376,  1376,  1377,  1377,  1378,  1378,  1379,  1379,
    1380,  1380,  1381,  1381,  1382,  1382,  1385,  1386,  1389,  1390,
    1391,  1392,  1393,  1394,  1395,  1396,  1397,  1398,  1399,  1400,
    1401,  1402,  1403,  1404,  1405,  1414,  1415,  1417,  1418,  1419,
    1420,  1422,  1427,  1428,  1430,  1431,  1443,  1444,  1445,  1446,
    1447,  1448,  1449,  1450,  1451,  1452,  1454,  1459,  1460,  1462,
    1463,  1464,  1465,  1466,  1467,  1469,  1474,  1475,  1477,  1478,
    1479,  1480,  1481,  1482,  1483,  1504,  1510,  1517,  1519,  1522,
    1523,  1525,  1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,
    1534,  1535,  1541,  1547,  1554,  1561,  1568,  1570,  1577,  1579,
    1584,  1585,  1587,  1594,  1600,  1610,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1631,  1634,  1635,  1637,  1639,
    1641,  1643,  1645,  1646,  1649,  1654,  1655,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1667,  1672,  1673,  1675,  1680,
    1685,  1690,  1704,  1708,  1712,  1715,  1720,  1721,  1723,  1729,
    1735,  1742,  1749,  1752,  1757,  1760,  1763,  1771,  1780,  1781,
    1782,  1783,  1785,  1790,  1791,  1792,  1793,  1794,  1795,  1797,
    1800,  1801,  1802,  1803,  1804,  1806,  1809,  1810,  1813,  1814
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "INTEGER", "L_OFF",
  "L_ON", "L_AUTO", "L_YES", "L_NO", "CHIPSET_TYPE", "KEYB_LAYOUT", "REAL",
  "STRING", "VARIABLE", "EXPRTEST", "INTCAST", "REALCAST", "AND_OP",
  "OR_OP", "XOR_OP", "SHR_OP", "SHL_OP", "NOT_OP", "EQ_OP", "GE_OP",
  "LE_OP", "'='", "'<'", "'>'", "NEQ_OP", "STR_EQ_OP", "STR_NEQ_OP",
  "L_AND_OP", "L_OR_OP", "'+'", "'-'", "'*'", "'/'", "UMINUS", "UPLUS",
  "BIT_NOT_OP", "STRLEN", "STRTOL", "STRNCMP", "STRCAT", "STRPBRK",
  "STRSPLIT", "STRCHR", "STRRCHR", "STRSTR", "STRDEL", "STRSPN", "STRCSPN",
  "SHELL", "DEFINED", "DEFINE", "UNDEF", "IFSTATEMENT", "WHILESTATEMENT",
  "FOREACHSTATEMENT", "ENTER_USER_SPACE", "LEAVE_USER_SPACE",
  "CHECKUSERVAR", "DOSBANNER", "FASTFLOPPY", "HOGTHRESH", "SPEAKER",
  "IPXSUPPORT", "IPXNETWORK", "NOVELLHACK", "ETHDEV", "TAPDEV",
  "VDESWITCH", "SLIRPARGS", "VNET", "DEBUG", "MOUSE", "SERIAL", "COM",
  "KEYBOARD", "TERMINAL", "VIDEO", "EMURETRACE", "TIMER", "MATHCO", "CPU",
  "CPUSPEED", "RDTSC", "BOOTDRIVE", "SWAP_BOOTDRIVE", "L_XMS", "L_DPMI",
  "DPMI_LIN_RSV_BASE", "DPMI_LIN_RSV_SIZE", "PM_DOS_API", "NO_NULL_CHECKS",
  "PORTS", "DISK", "DOSMEM", "EXT_MEM", "L_EMS", "UMB_A0", "UMB_B0",
  "UMB_F0", "EMS_SIZE", "EMS_FRAME", "EMS_UMA_PAGES", "EMS_CONV_PAGES",
  "TTYLOCKS", "L_SOUND", "L_SND_OSS", "L_JOYSTICK", "FULL_FILE_LOCKS",
  "DEXE", "ALLOWDISK", "FORCEXDOS", "XDOSONLY", "ABORT", "WARN",
  "L_FLOPPY", "EMUSYS", "L_X", "L_SDL", "DOSEMUMAP", "LOGBUFSIZE",
  "LOGFILESIZE", "MAPPINGDRIVER", "LFN_SUPPORT", "EMULATED", "NATIVE",
  "CPUEMU", "CPU_VM", "VM86", "FULL", "VM86SIM", "FULLSIM", "KVM",
  "RAWKEYBOARD", "PRESTROKE", "KEYTABLE", "SHIFT_MAP", "ALT_MAP",
  "NUMPAD_MAP", "DUMP", "DGRAVE", "DACUTE", "DCIRCUM", "DTILDE", "DBREVE",
  "DABOVED", "DDIARES", "DABOVER", "DDACUTE", "DCEDILLA", "DIOTA",
  "DOGONEK", "DCARON", "NETWORK", "PKTDRIVER", "DIRECTORY", "NAMESTUB",
  "BINARY", "BASE", "IRQ", "DEVICE", "CHARSET", "BAUDRATE", "VIRTUAL",
  "VMODEM", "PSEUDO", "RTSCTS", "LOWLAT", "PCCOM", "MICROSOFT",
  "MS3BUTTON", "LOGITECH", "MMSERIES", "MOUSEMAN", "HITACHI",
  "MOUSESYSTEMS", "BUSMOUSE", "PS2", "IMPS2", "INTERNALDRIVER",
  "EMULATE3BUTTONS", "CLEARDTR", "L_DISPLAY", "L_TITLE",
  "X_TITLE_SHOW_APPNAME", "ICON_NAME", "X_KEYCODE", "X_BLINKRATE",
  "X_SHARECMAP", "X_MITSHM", "X_FONT", "X_FIXED_ASPECT", "X_ASPECT_43",
  "X_LIN_FILT", "X_BILIN_FILT", "X_MODE13FACT", "X_WINSIZE", "X_GAMMA",
  "X_FULLSCREEN", "VGAEMU_MEMSIZE", "VESAMODE", "X_LFB", "X_PM_INTERFACE",
  "X_MGRAB_KEY", "X_BACKGROUND_PAUSE", "SDL_HWREND", "VGA", "MGA", "CGA",
  "EGA", "NONE", "CONSOLE", "GRAPHICS", "CHIPSET", "FULLREST", "PARTREST",
  "MEMSIZE", "VBIOS_SIZE_TOK", "VBIOS_SEG", "VGAEMUBIOS_FILE",
  "VBIOS_FILE", "VBIOS_COPY", "VBIOS_MMAP", "DUALMON", "VBIOS_POST",
  "FORCE_VT_SWITCH", "PCI", "COLOR", "ESCCHAR", "XTERM_TITLE", "IO",
  "PORT", "CONFIG", "READ", "WRITE", "KEYB", "PRINTER", "WARNING",
  "GENERAL", "HARDWARE", "L_IPC", "SOUND", "TRACE", "CLEAR", "LPT",
  "COMMAND", "TIMEOUT", "L_FILE", "L_PARTITION", "WHOLEDISK", "THREEINCH",
  "THREEINCH_720", "THREEINCH_2880", "FIVEINCH", "FIVEINCH_360",
  "READONLY", "LAYOUT", "SECTORS", "CYLINDERS", "TRACKS", "HEADS",
  "OFFSET", "HDIMAGE", "HDTYPE1", "HDTYPE2", "HDTYPE9", "DISKCYL4096",
  "RDONLY", "WRONLY", "RDWR", "ORMASK", "ANDMASK", "RANGE", "FAST", "SLOW",
  "SILLYINT", "USE_SIGIO", "HARDWARE_RAM", "SB_BASE", "SB_IRQ", "SB_DMA",
  "SB_HDMA", "MPU_BASE", "MPU_IRQ", "MPU_IRQ_MT32", "MIDI_SYNTH",
  "SOUND_DRIVER", "MIDI_DRIVER", "MUNT_ROMS", "SND_PLUGIN_PARAMS",
  "PCM_HPF", "MIDI_FILE", "WAV_FILE", "CDROM", "ASPI", "DEVICETYPE",
  "TARGET", "FEATURE", "JOYSTICK", "JOY_DEVICE", "JOY_DOS_MIN",
  "JOY_DOS_MAX", "JOY_GRANULARITY", "JOY_LATENCY", "CLI_TIMEOUT",
  "TIMEMODE", "UNICODE", "SHIFT_ALT_MAP", "CTRL_MAP", "CTRL_ALT_MAP",
  "INTERNAL", "EXTERNAL", "';'", "'{'", "'}'", "'('", "')'", "','",
  "$accept", "lines", "optdelim", "line", "$@1", "$@2", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "expression",
  "real_expression", "typed_expr", "int_expr", "bool_expr", "real_expr",
  "variable_content", "string_unquoted", "string_expr", "strarglist",
  "strarglist_item", "check_user_var_list", "x_flags", "x_flag",
  "sdl_flags", "sdl_flag", "dexeflags", "dexeflag", "sound_flags",
  "sound_flag", "joystick_flags", "joystick_flag", "video_flags",
  "video_flag", "term_flags", "term_flag", "debug_flags", "debug_flag",
  "mouse_flags", "mouse_flag", "keyboard_flags", "keyboard_flag", "$@13",
  "keyboard_mods", "keyboard_mod", "$@14", "$@15", "$@16", "$@17", "$@18",
  "$@19", "$@20", "keyboard_modvals", "keyboard_modval", "ttylocks_flags",
  "ttylocks_flag", "serial_flags", "serial_flag", "printer_flags",
  "printer_flag", "floppy_flags", "floppy_flag", "disk_flags", "disk_flag",
  "port_flags", "port_flag", "trace_port_flags", "trace_port_flag",
  "sillyint_flags", "sillyint_flag", "ems_flags", "ems_flag",
  "hardware_ram_flags", "hardware_ram_flag", "bool", "floppy_bool",
  "int_bool", "irq_bool", "speaker", "cpuemu", "cpu_vm", "charset_flags",
  "charset_flag", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-800)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-324)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2676,  -800,  -800,   -15,  1384,  -296,    14,    14,  -288,    30,
      54,  -800,  -800,    47,  1384,  1384,  1384,    98,  1384,  1384,
    1384,   393,   393,   393,   393,   393,    51,  -800,  -800,  -800,
    -251,  -800,  1384,  1384,  1384,  1741,  1969,  1384,   393,  1384,
    1384,  1384,  1384,  1384,  1384,  -800,  -800,  1384,  1384,  1793,
    1384,  1384,  1384,  -249,  -236,  1855,  1384,  -233,    51,    51,
    -800,    73,  -230,  -209,   393,  1384,  1384,   393,  1384,   400,
     136,   393,    -5,  1384,  -202,  1384,   393,  -800,  1384,    25,
    1384,  -800,  -176,  -170,  -168,  1384,   393,  1409,  -800,    51,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,    44,  -800,  -162,
    -160,  1384,  1384,  1384,  1384,  -156,  -118,  -115,  -110,  -104,
     -96,   -94,   -91,   -89,   -64,   -62,   -61,   -58,   -57,  1384,
    1300,  -800,  -800,  -800,    94,  -800,   109,    51,  -800,  -800,
    -800,  1384,  -114,   -73,  -800,   -56,  -800,  1300,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  1384,   -44,
    -800,   -55,  -800,   -40,   -39,   -23,   108,   -22,  -800,  -800,
    -800,  -800,  -800,   293,  -800,  1300,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,   -11,     6,  -800,  -800,    39,  -800,
    -800,  -800,  -800,   115,   883,   245,  -800,  -800,   -24,   -55,
     -55,     7,   393,  -800,  2394,   116,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,   393,  -800,
    -297,  -800,  -800,    21,  -800,    26,    28,  -800,  -800,    32,
     393,   393,  1384,  -800,  -800,  -800,  -800,  2414,  -800,   -55,
    1384,  1384,   961,  -800,  -800,  -800,   393,   393,   393,    51,
     393,   393,   393,   393,   393,   393,   393,   393,    51,    14,
     147,  1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,
    1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,   393,   393,
    -159,    22,    27,   341,   344,   547,  2779,    51,   428,   468,
      77,  -800,  -800,  1384,  1384,    61,  -800,  2219,  -800,    36,
     940,  -800,  -800,  -800,  1384,  1384,  1384,  1384,  1384,    29,
    -800,  -800,  -800,   393,   393,  -800,   110,  -800,  1384,  1384,
    1384,  1384,  1384,  1384,  1384,   393,   393,   393,   393,   393,
    1384,   393,   393,  1846,  -800,   393,  1384,  1384,  1384,  1384,
     104,  -800,  -800,  -800,  -800,   -71,  -800,   546,    57,   393,
     393,  1384,   393,  1384,  1384,  -800,  1384,   393,  1384,  -800,
    -800,  -800,  1384,  2021,  1384,  1384,  1384,  2073,  1384,  1384,
     393,  1384,  1408,  -800,  1384,  -190,  -800,    52,  -800,   365,
     366,  -112,  -800,   204,    13,    46,    53,    70,    92,   363,
    -800,  -800,   713,   734,    72,    83,    75,  -143,   100,   103,
     111,   112,   113,   117,   120,   121,  -135,    93,  -800,   961,
     961,   961,   961,   961,   119,   119,   119,   119,   119,   119,
      95,    95,   176,   176,  -800,  -800,  -800,  -800,  -800,  -800,
    1384,    74,  -800,  -800,  -800,  -800,  -800,  1384,  1384,  1384,
    1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,
    1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,  1384,
    1384,  1064,  -800,  -800,  -800,  -800,   393,  1384,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,    58,  -800,  -800,  -800,  -800,  1384,  1384,  1384,   393,
    -800,  -800,  -800,  -800,  -800,  -800,    82,  -800,  -800,  -800,
    1384,    90,    81,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,   396,   409,   407,  -800,  -800,
    1384,  1384,  1384,   393,   393,  -800,  -800,  -800,  -800,  -800,
    -800,   278,  -800,  -800,  -800,  -800,   393,  -800,  -800,  -800,
    1384,  1384,  2147,  -800,  -800,  1384,     9,  -800,  -800,  -800,
     393,   393,   393,   393,   413,  -800,  1384,  1384,  1384,  1384,
    1384,   393,  -800,  -800,  -800,  -800,   209,  -800,  -800,  -800,
    -800,  -800,   124,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,   393,   393,   393,
    -800,  -800,  -800,  -800,  -800,  -800,   255,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,   433,
     126,  -800,  -800,  -800,   446,   129,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  1689,  -800,  -800,  -800,  -800,
    -800,  -800,  1384,  1384,   393,  1384,   393,    49,  -800,  -800,
    -800,  -800,  -800,  2199,  1384,    12,  -800,  -800,  -800,  -800,
    2251,  1910,  1384,    76,  -800,  -800,  -800,  -800,  2303,  1384,
      68,  -800,  -800,   393,  1384,  -800,  -800,  -800,  -800,   393,
    -800,   393,  1384,   393,   393,   393,  1384,   393,   393,  -800,
    -800,   131,   393,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,   114,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,   453,   137,
     139,  -800,  -800,  -800,  -800,  -800,   454,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  1384,   460,  1384,  1384,  1384,  1384,  1384,
    1384,  1384,   439,  1538,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,   463,   160,   162,  -800,  -800,   484,   194,  2355,
    -800,   196,  -800,  -800,   523,   207,   210,  -800,  -800,   229,
     213,   215,   220,   222,   221,   225,   239,   241,   240,   243,
    -800,   248,   260,  -800,  1384,  -800,  -800,  -800,  -800,   257,
     559,   560,   562,   563,   564,   565,  -800,  -800,  -800,  -800,
    1384,  -800,  -800,  1384,   590,   274,  -800,  -800,  1384,  -800,
    1384,  -800,  1384,  -800,  1384,  -800,  -800,  -800,  1384,  -800,
    -800,    51,  1689,  -800,  1384,  -800,  -800,  -800,  -800,  -800,
    -800,    43,  -800,  -800,  -800,  1384,  -800,   279,   294,   308,
     309,  -101,  1618,  -800,    43,    43,    43,    43,    43,    43,
    -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  1384,  -800,   277,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,   277,   277,   277,   277,
     277,   277,   313,    43,  -800,  -800
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,   112,   111,     0,     0,     0,     0,     0,     0,     0,
       0,    15,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,    74,    77,    79,
       0,    67,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    85,    88,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      90,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    94,     0,     0,
     102,   106,     0,     0,     0,     0,     0,     0,     2,     0,
     128,   159,   158,   133,   156,   157,   161,   144,   163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      19,   115,   116,   117,   126,   165,     0,     0,   164,     9,
      10,     0,     0,     0,   175,    18,   484,   113,    42,   485,
      28,     8,   492,   488,   491,   490,   489,    66,    57,   486,
      58,    64,   170,    60,    61,    62,    63,    65,     0,     0,
     173,    71,   171,     0,     0,     0,     0,     0,    43,    39,
      56,    30,    29,   128,    33,   114,    35,    37,    38,    49,
      50,    51,    52,    53,     0,     0,    54,    55,     0,    45,
      46,    47,    48,     0,     0,     0,   100,    26,     0,    20,
      21,     0,     0,    22,     0,     0,    24,    40,    41,    25,
      27,   499,   493,   498,   494,   495,   496,   497,    32,   505,
     500,   504,   503,   501,   502,    31,    83,    81,     0,    59,
       0,    36,    69,     0,    98,     0,     0,   487,   104,     0,
       0,     0,     0,   109,   110,     1,     5,     0,     3,    17,
       0,     0,   155,   123,   122,   132,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   271,   270,     0,     0,     0,   266,     0,    34,     0,
       0,   475,   468,   474,     0,     0,     0,     0,     0,     0,
     466,   371,   370,     0,     0,   369,     0,   365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   215,     0,     0,     0,     0,     0,
       0,   232,   212,   213,   214,     0,   210,     0,     0,     0,
       0,     0,     0,     0,     0,   185,   186,     0,     0,   190,
     191,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   177,     0,     0,   207,     0,    84,     0,
       0,     0,   506,     0,     0,     0,     0,     0,     0,     0,
       6,     4,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   127,   129,
     130,   131,   124,   125,   145,   147,   148,   149,   150,   146,
     151,   152,   118,   119,   120,   121,   153,   154,    14,    11,
       0,     0,   176,   174,   300,   275,   299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   272,   172,   319,   318,     0,     0,   308,   309,
     312,   311,   315,   316,   310,   317,   313,   314,   304,   305,
     307,     0,   301,   386,   385,   384,     0,     0,     0,     0,
     375,   377,   376,   378,   379,   380,     0,   372,   329,   328,
       0,     0,     0,   320,   269,   268,    70,   267,   265,   264,
     241,   242,   243,   244,   245,   250,   248,     0,   252,   253,
       0,     0,     0,     0,     0,   256,   257,   261,   260,   262,
     263,     0,   239,   445,   432,   444,     0,   436,   437,   438,
       0,     0,     0,   441,   442,     0,     0,   430,   429,   428,
       0,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,   413,   414,   415,   412,     0,   409,   470,   471,
     472,   473,     0,    44,   467,   367,   368,    76,   366,   217,
     220,   218,   219,   221,   223,   224,   222,   225,   226,   227,
     228,   229,   230,   231,    99,   216,   234,   235,   236,   237,
     238,   101,   233,   105,   211,   408,   407,     0,     0,     0,
     399,   401,   400,   402,   403,   398,     0,   396,    23,   179,
     180,   181,   182,   183,   184,   187,   188,   189,   193,   128,
       0,   196,   197,   198,   128,     0,   203,   204,   205,   206,
      96,   178,   209,    97,   208,     0,   508,   509,     7,   507,
     395,   394,     0,     0,     0,     0,     0,     0,   387,   454,
     448,   453,   452,     0,     0,     0,   446,   465,   457,   464,
       0,     0,     0,     0,   455,   483,   478,   482,     0,     0,
       0,   476,    92,     0,     0,   134,   162,   136,   135,     0,
     166,     0,     0,     0,     0,     0,     0,     0,     0,   169,
     160,     0,     0,   290,   276,   282,   274,   288,   289,   278,
     293,   295,   296,   294,   284,   285,   277,   279,   280,   281,
     283,   286,   287,   291,   292,   297,   298,    73,   273,   303,
     306,    75,   302,   381,   382,   383,   374,    78,   373,   327,
     326,   325,   322,    80,   321,   251,   249,   246,   247,   259,
     258,   255,   254,    68,   240,   443,   439,   440,   128,     0,
       0,    86,   431,   427,   421,   422,   426,   424,   416,   417,
     418,   419,   420,   423,    89,   410,   469,   404,   406,   405,
      91,   397,   194,     0,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   330,   393,   389,   390,   391,   392,
      95,   388,   128,     0,     0,    87,   447,   128,     0,     0,
     459,     0,   103,   456,   128,     0,     0,   107,   477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      12,     0,     0,   434,     0,   433,   425,   195,   200,   201,
       0,     0,     0,     0,     0,     0,   338,    82,   331,   450,
       0,   449,   460,     0,   128,     0,   458,   480,     0,   479,
       0,   108,     0,   138,     0,   139,   140,   141,     0,   142,
     143,     0,     0,   435,     0,   340,   342,   344,   334,   332,
     336,     0,   451,   461,   462,     0,   481,     0,     0,     0,
       0,     0,     0,   202,     0,     0,     0,     0,     0,     0,
     362,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   348,     0,   364,   339,   346,   463,
      93,   137,   167,   168,    13,   324,   341,   343,   345,   335,
     333,   337,     0,     0,   363,   347
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -800,  -800,  -800,   -78,  -800,  -800,  -800,  -800,  -800,  -800,
    -800,  -800,  -800,  -800,  -800,  -800,   -13,  -800,  2786,  -800,
    -800,  -800,   359,    -6,   751,   -51,   337,  -800,  -800,   259,
    -800,   258,  -800,   289,  -800,   302,  -800,   296,  -800,   118,
    -800,   346,  -800,   182,  -800,   163,  -800,   143,  -800,  -225,
    -799,  -800,  -800,  -800,  -800,  -800,  -800,  -800,  -384,  -285,
    -800,   336,  -800,   157,  -800,    -3,  -800,    40,  -800,    96,
    -800,   122,  -800,    -4,  -800,   -10,  -800,   351,  -800,   -16,
     895,  -800,    65,  -800,  -800,  -800,  -800,  -800,   286
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    87,   247,    88,   167,   159,   163,   164,   165,   387,
     184,   185,   201,   233,   236,   239,   136,   174,   137,   121,
     122,   123,   124,   125,   126,   161,   162,   135,   382,   383,
     385,   386,   355,   356,   343,   344,   350,   351,   541,   542,
     305,   306,   471,   472,   491,   492,   512,   513,   842,   803,
     804,   908,   907,   909,   891,   904,   905,   906,   927,   928,
     326,   327,   506,   507,   667,   668,   626,   627,   576,   577,
     556,   557,   675,   676,   683,   684,   319,   320,   690,   691,
     138,   140,   150,   238,   147,   218,   225,   391,   392
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     129,   130,   139,   141,   858,   227,   149,   199,   200,   248,
     543,    89,   544,   669,   669,   670,   670,   389,   390,   384,
     169,   545,   172,   127,   671,   671,   128,   149,   149,   149,
     311,   131,   312,   132,   149,   149,   149,   543,   249,   544,
     311,   313,   312,   352,   353,   354,   910,   677,   545,   678,
     660,   313,   207,   208,   685,   128,   686,   133,   679,   474,
     134,   661,   301,   128,    98,   687,   166,   237,   193,   685,
     475,   686,   149,   302,  -164,  -164,   290,   677,   508,   678,
     687,   194,   508,   493,   198,   128,    98,   204,   679,   509,
     352,   353,   354,   509,   494,   108,   750,   110,   751,   142,
     752,   114,   143,   858,   117,   179,   180,   181,   205,   301,
     144,   321,   186,   187,   189,   230,   321,   108,   291,   110,
     302,   235,   322,   114,  -170,  -170,   117,   322,   653,   284,
     285,   286,   287,   314,   315,   316,   317,   219,   228,   288,
     289,   240,   220,   314,   315,   316,   317,   241,   221,   242,
     243,   282,   283,   284,   285,   286,   287,   250,   495,   251,
     496,   438,   297,   256,   271,   272,   273,   274,   275,   401,
     276,   277,   278,   546,   279,   280,   281,   700,   297,   282,
     283,   284,   285,   286,   287,   709,   297,   911,   912,   913,
     914,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     546,   257,   389,   390,   258,   660,   658,   292,   407,   259,
     558,   662,   286,   287,   510,   260,   661,   416,   510,   934,
     297,   559,   476,   261,   477,   262,   145,   146,   263,   399,
     264,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   497,   498,   499,   613,   293,   500,
     501,   502,   503,   504,   505,   265,   615,   266,   267,   672,
     672,   268,   269,   417,   222,   294,   297,   616,   223,   323,
     324,   325,   224,   296,   323,   324,   325,   298,   299,   518,
     547,   548,   549,   550,   551,   552,   553,   554,   673,   673,
     519,   515,   303,   304,   300,   307,   308,   663,   664,   665,
     666,   578,   579,   580,   581,   582,   309,   547,   548,   549,
     550,   551,   552,   553,   554,   589,   590,   591,   592,   593,
     149,   595,   680,   310,   357,   384,   681,   771,   555,   688,
     815,   674,   674,   607,   608,   609,   610,   511,   393,   303,
     304,   511,   439,   394,   688,   395,   440,   583,   318,   396,
     633,   634,   680,   924,   441,   555,   681,   442,   318,   638,
     640,   641,   925,   643,   645,   682,   662,   810,   560,   655,
     158,   652,   689,   561,   617,   628,   741,   656,   657,   516,
     152,   152,   152,   152,   152,   152,   827,   689,   692,   694,
     202,   693,   697,   712,   822,   682,   699,   152,   594,   753,
     747,   211,   755,   698,   212,   128,    98,   345,   346,   347,
     348,   349,   213,   710,   618,   756,   757,   152,   152,   619,
     152,   701,   611,   152,   702,   777,   152,   711,   587,   474,
     152,  -323,   703,   704,   705,   152,   792,   108,   706,   110,
     475,   707,   708,   114,   786,   152,   117,   793,   152,   794,
     795,   840,   663,   664,   665,   666,   843,   846,   844,   845,
     562,   563,   564,   848,   740,   856,   859,   418,   565,   493,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     494,   860,   861,   743,   744,   745,   152,   862,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   620,
     621,   622,   623,   624,   625,   863,   866,   758,   759,   760,
     936,   937,   938,   939,   940,   941,   867,   784,   868,   870,
     869,   871,   214,   215,   216,   217,   872,   766,   767,   769,
     873,   875,   770,   874,   495,   876,   496,   615,   345,   346,
     347,   348,   349,   778,   779,   780,   781,   782,   616,   877,
     879,   152,   878,   880,   271,   272,   273,   274,   275,   881,
     276,   277,   278,   790,   279,   280,   281,   882,   884,   282,
     283,   284,   285,   286,   287,   885,   886,   152,   887,   888,
     889,   890,   476,   894,   477,   895,   763,   930,   943,   152,
     152,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   931,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   932,   933,
     497,   498,   499,   944,   473,   500,   501,   502,   503,   504,
     505,   651,   802,   654,   614,   605,   612,   152,   152,   805,
     806,   517,   808,   738,   742,   754,   152,   902,   945,   764,
     813,   814,   588,   748,   811,   617,   791,   818,   820,   821,
     584,   816,   785,   823,   828,   825,   826,   659,   772,     0,
       0,   830,   152,   152,     0,     0,     0,     0,     0,   833,
       0,     0,     0,   837,   152,   152,   152,   152,   152,     0,
     152,   152,     0,     0,   152,   618,     0,     0,     0,     0,
     619,     0,     0,     0,     0,     0,     0,     0,   152,   152,
       0,   152,     0,     0,     0,     0,   152,     0,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   152,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
     287,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,   287,   153,   154,   155,   156,   157,   160,     0,     0,
     847,     0,   849,   850,   851,   852,   853,   854,   855,   177,
     802,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     620,   621,   622,   623,   624,   625,   865,     0,     0,   160,
     160,     0,   203,     0,     0,   206,     0,     0,   209,     0,
       0,     0,   226,     0,     0,     0,     0,   232,     0,     0,
     901,   883,     0,     0,     0,   152,     0,   244,     0,     0,
     160,     0,     0,     0,     0,     0,     0,   892,     0,     0,
     893,     0,     0,     0,     0,   896,     0,   897,   152,   898,
       0,   899,     0,     0,     0,   900,     0,   443,     0,   802,
       0,   903,     0,     0,     0,     0,     0,     0,   160,     0,
       0,     0,   929,     0,     0,   926,     0,     0,     0,   802,
       0,     0,   152,   152,     0,     0,     0,     0,   926,   926,
     926,   926,   926,   926,     0,   152,     0,     0,     0,     0,
       0,     0,   942,   148,     0,   151,     0,     0,     0,   152,
     152,   152,   152,     0,     0,     0,     0,   168,     0,   170,
     152,     0,   176,     0,   178,     0,     0,   926,   182,   183,
       0,   558,     0,     0,     0,   190,   191,   192,     0,     0,
     196,   197,   559,   358,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,     0,     0,   229,     0,
     231,     0,     0,   234,     0,     0,   152,   152,   152,   388,
       0,     0,     0,     0,   276,   277,   278,     0,   279,   280,
     281,   397,   398,   282,   283,   284,   285,   286,   287,     0,
       0,     0,     0,     0,     0,     0,     0,   404,   405,   406,
     160,   408,   409,   410,   411,   412,   413,   414,   415,   160,
       0,     0,     0,   152,     0,   152,     0,     0,     0,     0,
       0,     0,     0,   695,     0,     0,     0,     0,     0,   436,
     437,     0,     0,     0,     0,     0,     0,     0,   160,     0,
       0,     0,   152,     0,   696,     0,     0,     0,   152,     0,
     152,     0,   152,   152,   152,   444,   152,   152,   445,     0,
       0,   152,     0,     0,   585,   586,   446,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   596,   597,   598,   599,
     600,     0,   602,   603,     0,     0,   606,     0,     0,   560,
       0,     0,     0,     0,   561,     0,     0,     0,     0,     0,
     629,   630,     0,   632,     0,     0,     0,     0,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   648,     0,     0,     0,     0,     0,     0,     0,     0,
     447,   448,     0,   449,     0,   450,     0,     0,     0,     0,
       0,     0,     0,     0,   451,   452,     0,     0,     0,     0,
       0,   453,     0,     0,   454,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,     0,     0,     0,     0,   455,   456,     0,     0,     0,
       0,   562,   563,   564,     0,     0,     0,     0,   514,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   457,     0,     0,     0,     0,     0,   739,     0,     0,
       0,     0,     0,     0,     0,   601,     0,     0,     0,     0,
     152,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,     0,     0,     0,     0,   631,     0,     0,     0,
       0,   635,     0,   637,     0,     0,     0,     0,     0,     0,
     642,     0,     0,   646,   647,     0,   649,     0,     0,     0,
       0,     0,     0,     0,   761,   762,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   765,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
       0,   773,   774,   775,   776,     0,     0,   271,   272,   273,
     274,   275,   783,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,   287,     0,     0,
       0,     0,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   470,     0,   787,   788,
     789,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   737,     0,     0,     0,     0,    90,    91,    92,
      93,    94,    95,     0,     0,    96,    97,    98,     0,    99,
     100,     0,     0,     0,     0,   749,   101,     0,     0,   245,
       1,     0,     0,     0,     0,   807,     0,   809,   102,   103,
       0,     2,     3,     4,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,     0,
       0,     0,     0,     0,   829,     0,     0,     0,     0,     0,
     831,     0,   832,     0,   834,   835,   836,     0,   838,   839,
       0,     0,     5,   841,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     0,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,     0,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,     0,     0,     0,     0,    53,    54,     0,
      55,    56,    57,     0,     0,     0,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,     0,     0,    69,
      70,    90,    91,    92,    93,    94,    95,    71,    72,    96,
      97,    98,     0,    99,   100,     0,     0,     0,     0,     0,
     101,     0,     0,     0,     0,     0,     0,    73,     0,     0,
       0,     0,   102,   103,    74,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,     0,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,     0,     0,     0,
       0,    90,    91,    92,    93,    94,    95,     0,     0,    96,
      97,    98,   160,    99,   100,     0,     0,     0,     0,    75,
     101,     0,    76,     0,     0,     0,     0,     0,     0,    77,
       0,     0,   102,   103,    78,    79,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,     0,     0,     0,     0,     0,   796,   797,
     798,     0,     0,     0,     0,     0,     0,     0,    80,     0,
      81,     0,    90,    91,    92,    93,    94,    95,     0,     0,
      96,    97,    98,   119,    99,   100,    82,    83,     0,     0,
      84,   101,     0,     0,     0,     0,     0,    85,    86,     0,
       0,     0,     0,   102,   103,   246,   650,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    90,    91,    92,    93,    94,    95,
       0,     0,    96,    97,    98,     0,    99,   100,   796,   797,
     798,     0,     0,   101,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   102,   103,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    90,    91,    92,    93,
      94,    95,     0,     0,    96,    97,    98,     0,    99,   100,
       0,     0,     0,     0,     0,   101,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   102,   103,   796,
     797,   798,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,     0,   799,
     800,   801,     0,     0,     0,     0,   857,   119,    90,    91,
      92,    93,    94,    95,     0,     0,    96,    97,    98,   171,
      99,   100,     0,     0,     0,     0,     0,   101,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   102,
     103,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
       0,     0,     0,    90,    91,    92,    93,    94,    95,     0,
       0,    96,    97,    98,     0,    99,   100,     0,     0,   799,
     800,   801,   101,     0,     0,     0,   935,   119,     0,     0,
       0,     0,     0,     0,   102,   103,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,     0,     0,     0,     0,     0,
       0,     0,   173,    91,    92,    93,    94,    95,     0,     0,
      96,    97,    98,     0,    99,   100,     0,     0,     0,     0,
       0,   101,     0,     0,     0,     0,     0,     0,     0,     0,
     799,   800,   801,   102,   103,     0,     0,     0,   119,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   639,    91,    92,    93,    94,    95,
       0,     0,    96,    97,    98,     0,    99,   100,     0,     0,
       0,     0,     0,   101,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   102,   103,     0,     0,     0,
     119,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   644,    91,    92,    93,
      94,    95,     0,     0,    96,    97,    98,     0,    99,   100,
       0,     0,     0,     0,     0,   101,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   102,   103,     0,
     188,     0,   119,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,     0,     0,     0,     0,     0,     0,
     768,    91,    92,    93,    94,    95,     0,     0,    96,    97,
      98,     0,    99,   100,   604,     0,     0,     0,     0,   101,
       0,     0,   195,     0,   119,     0,     0,     0,     0,     0,
       0,   102,   103,     0,     0,     0,   819,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   812,    91,    92,    93,    94,    95,     0,     0,
      96,    97,    98,     0,    99,   100,     0,     0,     0,     0,
     518,   101,     0,     0,     0,     0,     0,     0,     0,   119,
       0,   519,     0,   102,   103,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   817,    91,    92,    93,    94,    95,
       0,     0,    96,    97,    98,     0,    99,   100,     0,     0,
       0,     0,     0,   101,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   102,   103,     0,   119,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   824,    91,    92,    93,
      94,    95,     0,     0,    96,    97,    98,     0,    99,   100,
       0,     0,     0,     0,     0,   101,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   102,   103,     0,
     119,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   864,    91,
      92,    93,    94,    95,     0,     0,    96,    97,    98,     0,
      99,   100,     0,     0,     0,     0,     0,   101,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   102,
     103,     0,   119,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
       0,     0,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     3,     4,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   119,     5,     0,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,     0,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,     0,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,   119,     0,
       0,     0,    53,    54,     0,    55,    56,    57,     0,     0,
       0,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,     0,     0,    69,    70,     0,     0,     0,     0,
       0,     0,    71,    72,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     119,     0,    73,     0,     0,     0,     0,     0,     0,    74,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   119,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    75,     0,     0,    76,     0,     0,
       0,     0,     0,     0,    77,     0,     0,     0,     0,    78,
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   119,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     3,
       4,     0,     0,    80,     0,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,    83,     0,     0,    84,     0,     0,     0,     0,
       0,     0,    85,    86,     0,     0,     0,     0,     0,     5,
     400,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,     0,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,     0,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
     444,     0,     0,   445,    53,    54,     0,    55,    56,    57,
     120,   446,     0,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,     0,     0,    69,    70,     0,     0,
       0,     0,     0,     0,    71,    72,     0,     0,     0,     0,
       0,     0,   175,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,     0,     0,     0,     0,
       0,    74,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   447,   448,     0,   449,     0,
     450,     0,     0,     0,     0,     0,     0,     0,     0,   451,
     452,     0,     0,     0,     0,     0,   453,     0,     0,   454,
       0,     0,     0,     0,     0,     0,     0,   252,   253,   254,
     255,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     455,   456,     0,     0,     0,   270,    75,     0,     0,    76,
       0,     0,     0,     0,     0,     0,    77,     0,     0,     0,
       0,    78,    79,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   457,     0,     0,     0,
       0,     0,     0,     0,   295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,    83,     0,     0,    84,     0,     0,
       0,     0,     0,     0,    85,    86,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   402,   403,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,     0,     0,     0,     0,     0,
       0,   470
};

static const yytype_int16 yycheck[] =
{
       6,     7,    15,    16,   803,    10,    19,    58,    59,    87,
       1,    26,     3,     1,     1,     3,     3,   314,   315,   209,
      33,    12,    35,   319,    12,    12,    12,    40,    41,    42,
       1,   319,     3,     3,    47,    48,    49,     1,    89,     3,
       1,    12,     3,   114,   115,   116,     3,     1,    12,     3,
       1,    12,    65,    66,     1,    12,     3,     3,    12,     1,
      13,    12,     1,    12,    13,    12,   317,    80,   317,     1,
      12,     3,    85,    12,    30,    31,   127,     1,     1,     3,
      12,   317,     1,     1,   317,    12,    13,   317,    12,    12,
     114,   115,   116,    12,    12,    44,     6,    46,     8,     1,
      10,    50,     4,   902,    53,    40,    41,    42,   317,     1,
      12,     1,    47,    48,    49,   317,     1,    44,   131,    46,
      12,    96,    12,    50,    30,    31,    53,    12,   318,    34,
      35,    36,    37,   104,   105,   106,   107,     1,   143,    30,
      31,   317,     6,   104,   105,   106,   107,   317,    12,   317,
      85,    32,    33,    34,    35,    36,    37,   319,    76,   319,
      78,   320,   321,   319,    17,    18,    19,    20,    21,   247,
      23,    24,    25,   164,    27,    28,    29,   320,   321,    32,
      33,    34,    35,    36,    37,   320,   321,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     164,   319,   314,   315,   319,     1,   318,   321,   259,   319,
       1,   162,    36,    37,   137,   319,    12,   268,   137,   320,
     321,    12,   164,   319,   166,   319,   128,   129,   319,   242,
     319,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   162,   163,   164,   318,   321,   167,
     168,   169,   170,   171,   172,   319,     1,   319,   319,   247,
     247,   319,   319,   269,   128,   321,   321,    12,   132,   159,
     160,   161,   136,   317,   159,   160,   161,   317,   317,     1,
     271,   272,   273,   274,   275,   276,   277,   278,   276,   276,
      12,   304,   231,   232,   317,   317,     3,   248,   249,   250,
     251,   314,   315,   316,   317,   318,   317,   271,   272,   273,
     274,   275,   276,   277,   278,   328,   329,   330,   331,   332,
     333,   334,   276,   317,   317,   209,   280,   318,   319,   276,
     318,   319,   319,   346,   347,   348,   349,   260,   317,   231,
     232,   260,   320,   317,   276,   317,   319,   318,   319,   317,
     363,   364,   276,   310,    13,   319,   280,    13,   319,   372,
     373,   374,   319,   376,   377,   319,   162,   318,   159,   317,
     319,   384,   319,   164,   119,   318,   318,    12,    12,   318,
      21,    22,    23,    24,    25,    26,   318,   319,   318,    26,
     317,   299,   320,   319,   318,   319,   321,    38,   333,   318,
     318,     1,     6,   320,     4,    12,    13,   303,   304,   305,
     306,   307,    12,   320,   159,     6,     9,    58,    59,   164,
      61,   321,   318,    64,   321,    12,    67,   440,   318,     1,
      71,   317,   321,   321,   321,    76,     3,    44,   321,    46,
      12,   321,   321,    50,   320,    86,    53,   321,    89,     3,
     321,   320,   248,   249,   250,   251,     3,     3,   321,   320,
     251,   252,   253,     3,   477,    26,     3,   320,   259,     1,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      12,   321,   320,   496,   497,   498,   127,     3,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   254,
     255,   256,   257,   258,   259,   321,   320,   530,   531,   532,
     904,   905,   906,   907,   908,   909,     3,   318,   321,   300,
     320,   318,   132,   133,   134,   135,   321,   550,   551,   552,
     320,   320,   555,   321,    76,   320,    78,     1,   303,   304,
     305,   306,   307,   566,   567,   568,   569,   570,    12,   320,
     320,   202,   321,   320,    17,    18,    19,    20,    21,   321,
      23,    24,    25,   318,    27,    28,    29,   317,   321,    32,
      33,    34,    35,    36,    37,    26,    26,   228,    26,    26,
      26,    26,   164,     3,   166,   321,   318,   318,   321,   240,
     241,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   320,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   320,   320,
     162,   163,   164,   320,   297,   167,   168,   169,   170,   171,
     172,   382,   655,   385,   355,   343,   350,   288,   289,   662,
     663,   305,   665,   471,   491,   512,   297,   882,   943,   541,
     673,   674,   326,   506,   667,   119,   626,   680,   681,   682,
     319,   675,   576,   683,   690,   688,   689,   391,   556,    -1,
      -1,   694,   323,   324,    -1,    -1,    -1,    -1,    -1,   702,
      -1,    -1,    -1,   706,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,    -1,   345,   159,    -1,    -1,    -1,    -1,
     164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,   360,
      -1,   362,    -1,    -1,    -1,    -1,   367,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,   380,
      27,    28,    29,    -1,    -1,    32,    33,    34,    35,    36,
      37,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    27,    28,    29,    -1,    -1,    32,    33,    34,    35,
      36,    37,    21,    22,    23,    24,    25,    26,    -1,    -1,
     793,    -1,   795,   796,   797,   798,   799,   800,   801,    38,
     803,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     254,   255,   256,   257,   258,   259,   819,    -1,    -1,    58,
      59,    -1,    61,    -1,    -1,    64,    -1,    -1,    67,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,
     881,   844,    -1,    -1,    -1,   476,    -1,    86,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,   860,    -1,    -1,
     863,    -1,    -1,    -1,    -1,   868,    -1,   870,   499,   872,
      -1,   874,    -1,    -1,    -1,   878,    -1,   320,    -1,   882,
      -1,   884,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,
      -1,    -1,   895,    -1,    -1,   891,    -1,    -1,    -1,   902,
      -1,    -1,   533,   534,    -1,    -1,    -1,    -1,   904,   905,
     906,   907,   908,   909,    -1,   546,    -1,    -1,    -1,    -1,
      -1,    -1,   925,    18,    -1,    20,    -1,    -1,    -1,   560,
     561,   562,   563,    -1,    -1,    -1,    -1,    32,    -1,    34,
     571,    -1,    37,    -1,    39,    -1,    -1,   943,    43,    44,
      -1,     1,    -1,    -1,    -1,    50,    51,    52,    -1,    -1,
      55,    56,    12,   202,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    73,    -1,
      75,    -1,    -1,    78,    -1,    -1,   617,   618,   619,   228,
      -1,    -1,    -1,    -1,    23,    24,    25,    -1,    27,    28,
      29,   240,   241,    32,    33,    34,    35,    36,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,    -1,    -1,   664,    -1,   666,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,   288,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,    -1,   693,    -1,   320,    -1,    -1,    -1,   699,    -1,
     701,    -1,   703,   704,   705,     1,   707,   708,     4,    -1,
      -1,   712,    -1,    -1,   323,   324,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,    -1,   345,    -1,    -1,   159,
      -1,    -1,    -1,    -1,   164,    -1,    -1,    -1,    -1,    -1,
     359,   360,    -1,   362,    -1,    -1,    -1,    -1,   367,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    -1,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,   100,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
      -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
      -1,   251,   252,   253,    -1,    -1,    -1,    -1,   303,   259,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,    -1,    -1,
     881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     499,    -1,    -1,    -1,    -1,    -1,   361,    -1,    -1,    -1,
      -1,   366,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,
     375,    -1,    -1,   378,   379,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   533,   534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   560,   561,   562,   563,    -1,    -1,    17,    18,    19,
      20,    21,   571,    23,    24,    25,    -1,    27,    28,    29,
      -1,    -1,    32,    33,    34,    35,    36,    37,    -1,    -1,
      -1,    -1,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   302,    -1,   617,   618,
     619,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   318,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    -1,    -1,   510,    22,    -1,    -1,     0,
       1,    -1,    -1,    -1,    -1,   664,    -1,   666,    34,    35,
      -1,    12,    13,    14,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    -1,   693,    -1,    -1,    -1,    -1,    -1,
     699,    -1,   701,    -1,   703,   704,   705,    -1,   707,   708,
      -1,    -1,    53,   712,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,    -1,    -1,    -1,   108,   109,    -1,
     111,   112,   113,    -1,    -1,    -1,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,    -1,    -1,   130,
     131,     3,     4,     5,     6,     7,     8,   138,   139,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,
      -1,    -1,    34,    35,   165,    -1,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,   881,    15,    16,    -1,    -1,    -1,    -1,   230,
      22,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,   240,
      -1,    -1,    34,    35,   245,   246,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    -1,   140,   141,
     142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,
     281,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,   319,    15,    16,   297,   298,    -1,    -1,
     301,    22,    -1,    -1,    -1,    -1,    -1,   308,   309,    -1,
      -1,    -1,    -1,    34,    35,   316,   318,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,   140,   141,
     142,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,   140,
     141,   142,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,   311,
     312,   313,    -1,    -1,    -1,    -1,   318,   319,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,   128,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,    -1,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,   311,
     312,   313,    22,    -1,    -1,    -1,   318,   319,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,   312,   313,    34,    35,    -1,    -1,    -1,   319,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,
     319,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
     317,    -1,   319,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,    -1,    -1,    11,    12,
      13,    -1,    15,    16,   318,    -1,    -1,    -1,    -1,    22,
      -1,    -1,   317,    -1,   319,    -1,    -1,    -1,    -1,    -1,
      -1,    34,    35,    -1,    -1,    -1,   276,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    -1,    -1,
       1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   319,
      -1,    12,    -1,    34,    35,    -1,    -1,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,     3,     4,     5,     6,     7,     8,
      -1,    -1,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    34,    35,    -1,   319,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,     3,     4,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    -1,
     319,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,     3,     4,
       5,     6,     7,     8,    -1,    -1,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      35,    -1,   319,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   319,    53,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   319,    -1,
      -1,    -1,   108,   109,    -1,   111,   112,   113,    -1,    -1,
      -1,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,    -1,    -1,   130,   131,    -1,    -1,    -1,    -1,
      -1,    -1,   138,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     319,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   230,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,    -1,   245,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   319,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,   279,    -1,   281,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,   298,    -1,    -1,   301,    -1,    -1,    -1,    -1,
      -1,    -1,   308,   309,    -1,    -1,    -1,    -1,    -1,    53,
     316,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    -1,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
       1,    -1,    -1,     4,   108,   109,    -1,   111,   112,   113,
       4,    12,    -1,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,    -1,    -1,   130,   131,    -1,    -1,
      -1,    -1,    -1,    -1,   138,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,
      -1,   165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    77,    -1,    79,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
     104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     121,   122,    -1,    -1,    -1,   119,   230,    -1,    -1,   233,
      -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,
      -1,   245,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,    -1,   281,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   297,   298,    -1,    -1,   301,    -1,    -1,
      -1,    -1,    -1,    -1,   308,   309,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   250,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    12,    13,    14,    53,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   108,   109,   111,   112,   113,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   130,
     131,   138,   139,   158,   165,   230,   233,   240,   245,   246,
     279,   281,   297,   298,   301,   308,   309,   323,   325,    26,
       3,     4,     5,     6,     7,     8,    11,    12,    13,    15,
      16,    22,    34,    35,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,   319,
     340,   341,   342,   343,   344,   345,   346,   319,    12,   345,
     345,   319,     3,     3,    13,   349,   338,   340,   402,   338,
     403,   338,     1,     4,    12,   128,   129,   406,   402,   338,
     404,   402,   344,   346,   346,   346,   346,   346,   319,   327,
     346,   347,   348,   328,   329,   330,   317,   326,   402,   338,
     402,   128,   338,     3,   339,   340,   402,   346,   402,   404,
     404,   404,   402,   402,   332,   333,   404,   404,   317,   404,
     402,   402,   402,   317,   317,   317,   402,   402,   317,   347,
     347,   334,   317,   346,   317,   317,   346,   338,   338,   346,
     402,     1,     4,    12,   132,   133,   134,   135,   407,     1,
       6,    12,   128,   132,   136,   408,   346,    10,   143,   402,
     317,   402,   346,   335,   402,    96,   336,   338,   405,   337,
     317,   317,   317,   404,   346,     0,   316,   324,   325,   347,
     319,   319,   340,   340,   340,   340,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     340,    17,    18,    19,    20,    21,    23,    24,    25,    27,
      28,    29,    32,    33,    34,    35,    36,    37,    30,    31,
     347,   338,   321,   321,   321,   340,   317,   321,   317,   317,
     317,     1,    12,   231,   232,   362,   363,   317,     3,   317,
     317,     1,     3,    12,   104,   105,   106,   107,   319,   398,
     399,     1,    12,   159,   160,   161,   382,   383,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   356,   357,   303,   304,   305,   306,   307,
     358,   359,   114,   115,   116,   354,   355,   317,   346,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   350,   351,   209,   352,   353,   331,   346,   314,
     315,   409,   410,   317,   317,   317,   317,   346,   346,   338,
     316,   325,   340,   340,   346,   346,   346,   347,   346,   346,
     346,   346,   346,   346,   346,   346,   347,   345,   320,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   346,   346,   320,   320,
     319,    13,    13,   320,     1,     4,    12,    76,    77,    79,
      81,    90,    91,    97,   100,   121,   122,   157,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     302,   364,   365,   348,     1,    12,   164,   166,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   366,   367,     1,    12,    76,    78,   162,   163,   164,
     167,   168,   169,   170,   171,   172,   384,   385,     1,    12,
     137,   260,   368,   369,   402,   338,   318,   363,     1,    12,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   360,   361,     1,     3,    12,   164,   271,   272,   273,
     274,   275,   276,   277,   278,   319,   392,   393,     1,    12,
     159,   164,   251,   252,   253,   259,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   390,   391,   338,   338,
     338,   338,   338,   318,   399,   346,   346,   318,   383,   338,
     338,   338,   338,   338,   404,   338,   346,   346,   346,   346,
     346,   402,   346,   346,   318,   357,   346,   338,   338,   338,
     338,   318,   359,   318,   355,     1,    12,   119,   159,   164,
     254,   255,   256,   257,   258,   259,   388,   389,   318,   346,
     346,   402,   346,   338,   338,   402,   346,   402,   338,     3,
     338,   338,   402,   338,     3,   338,   402,   402,   346,   402,
     318,   351,   338,   318,   353,   317,    12,    12,   318,   410,
       1,    12,   162,   248,   249,   250,   251,   386,   387,     1,
       3,    12,   247,   276,   319,   394,   395,     1,     3,    12,
     276,   280,   319,   396,   397,     1,     3,    12,   276,   319,
     400,   401,   318,   299,    26,   320,   320,   320,   320,   321,
     320,   321,   321,   321,   321,   321,   321,   321,   321,   320,
     320,   338,   319,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   402,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   402,   402,   402,   402,   402,   318,   365,   346,
     338,   318,   367,   338,   338,   338,   346,   318,   385,   402,
       6,     8,    10,   318,   369,     6,     6,     9,   338,   338,
     338,   346,   346,   318,   361,   346,   338,   338,     3,   338,
     338,   318,   393,   346,   346,   346,   346,    12,   338,   338,
     338,   338,   338,   346,   318,   391,   320,   346,   346,   346,
     318,   389,     3,   321,     3,   321,   140,   141,   142,   311,
     312,   313,   338,   371,   372,   338,   338,   346,   338,   346,
     318,   387,     3,   338,   338,   318,   395,     3,   338,   276,
     338,   338,   318,   397,     3,   338,   338,   318,   401,   346,
     338,   346,   346,   338,   346,   346,   346,   338,   346,   346,
     320,   346,   370,     3,   321,   320,     3,   338,     3,   338,
     338,   338,   338,   338,   338,   338,    26,   318,   372,     3,
     321,   320,     3,   321,     3,   338,   320,     3,   321,   320,
     300,   318,   321,   320,   321,   320,   320,   320,   321,   320,
     320,   321,   317,   338,   321,    26,    26,    26,    26,    26,
      26,   376,   338,   338,     3,   321,   338,   338,   338,   338,
     338,   347,   371,   338,   377,   378,   379,   374,   373,   375,
       3,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   310,   319,   345,   380,   381,   338,
     318,   320,   320,   320,   320,   318,   380,   380,   380,   380,
     380,   380,   338,   321,   320,   381
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   322,   323,   323,   323,   324,   324,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   326,   325,   325,
     325,   325,   327,   325,   328,   325,   325,   329,   325,   330,
     325,   331,   325,   325,   325,   332,   325,   325,   333,   325,
     334,   325,   325,   325,   335,   325,   325,   325,   325,   325,
     325,   325,   336,   325,   325,   325,   337,   325,   325,   325,
     325,   325,   325,   338,   339,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   341,   341,
     341,   341,   341,   341,   341,   341,   341,   341,   341,   341,
     341,   341,   341,   341,   341,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   343,   343,   344,   345,   346,   346,   346,   346,   346,
     346,   347,   347,   348,   348,   349,   349,   350,   350,   351,
     351,   351,   351,   351,   351,   351,   351,   351,   351,   351,
     351,   351,   351,   351,   351,   351,   351,   351,   351,   351,
     351,   351,   351,   351,   351,   351,   351,   352,   352,   353,
     354,   354,   355,   355,   355,   356,   356,   357,   357,   357,
     357,   357,   357,   357,   357,   357,   357,   357,   357,   357,
     357,   357,   358,   358,   359,   359,   359,   359,   359,   360,
     360,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   362,   362,   363,   363,
     363,   363,   364,   364,   365,   365,   365,   365,   365,   365,
     365,   365,   365,   365,   365,   365,   365,   365,   365,   365,
     365,   365,   365,   365,   365,   365,   365,   365,   365,   365,
     365,   366,   366,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     368,   368,   369,   370,   369,   369,   369,   369,   369,   369,
     371,   371,   373,   372,   374,   372,   375,   372,   376,   372,
     377,   372,   378,   372,   379,   372,   380,   380,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   382,   382,   383,   383,   383,
     383,   383,   384,   384,   385,   385,   385,   385,   385,   385,
     385,   385,   385,   385,   385,   385,   385,   386,   386,   387,
     387,   387,   387,   387,   387,   387,   388,   388,   389,   389,
     389,   389,   389,   389,   389,   389,   389,   389,   389,   390,
     390,   391,   391,   391,   391,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   391,   391,   391,   391,   391,   391,
     392,   392,   393,   393,   393,   393,   393,   393,   393,   393,
     393,   393,   393,   393,   393,   393,   394,   394,   395,   395,
     395,   395,   395,   395,   395,   396,   396,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   398,   398,   399,   399,
     399,   399,   399,   399,   399,   399,   400,   400,   401,   401,
     401,   401,   401,   401,   402,   403,   404,   405,   406,   406,
     406,   406,   406,   407,   407,   407,   407,   407,   407,   407,
     408,   408,   408,   408,   408,   408,   409,   409,   410,   410
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     3,     1,     2,     4,     2,     2,
       2,     4,     6,     9,     4,     1,     1,     3,     2,     2,
       2,     2,     2,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     4,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     0,     5,     2,
       4,     2,     0,     5,     0,     5,     4,     0,     5,     0,
       5,     0,     6,     2,     3,     0,     5,     5,     0,     5,
       0,     5,     4,     8,     0,     5,     4,     4,     2,     4,
       2,     4,     0,     5,     2,     4,     0,     5,     6,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     2,     2,     3,     3,     1,     3,     1,     3,
       3,     3,     2,     1,     4,     4,     4,     8,     6,     6,
       6,     6,     6,     6,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     1,     1,     1,     1,
       4,     1,     4,     1,     1,     1,     4,     8,     8,     4,
       1,     1,     3,     1,     3,     1,     3,     1,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     2,     2,     2,
       1,     1,     1,     2,     3,     4,     2,     2,     2,     3,
       4,     4,     6,     2,     2,     2,     2,     1,     2,     2,
       1,     2,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     2,     1,
       2,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       1,     2,     1,     1,     2,     2,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     1,     1,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     2,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     6,     2,     2,     2,     1,     1,
       1,     2,     0,     5,     0,     5,     0,     5,     0,     4,
       0,     5,     0,     5,     0,     5,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     1,     1,
       1,     2,     1,     3,     3,     4,     1,     1,     1,     2,
       2,     1,     1,     2,     1,     1,     1,     2,     1,     3,
       3,     4,     1,     1,     1,     1,     2,     1,     3,     2,
       3,     4,     4,     5,     1,     1,     1,     2,     1,     3,
       2,     2,     2,     2,     1,     1,     1,     2,     1,     3,
       3,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 7: /* line: CHARSET '{' charset_flags '}'  */
#line 364 "parser.y"
                                              {}
#line 2805 "parser.c"
    break;

  case 8: /* line: HOGTHRESH expression  */
#line 366 "parser.y"
                                        { config.hogthreshold = (yyvsp[0].i_value); }
#line 2811 "parser.c"
    break;

  case 9: /* line: DEFINE string_unquoted  */
#line 367 "parser.y"
                                        { IFCLASS(CL_VAR){ define_config_variable((yyvsp[0].s_value));} free((yyvsp[0].s_value)); }
#line 2817 "parser.c"
    break;

  case 10: /* line: UNDEF string_unquoted  */
#line 368 "parser.y"
                                        { IFCLASS(CL_VAR){ undefine_config_variable((yyvsp[0].s_value));} free((yyvsp[0].s_value)); }
#line 2823 "parser.c"
    break;

  case 11: /* line: IFSTATEMENT '(' expression ')'  */
#line 369 "parser.y"
                                                 {
			/* NOTE:
			 * We _need_ absolutely to return to state stack 0
			 * because we 'backward' modify the input stream for
			 * the parser (in lexer). Hence, _if_ the parser needs
			 * to read one token more than needed, we are lost,
			 * because we can't discard it. So please, don't
			 * play with the grammar without knowing what you do.
			 * The ')' _will_ return to state stack 0, but fiddling
			 * with brackets '()' in the underlaying 'expression'
			 * rules may distroy this.
			 *                          -- Hans 971231
			 */
			tell_lexer_if((yyvsp[-1].i_value));
		}
#line 2843 "parser.c"
    break;

  case 12: /* line: WHILESTATEMENT INTEGER ',' '(' expression ')'  */
#line 391 "parser.y"
                                                                {
			tell_lexer_loop((yyvsp[-4].i_value), (yyvsp[-1].i_value));
		}
#line 2851 "parser.c"
    break;

  case 13: /* line: FOREACHSTATEMENT INTEGER ',' VARIABLE '(' string_expr ',' strarglist ')'  */
#line 394 "parser.y"
                                                                                           {
			tell_lexer_loop((yyvsp[-7].i_value), for_each_handling((yyvsp[-7].i_value),(yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].s_value)));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 2860 "parser.c"
    break;

  case 14: /* line: SHELL '(' strarglist ')'  */
#line 398 "parser.y"
                                           {
			char *s = run_shell((yyvsp[-1].s_value));
			if (s) free(s);
			free((yyvsp[-1].s_value));
		}
#line 2870 "parser.c"
    break;

  case 15: /* line: ENTER_USER_SPACE  */
#line 403 "parser.y"
                                   { enter_user_scope((yyvsp[0].i_value)); }
#line 2876 "parser.c"
    break;

  case 16: /* line: LEAVE_USER_SPACE  */
#line 404 "parser.y"
                                   { leave_user_scope((yyvsp[0].i_value)); }
#line 2882 "parser.c"
    break;

  case 17: /* line: VARIABLE '=' strarglist  */
#line 405 "parser.y"
                                          {
		    if (!parser_version_3_style_used) {
			parser_version_3_style_used = 1;
			define_config_variable(CONFNAME_V3USED);
		    }
		    if ((strpbrk((yyvsp[-2].s_value), "uhc") == (yyvsp[-2].s_value)) && ((yyvsp[-2].s_value)[1] == '_'))
			yyerror("reserved variable %s can't be set\n", (yyvsp[-2].s_value));
		    else {
			if (user_scope_level) {
			    char *s = malloc(strlen((yyvsp[-2].s_value))+sizeof(USERVAR_PREF));
			    strcpy(s, USERVAR_PREF);
			    strcat(s,(yyvsp[-2].s_value));
			    setenv(s, (yyvsp[0].s_value), 1);
			    free(s);
			}
			else IFCLASS(CL_VAR) setenv((yyvsp[-2].s_value), (yyvsp[0].s_value), 1);
		    }
		    free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 2906 "parser.c"
    break;

  case 19: /* line: EXPRTEST typed_expr  */
#line 425 "parser.y"
                                      {
		    if ((yyvsp[0].t_value).type == TYPE_REAL)
			c_printf("CONF TESTING: exprtest real %f\n", (yyvsp[0].t_value).value.r);
		    else
			c_printf("CONF TESTING: exprtest int %d\n", (yyvsp[0].t_value).value.i);
		}
#line 2917 "parser.c"
    break;

  case 20: /* line: ABORT strarglist  */
#line 436 "parser.y"
                    { if ((yyvsp[0].s_value)[0]) fprintf(stderr,"CONF aborted with: %s\n", (yyvsp[0].s_value));
			exit(99);
		    }
#line 2925 "parser.c"
    break;

  case 21: /* line: WARN strarglist  */
#line 439 "parser.y"
                                        { c_printf("CONF: %s\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 2931 "parser.c"
    break;

  case 22: /* line: EMUSYS string_expr  */
#line 441 "parser.y"
                    {
		    free(config.emusys); config.emusys = (yyvsp[0].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[0].s_value));
		    }
#line 2940 "parser.c"
    break;

  case 23: /* line: EMUSYS '{' string_expr '}'  */
#line 446 "parser.y"
                    {
		    free(config.emusys); config.emusys = (yyvsp[-1].s_value);
		    c_printf("CONF: config.emusys = '%s'\n", (yyvsp[-1].s_value));
		    }
#line 2949 "parser.c"
    break;

  case 24: /* line: DOSEMUMAP string_expr  */
#line 451 "parser.y"
                    {
		    DOSEMU_MAP_PATH = (yyvsp[0].s_value);
		    c_printf("CONF: dosemu.map path = '%s'\n", (yyvsp[0].s_value));
		    }
#line 2958 "parser.c"
    break;

  case 25: /* line: MAPPINGDRIVER string_expr  */
#line 456 "parser.y"
                    {
		    free(config.mappingdriver); config.mappingdriver = (yyvsp[0].s_value);
		    c_printf("CONF: mapping driver = '%s'\n", (yyvsp[0].s_value));
		    }
#line 2967 "parser.c"
    break;

  case 26: /* line: FULL_FILE_LOCKS bool  */
#line 461 "parser.y"
                    {
		    config.full_file_locks = ((yyvsp[0].i_value)!=0);
		    }
#line 2975 "parser.c"
    break;

  case 27: /* line: LFN_SUPPORT bool  */
#line 465 "parser.y"
                    {
		    config.lfn = ((yyvsp[0].i_value)!=0);
		    }
#line 2983 "parser.c"
    break;

  case 28: /* line: FASTFLOPPY floppy_bool  */
#line 469 "parser.y"
                        {
			config.fastfloppy = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: fastfloppy = %d\n", config.fastfloppy);
			}
#line 2992 "parser.c"
    break;

  case 29: /* line: CPU expression  */
#line 474 "parser.y"
                        {
			int cpu = cpu_override (((yyvsp[0].i_value)%100)==86?((yyvsp[0].i_value)/100)%10:0);
			if (cpu > 0) {
				c_printf("CONF: CPU set to %d86\n",cpu);
				vm86s.cpu_type = cpu;
			}
			else
				yyerror("error in CPU user override\n");
			}
#line 3006 "parser.c"
    break;

  case 30: /* line: CPU EMULATED  */
#line 484 "parser.y"
                        {
			vm86s.cpu_type = 5;
#ifdef X86_EMULATOR
			config.cpuemu = 1;
			c_printf("CONF: CPUEMU set to %d for %d86\n",
				config.cpuemu, (int)vm86s.cpu_type);
#endif
			}
#line 3019 "parser.c"
    break;

  case 31: /* line: CPU_VM cpu_vm  */
#line 493 "parser.y"
                        {
			config.cpu_vm = (yyvsp[0].i_value);
			c_printf("CONF: CPU VM set to %d\n", config.cpu_vm);
			}
#line 3028 "parser.c"
    break;

  case 32: /* line: CPUEMU cpuemu  */
#line 498 "parser.y"
                        {
#ifdef X86_EMULATOR
			config.cpuemu = (yyvsp[0].i_value);
			if (config.cpuemu > 4) {
				config.cpuemu -= 2;
#ifdef HOST_ARCH_X86
				config.cpusim = 1;
#endif
			}
			c_printf("CONF: %s CPUEMU set to %d for %d86\n",
				CONFIG_CPUSIM ? "simulated" : "JIT",
				config.cpuemu, (int)vm86s.cpu_type);
#endif
			}
#line 3047 "parser.c"
    break;

  case 33: /* line: CPUSPEED real_expression  */
#line 513 "parser.y"
                        { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = ((double)LLF_US)/(yyvsp[0].r_value);
			  config.cpu_tick_spd = ((double)LLF_TICKS)/(yyvsp[0].r_value);
			  c_printf("CONF: CPU speed = %g\n", ((double)(yyvsp[0].r_value)));
			}
#endif
			}
#line 3061 "parser.c"
    break;

  case 34: /* line: CPUSPEED INTEGER INTEGER  */
#line 523 "parser.y"
                        { 
#if 0 /* no longer used, but left in for dosemu.conf compatibility */
			if (config.realcpu >= CPU_586) {
			  config.cpu_spd = (LLF_US*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  config.cpu_tick_spd = (LLF_TICKS*(yyvsp[0].i_value))/(yyvsp[-1].i_value);
			  c_printf("CONF: CPU speed = %d/%d\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
			}
#endif
			}
#line 3075 "parser.c"
    break;

  case 35: /* line: RDTSC bool  */
#line 533 "parser.y"
                    {
			config.rdtsc = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: %sabling use of pentium timer\n",
				(config.rdtsc?"En":"Dis"));
		    }
#line 3085 "parser.c"
    break;

  case 36: /* line: PCI bool  */
#line 539 "parser.y"
                    {
		      config.pci_video = ((yyvsp[0].i_value)!=0);
		      IFCLASS(CL_PCI) {}
		      config.pci = (abs((yyvsp[0].i_value))==2); 
		    }
#line 3095 "parser.c"
    break;

  case 37: /* line: BOOTDRIVE string_expr  */
#line 545 "parser.y"
                    {
                      if ((yyvsp[0].s_value)[0] == 0) {
		        config.hdiskboot = -1;
		      } else if ((yyvsp[0].s_value)[0] >= 'a') {
		        config.hdiskboot = (yyvsp[0].s_value)[0] - 'a';
		      } else {
		        error("wrong value for $_bootdrive\n");
		        config.hdiskboot = 2;
		      }
		      free((yyvsp[0].s_value));
		    }
#line 3111 "parser.c"
    break;

  case 38: /* line: SWAP_BOOTDRIVE bool  */
#line 557 "parser.y"
                    {
		      config.swap_bootdrv = ((yyvsp[0].i_value)!=0);
		    }
#line 3119 "parser.c"
    break;

  case 39: /* line: TIMER expression  */
#line 561 "parser.y"
                    {
		    config.freq = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value)) {
		        config.update = 1000000 / (yyvsp[0].i_value);
		    } else {
			config.update = 54925;
			config.freq = 18;
		    }
		    c_printf("CONF: timer freq=%d, update=%d\n",config.freq,config.update);
		    }
#line 3134 "parser.c"
    break;

  case 40: /* line: LOGBUFSIZE expression  */
#line 572 "parser.y"
                    {
		      char *b;
		      flush_log();
		      b = malloc((yyvsp[0].i_value)+1024);
		      if (!b) {
			error("cannot get logbuffer\n");
			exit(1);
		      }
		      logptr = logbuf = b;
		      logbuf_size = (yyvsp[0].i_value);
		    }
#line 3150 "parser.c"
    break;

  case 41: /* line: LOGFILESIZE expression  */
#line 584 "parser.y"
                    {
		      logfile_limit = (yyvsp[0].i_value);
		    }
#line 3158 "parser.c"
    break;

  case 42: /* line: DOSBANNER bool  */
#line 588 "parser.y"
                    {
		    config.dosbanner = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: dosbanner %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3167 "parser.c"
    break;

  case 43: /* line: EMURETRACE bool  */
#line 593 "parser.y"
                    { IFCLASS(CL_VPORT){
		    if ((yyvsp[0].i_value) && !config.emuretrace && priv_lvl)
		      yyerror("Can not modify video port access in user config file");
		    config.emuretrace = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: emu_retrace %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }}
#line 3178 "parser.c"
    break;

  case 45: /* line: L_EMS int_bool  */
#line 601 "parser.y"
                    {
		    if ((yyvsp[0].i_value) >= 0) config.ems_size = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		    }
#line 3187 "parser.c"
    break;

  case 46: /* line: UMB_A0 bool  */
#line 606 "parser.y"
                    {
		    config.umb_a0 = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0a0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3196 "parser.c"
    break;

  case 47: /* line: UMB_B0 bool  */
#line 611 "parser.y"
                    {
		    config.umb_b0 = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0b0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3205 "parser.c"
    break;

  case 48: /* line: UMB_F0 bool  */
#line 616 "parser.y"
                    {
		    config.umb_f0 = ((yyvsp[0].i_value)!=0);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: umb at 0f0000: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3214 "parser.c"
    break;

  case 49: /* line: L_DPMI int_bool  */
#line 621 "parser.y"
                    {
		    if ((yyvsp[0].i_value)>=0) config.dpmi = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI-Server %s (%#x)\n", ((yyvsp[0].i_value)) ? "on" : "off", ((yyvsp[0].i_value)));
		    }
#line 3223 "parser.c"
    break;

  case 50: /* line: DPMI_LIN_RSV_BASE int_bool  */
#line 626 "parser.y"
                    {
		    config.dpmi_lin_rsv_base = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI linear reserve base addr = %#x\n", (yyvsp[0].i_value));
		    }
#line 3232 "parser.c"
    break;

  case 51: /* line: DPMI_LIN_RSV_SIZE int_bool  */
#line 631 "parser.y"
                    {
		    config.dpmi_lin_rsv_size = (yyvsp[0].i_value);
		    c_printf("CONF: DPMI linear reserve size = %#x\n", (yyvsp[0].i_value));
		    }
#line 3241 "parser.c"
    break;

  case 52: /* line: PM_DOS_API bool  */
#line 636 "parser.y"
                    {
		    config.pm_dos_api = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: PM DOS API Translator %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3250 "parser.c"
    break;

  case 53: /* line: NO_NULL_CHECKS bool  */
#line 641 "parser.y"
                    {
		    config.no_null_checks = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: No DJGPP NULL deref checks: %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3259 "parser.c"
    break;

  case 54: /* line: DOSMEM int_bool  */
#line 645 "parser.y"
                                        { if ((yyvsp[0].i_value)>=0) config.mem_size = (yyvsp[0].i_value); }
#line 3265 "parser.c"
    break;

  case 55: /* line: EXT_MEM int_bool  */
#line 647 "parser.y"
                    {
		    if ((yyvsp[0].i_value)>=0) config.ext_mem = (yyvsp[0].i_value);
		    if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes XMS memory\n", (yyvsp[0].i_value));
		    }
#line 3274 "parser.c"
    break;

  case 56: /* line: MATHCO bool  */
#line 651 "parser.y"
                                        { config.mathco = ((yyvsp[0].i_value)!=0); }
#line 3280 "parser.c"
    break;

  case 57: /* line: IPXSUPPORT bool  */
#line 653 "parser.y"
                    {
		    config.ipxsup = ((yyvsp[0].i_value)!=0);
		    c_printf("CONF: IPX support %s\n", ((yyvsp[0].i_value)) ? "on" : "off");
		    }
#line 3289 "parser.c"
    break;

  case 58: /* line: IPXNETWORK int_bool  */
#line 657 "parser.y"
                                        { config.ipx_net = (yyvsp[0].i_value); }
#line 3295 "parser.c"
    break;

  case 59: /* line: PKTDRIVER bool  */
#line 659 "parser.y"
                    {
		      if (config.vnet == VNET_TYPE_TAP || config.vnet == VNET_TYPE_VDE || (yyvsp[0].i_value) == 0 || is_in_allowed_classes(CL_NET)) {
			config.pktdrv = ((yyvsp[0].i_value)!=0);
			c_printf("CONF: Packet Driver %s.\n", 
				((yyvsp[0].i_value)) ? "enabled" : "disabled");
		      }
		    }
#line 3307 "parser.c"
    break;

  case 60: /* line: ETHDEV string_expr  */
#line 666 "parser.y"
                                        { free(config.ethdev); config.ethdev = (yyvsp[0].s_value); }
#line 3313 "parser.c"
    break;

  case 61: /* line: TAPDEV string_expr  */
#line 667 "parser.y"
                                        { free(config.tapdev); config.tapdev = (yyvsp[0].s_value); }
#line 3319 "parser.c"
    break;

  case 62: /* line: VDESWITCH string_expr  */
#line 668 "parser.y"
                                        { free(config.vdeswitch); config.vdeswitch = (yyvsp[0].s_value); }
#line 3325 "parser.c"
    break;

  case 63: /* line: SLIRPARGS string_expr  */
#line 669 "parser.y"
                                        { free(config.slirp_args); config.slirp_args = (yyvsp[0].s_value); }
#line 3331 "parser.c"
    break;

  case 64: /* line: NOVELLHACK bool  */
#line 670 "parser.y"
                                        { config.pktflags = ((yyvsp[0].i_value)!=0); }
#line 3337 "parser.c"
    break;

  case 65: /* line: VNET string_expr  */
#line 671 "parser.y"
                                        { start_vnet((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3343 "parser.c"
    break;

  case 66: /* line: SPEAKER speaker  */
#line 673 "parser.y"
                    {
		    if ((yyvsp[0].i_value) == SPKR_NATIVE) {
		      if (can_do_root_stuff) {
                        c_printf("CONF: allowing speaker port access!\n");
		      } else {
                        c_printf("CONF: native speaker not allowed: emulate\n");
			(yyvsp[0].i_value) = SPKR_EMULATED;
		      }
		    }
		    else
                      c_printf("CONF: not allowing speaker port access\n");
		    config.speaker = (yyvsp[0].i_value);
		    }
#line 3361 "parser.c"
    break;

  case 67: /* $@1: %empty  */
#line 687 "parser.y"
                    { start_video(); }
#line 3367 "parser.c"
    break;

  case 68: /* line: VIDEO $@1 '{' video_flags '}'  */
#line 689 "parser.y"
                    { stop_video(); }
#line 3373 "parser.c"
    break;

  case 69: /* line: XTERM_TITLE string_expr  */
#line 690 "parser.y"
                                          { free(config.xterm_title); config.xterm_title = (yyvsp[0].s_value); }
#line 3379 "parser.c"
    break;

  case 70: /* line: TERMINAL '{' term_flags '}'  */
#line 693 "parser.y"
                    { stop_terminal(); }
#line 3385 "parser.c"
    break;

  case 71: /* line: DEBUG strarglist  */
#line 694 "parser.y"
                                   {
			parse_debugflags((yyvsp[0].s_value), 1);
			free((yyvsp[0].s_value));
		}
#line 3394 "parser.c"
    break;

  case 72: /* $@2: %empty  */
#line 699 "parser.y"
                    { start_debug(); }
#line 3400 "parser.c"
    break;

  case 74: /* $@3: %empty  */
#line 702 "parser.y"
                    { start_mouse(); }
#line 3406 "parser.c"
    break;

  case 75: /* line: MOUSE $@3 '{' mouse_flags '}'  */
#line 704 "parser.y"
                    { stop_mouse(); }
#line 3412 "parser.c"
    break;

  case 76: /* line: TTYLOCKS '{' ttylocks_flags '}'  */
#line 707 "parser.y"
                    { stop_ttylocks(); }
#line 3418 "parser.c"
    break;

  case 77: /* $@4: %empty  */
#line 709 "parser.y"
                    { start_serial(); }
#line 3424 "parser.c"
    break;

  case 78: /* line: SERIAL $@4 '{' serial_flags '}'  */
#line 711 "parser.y"
                    { stop_serial(); }
#line 3430 "parser.c"
    break;

  case 79: /* $@5: %empty  */
#line 713 "parser.y"
                    { start_keyboard(); }
#line 3436 "parser.c"
    break;

  case 81: /* $@6: %empty  */
#line 716 "parser.y"
                        {keytable_start((yyvsp[0].i_value));}
#line 3442 "parser.c"
    break;

  case 82: /* line: KEYTABLE KEYB_LAYOUT $@6 '{' keyboard_mods '}'  */
#line 718 "parser.y"
                        {keytable_stop();}
#line 3448 "parser.c"
    break;

  case 83: /* line: PRESTROKE string_expr  */
#line 720 "parser.y"
                    {
		    append_pre_strokes((yyvsp[0].s_value));
		    c_printf("CONF: appending pre-strokes '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3458 "parser.c"
    break;

  case 84: /* line: KEYTABLE DUMP string_expr  */
#line 725 "parser.y"
                                            {
			dump_keytables_to_file((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		    }
#line 3467 "parser.c"
    break;

  case 85: /* $@7: %empty  */
#line 730 "parser.y"
                    { IFCLASS(CL_PORT) start_ports(); }
#line 3473 "parser.c"
    break;

  case 88: /* $@8: %empty  */
#line 734 "parser.y"
                    { start_disk(); }
#line 3479 "parser.c"
    break;

  case 89: /* line: DISK $@8 '{' disk_flags '}'  */
#line 736 "parser.y"
                    { stop_disk(DISK); }
#line 3485 "parser.c"
    break;

  case 90: /* $@9: %empty  */
#line 738 "parser.y"
                    { start_floppy(); }
#line 3491 "parser.c"
    break;

  case 91: /* line: L_FLOPPY $@9 '{' floppy_flags '}'  */
#line 740 "parser.y"
                    { stop_disk(L_FLOPPY); }
#line 3497 "parser.c"
    break;

  case 92: /* line: CDROM '{' string_expr '}'  */
#line 742 "parser.y"
                    {
		    static int which = 0;
		    if (which >= 3) {
			c_printf("CONF: too many cdrom drives defined\n");
			free((yyvsp[-1].s_value));
		    }
		    else {
			Path_cdrom[which] = (yyvsp[-1].s_value);
			c_printf("CONF: cdrom MSCD000%d on %s\n", which+1 ,(yyvsp[-1].s_value));
			which++;
		    }
		    }
#line 3514 "parser.c"
    break;

  case 93: /* line: ASPI '{' string_expr DEVICETYPE string_expr TARGET expression '}'  */
#line 755 "parser.y"
                    {
		    char *s = aspi_add_device((yyvsp[-5].s_value), (yyvsp[-3].s_value), (yyvsp[-1].i_value));
		    if (s) {
			c_printf("CONF: aspi available for %s\n", s);
			free(s);
		    }
		    else c_printf("CONF: aspi device %s not available\n", (yyvsp[-5].s_value));
		    free((yyvsp[-5].s_value));
		    free((yyvsp[-3].s_value));
		    }
#line 3529 "parser.c"
    break;

  case 94: /* $@10: %empty  */
#line 766 "parser.y"
                    { start_printer(); }
#line 3535 "parser.c"
    break;

  case 95: /* line: PRINTER $@10 '{' printer_flags '}'  */
#line 768 "parser.y"
                    { stop_printer(); }
#line 3541 "parser.c"
    break;

  case 98: /* line: SOUND bool  */
#line 771 "parser.y"
                                { config.sound = ((yyvsp[0].i_value)!=0); }
#line 3547 "parser.c"
    break;

  case 100: /* line: L_JOYSTICK bool  */
#line 773 "parser.y"
                                  { if (! (yyvsp[0].i_value)) { config.joy_device[0] = config.joy_device[1] = NULL; } }
#line 3553 "parser.c"
    break;

  case 102: /* $@11: %empty  */
#line 776 "parser.y"
                    { IFCLASS(CL_IRQ) config.sillyint=0; }
#line 3559 "parser.c"
    break;

  case 104: /* line: SILLYINT irq_bool  */
#line 779 "parser.y"
                    { IFCLASS(CL_IRQ) if ((yyvsp[0].i_value)) {
		        config.sillyint = 1 << (yyvsp[0].i_value);
		        c_printf("CONF: IRQ %d for irqpassing\n", (yyvsp[0].i_value));
		      }
		    }
#line 3569 "parser.c"
    break;

  case 106: /* $@12: %empty  */
#line 786 "parser.y"
                    { IFCLASS(CL_HARDRAM) {}
		    if (priv_lvl)
		      yyerror("Can not change hardware ram access settings in user config file");
		    }
#line 3578 "parser.c"
    break;

  case 108: /* line: FEATURE '{' expression '=' expression '}'  */
#line 792 "parser.y"
                    {
			handle_features((yyvsp[-3].i_value), (yyvsp[-1].i_value));
		    }
#line 3586 "parser.c"
    break;

  case 109: /* line: CLI_TIMEOUT int_bool  */
#line 796 "parser.y"
                    { config.cli_timeout = (yyvsp[0].i_value); }
#line 3592 "parser.c"
    break;

  case 110: /* line: TIMEMODE string_expr  */
#line 798 "parser.y"
                    {
		    config.timemode = parse_timemode((yyvsp[0].s_value));
		    c_printf("CONF: time mode = '%s'\n", (yyvsp[0].s_value));
		    free((yyvsp[0].s_value));
		    }
#line 3602 "parser.c"
    break;

  case 111: /* line: STRING  */
#line 804 "parser.y"
                    { yyerror("unrecognized command '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 3608 "parser.c"
    break;

  case 113: /* expression: typed_expr  */
#line 808 "parser.y"
                           { (yyval.i_value) = TOF((yyvsp[0].t_value)); }
#line 3614 "parser.c"
    break;

  case 114: /* real_expression: typed_expr  */
#line 811 "parser.y"
                           { (yyval.r_value) = TOF((yyvsp[0].t_value)); }
#line 3620 "parser.c"
    break;

  case 115: /* typed_expr: int_expr  */
#line 816 "parser.y"
                           {(yyval.t_value).type = TYPE_INTEGER; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 3626 "parser.c"
    break;

  case 116: /* typed_expr: bool_expr  */
#line 817 "parser.y"
                            {(yyval.t_value).type = TYPE_BOOLEAN; (yyval.t_value).value.i=(yyvsp[0].i_value);}
#line 3632 "parser.c"
    break;

  case 117: /* typed_expr: real_expr  */
#line 818 "parser.y"
                            {(yyval.t_value).type = TYPE_REAL; (yyval.t_value).value.r=(yyvsp[0].r_value);}
#line 3638 "parser.c"
    break;

  case 118: /* typed_expr: typed_expr '+' typed_expr  */
#line 820 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) + TOF((yyvsp[0].t_value))); }
#line 3644 "parser.c"
    break;

  case 119: /* typed_expr: typed_expr '-' typed_expr  */
#line 822 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) - TOF((yyvsp[0].t_value))); }
#line 3650 "parser.c"
    break;

  case 120: /* typed_expr: typed_expr '*' typed_expr  */
#line 824 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) * TOF((yyvsp[0].t_value))); }
#line 3656 "parser.c"
    break;

  case 121: /* typed_expr: typed_expr '/' typed_expr  */
#line 825 "parser.y"
                                            {
			if (TOF((yyvsp[0].t_value)))	V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[-2].t_value)) / TOF((yyvsp[0].t_value)));
			else V_VAL((yyval.t_value),(yyvsp[-2].t_value),TOF((yyvsp[0].t_value)));
		}
#line 3665 "parser.c"
    break;

  case 122: /* typed_expr: '-' typed_expr  */
#line 830 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[0].t_value),-TOF((yyvsp[0].t_value))); }
#line 3671 "parser.c"
    break;

  case 123: /* typed_expr: '+' typed_expr  */
#line 832 "parser.y"
                        {V_VAL((yyval.t_value),(yyvsp[0].t_value),TOF((yyvsp[0].t_value))); }
#line 3677 "parser.c"
    break;

  case 124: /* typed_expr: typed_expr SHR_OP typed_expr  */
#line 834 "parser.y"
                        { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) / shift);}
#line 3685 "parser.c"
    break;

  case 125: /* typed_expr: typed_expr SHL_OP typed_expr  */
#line 838 "parser.y"
                        { unsigned int shift = (1 << (int)TOF((yyvsp[0].t_value)));
			if (!shift) (yyval.t_value) = (yyvsp[-2].t_value);
			else V_VAL((yyval.t_value), (yyvsp[-2].t_value), TOF((yyvsp[-2].t_value)) * shift);}
#line 3693 "parser.c"
    break;

  case 126: /* typed_expr: variable_content  */
#line 841 "parser.y"
                                   {
			char *s;
			(yyval.t_value).type = TYPE_INTEGER;
			(yyval.t_value).value.i = strtoul((yyvsp[0].s_value),&s,0);
			switch (*s) {
				case '.':  case 'e':  case 'E':
				/* we assume a real number */
				(yyval.t_value).type = TYPE_REAL;
				(yyval.t_value).value.r = strtod((yyvsp[0].s_value),0);
			}
			free((yyvsp[0].s_value));
		}
#line 3710 "parser.c"
    break;

  case 127: /* typed_expr: '(' typed_expr ')'  */
#line 853 "parser.y"
                                     {(yyval.t_value) = (yyvsp[-1].t_value);}
#line 3716 "parser.c"
    break;

  case 129: /* int_expr: typed_expr AND_OP typed_expr  */
#line 858 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) & (int)TOF((yyvsp[0].t_value)); }
#line 3722 "parser.c"
    break;

  case 130: /* int_expr: typed_expr OR_OP typed_expr  */
#line 860 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) | (int)TOF((yyvsp[0].t_value)); }
#line 3728 "parser.c"
    break;

  case 131: /* int_expr: typed_expr XOR_OP typed_expr  */
#line 862 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[-2].t_value)) ^ (int)TOF((yyvsp[0].t_value)); }
#line 3734 "parser.c"
    break;

  case 132: /* int_expr: BIT_NOT_OP typed_expr  */
#line 864 "parser.y"
                        {(yyval.i_value) = (int)TOF((yyvsp[0].t_value)) ^ (-1); }
#line 3740 "parser.c"
    break;

  case 133: /* int_expr: L_AUTO  */
#line 865 "parser.y"
                                {(yyval.i_value) = -1; }
#line 3746 "parser.c"
    break;

  case 134: /* int_expr: INTCAST '(' typed_expr ')'  */
#line 866 "parser.y"
                                             {(yyval.i_value) = TOF((yyvsp[-1].t_value));}
#line 3752 "parser.c"
    break;

  case 135: /* int_expr: STRTOL '(' string_expr ')'  */
#line 867 "parser.y"
                                             {
			(yyval.i_value) = strtol((yyvsp[-1].s_value),0,0);
			free((yyvsp[-1].s_value));
		}
#line 3761 "parser.c"
    break;

  case 136: /* int_expr: STRLEN '(' string_expr ')'  */
#line 871 "parser.y"
                                             {
			(yyval.i_value) = strlen((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 3770 "parser.c"
    break;

  case 137: /* int_expr: STRNCMP '(' string_expr ',' string_expr ',' expression ')'  */
#line 875 "parser.y"
                                                                             {
			(yyval.i_value) = strncmp((yyvsp[-5].s_value),(yyvsp[-3].s_value),(yyvsp[-1].i_value));
			free((yyvsp[-5].s_value)); free((yyvsp[-3].s_value));
		}
#line 3779 "parser.c"
    break;

  case 138: /* int_expr: STRPBRK '(' string_expr ',' string_expr ')'  */
#line 879 "parser.y"
                                                              {
			char *s = strpbrk((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3790 "parser.c"
    break;

  case 139: /* int_expr: STRCHR '(' string_expr ',' string_expr ')'  */
#line 885 "parser.y"
                                                             {
			char *s = strchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3801 "parser.c"
    break;

  case 140: /* int_expr: STRRCHR '(' string_expr ',' string_expr ')'  */
#line 891 "parser.y"
                                                              {
			char *s = strrchr((yyvsp[-3].s_value),(yyvsp[-1].s_value)[0]);
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3812 "parser.c"
    break;

  case 141: /* int_expr: STRSTR '(' string_expr ',' string_expr ')'  */
#line 897 "parser.y"
                                                             {
			char *s = strstr((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			if (s) (yyval.i_value) = s - (yyvsp[-3].s_value);
			else (yyval.i_value) = -1;
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3823 "parser.c"
    break;

  case 142: /* int_expr: STRSPN '(' string_expr ',' string_expr ')'  */
#line 903 "parser.y"
                                                             {
			(yyval.i_value) = strspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3832 "parser.c"
    break;

  case 143: /* int_expr: STRCSPN '(' string_expr ',' string_expr ')'  */
#line 907 "parser.y"
                                                              {
			(yyval.i_value) = strcspn((yyvsp[-3].s_value),(yyvsp[-1].s_value));
			free((yyvsp[-3].s_value)); free((yyvsp[-1].s_value));
		}
#line 3841 "parser.c"
    break;

  case 144: /* int_expr: STRING  */
#line 911 "parser.y"
                         {
			if ( (yyvsp[0].s_value)[0] == '\'' && (yyvsp[0].s_value)[1] && (yyvsp[0].s_value)[2] == '\'' && !(yyvsp[0].s_value)[3] )
				(yyval.i_value) = (yyvsp[0].s_value)[1];
			else	yyerror("unrecognized expression '%s'", (yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 3852 "parser.c"
    break;

  case 145: /* bool_expr: typed_expr EQ_OP typed_expr  */
#line 920 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) == TOF((yyvsp[0].t_value)); }
#line 3858 "parser.c"
    break;

  case 146: /* bool_expr: typed_expr NEQ_OP typed_expr  */
#line 922 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) != TOF((yyvsp[0].t_value)); }
#line 3864 "parser.c"
    break;

  case 147: /* bool_expr: typed_expr GE_OP typed_expr  */
#line 924 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) >= TOF((yyvsp[0].t_value)); }
#line 3870 "parser.c"
    break;

  case 148: /* bool_expr: typed_expr LE_OP typed_expr  */
#line 926 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) <= TOF((yyvsp[0].t_value)); }
#line 3876 "parser.c"
    break;

  case 149: /* bool_expr: typed_expr '<' typed_expr  */
#line 928 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) < TOF((yyvsp[0].t_value)); }
#line 3882 "parser.c"
    break;

  case 150: /* bool_expr: typed_expr '>' typed_expr  */
#line 930 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) > TOF((yyvsp[0].t_value)); }
#line 3888 "parser.c"
    break;

  case 151: /* bool_expr: typed_expr L_AND_OP typed_expr  */
#line 932 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) && TOF((yyvsp[0].t_value)); }
#line 3894 "parser.c"
    break;

  case 152: /* bool_expr: typed_expr L_OR_OP typed_expr  */
#line 934 "parser.y"
                        {(yyval.i_value) = TOF((yyvsp[-2].t_value)) || TOF((yyvsp[0].t_value)); }
#line 3900 "parser.c"
    break;

  case 153: /* bool_expr: string_expr STR_EQ_OP string_expr  */
#line 936 "parser.y"
                        {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) == 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 3906 "parser.c"
    break;

  case 154: /* bool_expr: string_expr STR_NEQ_OP string_expr  */
#line 938 "parser.y"
                        {(yyval.i_value) = strcmp((yyvsp[-2].s_value),(yyvsp[0].s_value)) != 0; free((yyvsp[-2].s_value)); free((yyvsp[0].s_value)); }
#line 3912 "parser.c"
    break;

  case 155: /* bool_expr: NOT_OP typed_expr  */
#line 939 "parser.y"
                                    {(yyval.i_value) = (TOF((yyvsp[0].t_value)) ? 0:1); }
#line 3918 "parser.c"
    break;

  case 156: /* bool_expr: L_YES  */
#line 940 "parser.y"
                                {(yyval.i_value) = -2; }
#line 3924 "parser.c"
    break;

  case 157: /* bool_expr: L_NO  */
#line 941 "parser.y"
                                {(yyval.i_value) = 0; }
#line 3930 "parser.c"
    break;

  case 158: /* bool_expr: L_ON  */
#line 942 "parser.y"
                                {(yyval.i_value) = -2; }
#line 3936 "parser.c"
    break;

  case 159: /* bool_expr: L_OFF  */
#line 943 "parser.y"
                                {(yyval.i_value) = 0; }
#line 3942 "parser.c"
    break;

  case 160: /* bool_expr: DEFINED '(' string_unquoted ')'  */
#line 944 "parser.y"
                                                  {
			(yyval.i_value) = get_config_variable((yyvsp[-1].s_value)) !=0;
			free((yyvsp[-1].s_value));
		}
#line 3951 "parser.c"
    break;

  case 162: /* real_expr: REALCAST '(' typed_expr ')'  */
#line 951 "parser.y"
                                              {(yyval.r_value) = TOF((yyvsp[-1].t_value));}
#line 3957 "parser.c"
    break;

  case 163: /* variable_content: VARIABLE  */
#line 955 "parser.y"
                         {
			char *s = (yyvsp[0].s_value);
			if (get_config_variable(s))
				s = "1";
			else if (strncmp("c_",s,2)
					&& strncmp("u_",s,2)
					&& strncmp("h_",s,2) ) {
				s = checked_getenv(s);
				if (!s) s = "";
			}
			else
				s = "0";
			(yyval.s_value) = strdup(s);
			free((yyvsp[0].s_value));
		}
#line 3977 "parser.c"
    break;

  case 164: /* string_unquoted: STRING  */
#line 972 "parser.y"
                       {
			(yyval.s_value) = (yyvsp[0].s_value);
			if ((yyval.s_value)[0] == '\'' || (yyval.s_value)[0] == '\"') {
				size_t len = strlen((yyvsp[0].s_value)) - 2;
				memmove((yyval.s_value), (yyval.s_value)+1, len);
				(yyval.s_value)[len] = '\0';
			}
		}
#line 3990 "parser.c"
    break;

  case 166: /* string_expr: STRCAT '(' strarglist ')'  */
#line 983 "parser.y"
                                            {(yyval.s_value) = (yyvsp[-1].s_value); }
#line 3996 "parser.c"
    break;

  case 167: /* string_expr: STRSPLIT '(' string_expr ',' expression ',' expression ')'  */
#line 984 "parser.y"
                                                                             {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) len = slen - i;
				(yyvsp[-5].s_value)[i+len] = 0;
				(yyval.s_value) = strdup((yyvsp[-5].s_value) + i);
			}
			else
				(yyval.s_value) = strdup("");
			free((yyvsp[-5].s_value));
		}
#line 4014 "parser.c"
    break;

  case 168: /* string_expr: STRDEL '(' string_expr ',' expression ',' expression ')'  */
#line 997 "parser.y"
                                                                           {
			int i = (yyvsp[-3].i_value);
			int len = (yyvsp[-1].i_value);
			int slen = strlen((yyvsp[-5].s_value));
			char *s = strdup((yyvsp[-5].s_value));
			if ((i >=0) && (i < slen) && (len > 0)) {
				if ((i+len) > slen) s[i] = 0;
				else memmove(s+i, s+i+len, slen-i-len+1);
			}
			free((yyvsp[-5].s_value));
			(yyval.s_value) = s;
		}
#line 4031 "parser.c"
    break;

  case 169: /* string_expr: SHELL '(' strarglist ')'  */
#line 1009 "parser.y"
                                           {
			(yyval.s_value) = run_shell((yyvsp[-1].s_value));
			free((yyvsp[-1].s_value));
		}
#line 4040 "parser.c"
    break;

  case 170: /* string_expr: variable_content  */
#line 1013 "parser.y"
                                   {(yyval.s_value) = (yyvsp[0].s_value);}
#line 4046 "parser.c"
    break;

  case 172: /* strarglist: strarglist ',' strarglist_item  */
#line 1017 "parser.y"
                                                 {
			char *s = malloc(strlen((yyvsp[-2].s_value))+strlen((yyvsp[0].s_value))+1);
			strcpy(s, (yyvsp[-2].s_value));
			strcat(s, (yyvsp[0].s_value));
			(yyval.s_value) = s;
			free((yyvsp[-2].s_value)); free((yyvsp[0].s_value));
		}
#line 4058 "parser.c"
    break;

  case 174: /* strarglist_item: '(' typed_expr ')'  */
#line 1027 "parser.y"
                                     {
			int ret;
			if ((yyvsp[-1].t_value).type == TYPE_REAL) {
				ret = asprintf(&(yyval.s_value), "%g", (yyvsp[-1].t_value).value.r);
				assert(ret != -1);
			} else {
				ret = asprintf(&(yyval.s_value), "%d", (yyvsp[-1].t_value).value.i);
				assert(ret != -1);
			}
		}
#line 4073 "parser.c"
    break;

  case 175: /* check_user_var_list: VARIABLE  */
#line 1040 "parser.y"
                         {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4082 "parser.c"
    break;

  case 176: /* check_user_var_list: check_user_var_list ',' VARIABLE  */
#line 1044 "parser.y"
                                                   {
			check_user_var((yyvsp[0].s_value));
			free((yyvsp[0].s_value));
		}
#line 4091 "parser.c"
    break;

  case 179: /* x_flag: L_DISPLAY string_expr  */
#line 1055 "parser.y"
                                        { free(config.X_display); config.X_display = (yyvsp[0].s_value); }
#line 4097 "parser.c"
    break;

  case 180: /* x_flag: L_TITLE string_expr  */
#line 1056 "parser.y"
                                        { free(config.X_title); config.X_title = (yyvsp[0].s_value); }
#line 4103 "parser.c"
    break;

  case 181: /* x_flag: X_TITLE_SHOW_APPNAME bool  */
#line 1057 "parser.y"
                                                { config.X_title_show_appname = ((yyvsp[0].i_value)!=0); }
#line 4109 "parser.c"
    break;

  case 182: /* x_flag: ICON_NAME string_expr  */
#line 1058 "parser.y"
                                        { free(config.X_icon_name); config.X_icon_name = (yyvsp[0].s_value); }
#line 4115 "parser.c"
    break;

  case 183: /* x_flag: X_KEYCODE expression  */
#line 1059 "parser.y"
                                        { config.X_keycode = (yyvsp[0].i_value); }
#line 4121 "parser.c"
    break;

  case 184: /* x_flag: X_BLINKRATE expression  */
#line 1060 "parser.y"
                                                { config.X_blinkrate = (yyvsp[0].i_value); }
#line 4127 "parser.c"
    break;

  case 185: /* x_flag: X_SHARECMAP  */
#line 1061 "parser.y"
                                        { config.X_sharecmap = 1; }
#line 4133 "parser.c"
    break;

  case 186: /* x_flag: X_MITSHM  */
#line 1062 "parser.y"
                                        { config.X_mitshm = 1; }
#line 4139 "parser.c"
    break;

  case 187: /* x_flag: X_MITSHM bool  */
#line 1063 "parser.y"
                                        { config.X_mitshm = ((yyvsp[0].i_value)!=0); }
#line 4145 "parser.c"
    break;

  case 188: /* x_flag: X_FONT string_expr  */
#line 1064 "parser.y"
                                                { free(config.X_font); config.X_font = (yyvsp[0].s_value); }
#line 4151 "parser.c"
    break;

  case 189: /* x_flag: X_FIXED_ASPECT bool  */
#line 1065 "parser.y"
                                        { config.X_fixed_aspect = ((yyvsp[0].i_value)!=0); }
#line 4157 "parser.c"
    break;

  case 190: /* x_flag: X_ASPECT_43  */
#line 1066 "parser.y"
                                        { config.X_aspect_43 = 1; }
#line 4163 "parser.c"
    break;

  case 191: /* x_flag: X_LIN_FILT  */
#line 1067 "parser.y"
                                        { config.X_lin_filt = 1; }
#line 4169 "parser.c"
    break;

  case 192: /* x_flag: X_BILIN_FILT  */
#line 1068 "parser.y"
                                        { config.X_bilin_filt = 1; }
#line 4175 "parser.c"
    break;

  case 193: /* x_flag: X_MODE13FACT expression  */
#line 1069 "parser.y"
                                           { config.X_mode13fact = (yyvsp[0].i_value); }
#line 4181 "parser.c"
    break;

  case 194: /* x_flag: X_WINSIZE INTEGER INTEGER  */
#line 1071 "parser.y"
                   {
                     config.X_winsize_x = (yyvsp[-1].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4190 "parser.c"
    break;

  case 195: /* x_flag: X_WINSIZE expression ',' expression  */
#line 1076 "parser.y"
                   {
                     config.X_winsize_x = (yyvsp[-2].i_value);
                     config.X_winsize_y = (yyvsp[0].i_value);
                   }
#line 4199 "parser.c"
    break;

  case 196: /* x_flag: X_GAMMA expression  */
#line 1080 "parser.y"
                                      { config.X_gamma = (yyvsp[0].i_value); }
#line 4205 "parser.c"
    break;

  case 197: /* x_flag: X_FULLSCREEN bool  */
#line 1081 "parser.y"
                                      { config.X_fullscreen = (yyvsp[0].i_value); }
#line 4211 "parser.c"
    break;

  case 198: /* x_flag: VGAEMU_MEMSIZE expression  */
#line 1082 "parser.y"
                                                { config.vgaemu_memsize = (yyvsp[0].i_value); }
#line 4217 "parser.c"
    break;

  case 199: /* x_flag: VESAMODE INTEGER INTEGER  */
#line 1083 "parser.y"
                                           { set_vesamodes((yyvsp[-1].i_value),(yyvsp[0].i_value),0);}
#line 4223 "parser.c"
    break;

  case 200: /* x_flag: VESAMODE INTEGER INTEGER INTEGER  */
#line 1084 "parser.y"
                                                   { set_vesamodes((yyvsp[-2].i_value),(yyvsp[-1].i_value),(yyvsp[0].i_value));}
#line 4229 "parser.c"
    break;

  case 201: /* x_flag: VESAMODE expression ',' expression  */
#line 1085 "parser.y"
                                                     { set_vesamodes((yyvsp[-2].i_value),(yyvsp[0].i_value),0);}
#line 4235 "parser.c"
    break;

  case 202: /* x_flag: VESAMODE expression ',' expression ',' expression  */
#line 1087 "parser.y"
                        { set_vesamodes((yyvsp[-4].i_value),(yyvsp[-2].i_value),(yyvsp[0].i_value));}
#line 4241 "parser.c"
    break;

  case 203: /* x_flag: X_LFB bool  */
#line 1088 "parser.y"
                                        { config.X_lfb = ((yyvsp[0].i_value)!=0); }
#line 4247 "parser.c"
    break;

  case 204: /* x_flag: X_PM_INTERFACE bool  */
#line 1089 "parser.y"
                                        { config.X_pm_interface = ((yyvsp[0].i_value)!=0); }
#line 4253 "parser.c"
    break;

  case 205: /* x_flag: X_MGRAB_KEY string_expr  */
#line 1090 "parser.y"
                                          { free(config.X_mgrab_key); config.X_mgrab_key = (yyvsp[0].s_value); }
#line 4259 "parser.c"
    break;

  case 206: /* x_flag: X_BACKGROUND_PAUSE bool  */
#line 1091 "parser.y"
                                                { config.X_background_pause = ((yyvsp[0].i_value)!=0); }
#line 4265 "parser.c"
    break;

  case 209: /* sdl_flag: SDL_HWREND expression  */
#line 1098 "parser.y"
                                        { config.sdl_hwrend = ((yyvsp[0].i_value)!=0); }
#line 4271 "parser.c"
    break;

  case 212: /* dexeflag: ALLOWDISK  */
#line 1105 "parser.y"
                                { if (!priv_lvl) dexe_forbid_disk = 0; }
#line 4277 "parser.c"
    break;

  case 213: /* dexeflag: FORCEXDOS  */
#line 1106 "parser.y"
                                {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
		}
#line 4286 "parser.c"
    break;

  case 214: /* dexeflag: XDOSONLY  */
#line 1110 "parser.y"
                                {
			char *env = getenv("DISPLAY");
			if (env && env[0] && dexe_running) config.X = 1;
			else if (dexe_running) {
			  yyerror("this DEXE requires X, giving up");
			  exit(99);
			}
		}
#line 4299 "parser.c"
    break;

  case 217: /* sound_flag: SB_BASE expression  */
#line 1125 "parser.y"
                                        { config.sb_base = (yyvsp[0].i_value); }
#line 4305 "parser.c"
    break;

  case 218: /* sound_flag: SB_DMA expression  */
#line 1126 "parser.y"
                                        { config.sb_dma = (yyvsp[0].i_value); }
#line 4311 "parser.c"
    break;

  case 219: /* sound_flag: SB_HDMA expression  */
#line 1127 "parser.y"
                                     { config.sb_hdma = (yyvsp[0].i_value); }
#line 4317 "parser.c"
    break;

  case 220: /* sound_flag: SB_IRQ expression  */
#line 1128 "parser.y"
                                        { config.sb_irq = (yyvsp[0].i_value); }
#line 4323 "parser.c"
    break;

  case 221: /* sound_flag: MPU_BASE expression  */
#line 1129 "parser.y"
                                        { config.mpu401_base = (yyvsp[0].i_value); }
#line 4329 "parser.c"
    break;

  case 222: /* sound_flag: MIDI_SYNTH string_expr  */
#line 1130 "parser.y"
                                                { free(config.midi_synth); config.midi_synth = (yyvsp[0].s_value); }
#line 4335 "parser.c"
    break;

  case 223: /* sound_flag: MPU_IRQ int_bool  */
#line 1131 "parser.y"
                                        { config.mpu401_irq = (yyvsp[0].i_value); }
#line 4341 "parser.c"
    break;

  case 224: /* sound_flag: MPU_IRQ_MT32 expression  */
#line 1132 "parser.y"
                                                { config.mpu401_irq_mt32 = (yyvsp[0].i_value); }
#line 4347 "parser.c"
    break;

  case 225: /* sound_flag: SOUND_DRIVER string_expr  */
#line 1133 "parser.y"
                                                { free(config.sound_driver); config.sound_driver = (yyvsp[0].s_value); }
#line 4353 "parser.c"
    break;

  case 226: /* sound_flag: MIDI_DRIVER string_expr  */
#line 1134 "parser.y"
                                                { free(config.midi_driver); config.midi_driver = (yyvsp[0].s_value); }
#line 4359 "parser.c"
    break;

  case 227: /* sound_flag: MUNT_ROMS string_expr  */
#line 1136 "parser.y"
                        {
				free(config.munt_roms_dir);
				config.munt_roms_dir = concat_dir(LOCALDIR, (yyvsp[0].s_value));
				free((yyvsp[0].s_value));
			}
#line 4369 "parser.c"
    break;

  case 228: /* sound_flag: SND_PLUGIN_PARAMS string_expr  */
#line 1141 "parser.y"
                                                { free(config.snd_plugin_params); config.snd_plugin_params = (yyvsp[0].s_value); }
#line 4375 "parser.c"
    break;

  case 229: /* sound_flag: PCM_HPF bool  */
#line 1142 "parser.y"
                                        { config.pcm_hpf = ((yyvsp[0].i_value)!=0); }
#line 4381 "parser.c"
    break;

  case 230: /* sound_flag: MIDI_FILE string_expr  */
#line 1143 "parser.y"
                                        { free(config.midi_file); config.midi_file = (yyvsp[0].s_value); }
#line 4387 "parser.c"
    break;

  case 231: /* sound_flag: WAV_FILE string_expr  */
#line 1144 "parser.y"
                                        { free(config.wav_file); config.wav_file = (yyvsp[0].s_value); }
#line 4393 "parser.c"
    break;

  case 234: /* joystick_flag: JOY_DEVICE string_expr  */
#line 1152 "parser.y"
                                                { set_joy_device((yyvsp[0].s_value)); }
#line 4399 "parser.c"
    break;

  case 235: /* joystick_flag: JOY_DOS_MIN expression  */
#line 1153 "parser.y"
                                                { config.joy_dos_min = (yyvsp[0].i_value); }
#line 4405 "parser.c"
    break;

  case 236: /* joystick_flag: JOY_DOS_MAX expression  */
#line 1154 "parser.y"
                                                { config.joy_dos_max = (yyvsp[0].i_value); }
#line 4411 "parser.c"
    break;

  case 237: /* joystick_flag: JOY_GRANULARITY expression  */
#line 1155 "parser.y"
                                                { config.joy_granularity = (yyvsp[0].i_value); }
#line 4417 "parser.c"
    break;

  case 238: /* joystick_flag: JOY_LATENCY expression  */
#line 1156 "parser.y"
                                                { config.joy_latency = (yyvsp[0].i_value); }
#line 4423 "parser.c"
    break;

  case 241: /* video_flag: VGA  */
#line 1164 "parser.y"
                                        { config.cardtype = CARD_VGA; }
#line 4429 "parser.c"
    break;

  case 242: /* video_flag: MGA  */
#line 1165 "parser.y"
                                        { config.cardtype = CARD_MDA; }
#line 4435 "parser.c"
    break;

  case 243: /* video_flag: CGA  */
#line 1166 "parser.y"
                                        { config.cardtype = CARD_CGA; }
#line 4441 "parser.c"
    break;

  case 244: /* video_flag: EGA  */
#line 1167 "parser.y"
                                        { config.cardtype = CARD_EGA; }
#line 4447 "parser.c"
    break;

  case 245: /* video_flag: NONE  */
#line 1168 "parser.y"
                                        { config.cardtype = CARD_NONE; }
#line 4453 "parser.c"
    break;

  case 246: /* video_flag: CHIPSET CHIPSET_TYPE  */
#line 1170 "parser.y"
                    {
		    config.chipset = (yyvsp[0].i_value);
                    c_printf("CHIPSET: %d\n", (yyvsp[0].i_value));
		    }
#line 4462 "parser.c"
    break;

  case 247: /* video_flag: MEMSIZE expression  */
#line 1174 "parser.y"
                                        { config.gfxmemsize = (yyvsp[0].i_value); }
#line 4468 "parser.c"
    break;

  case 248: /* video_flag: GRAPHICS  */
#line 1176 "parser.y"
                    { config.vga = 1;
		    }
#line 4475 "parser.c"
    break;

  case 249: /* video_flag: GRAPHICS L_AUTO  */
#line 1179 "parser.y"
                    { config.vga = -1;
		    }
#line 4482 "parser.c"
    break;

  case 250: /* video_flag: CONSOLE  */
#line 1182 "parser.y"
                    { config.console_video = 1;
		    }
#line 4489 "parser.c"
    break;

  case 251: /* video_flag: CONSOLE L_AUTO  */
#line 1185 "parser.y"
                    { config.console_video = -1;
		    }
#line 4496 "parser.c"
    break;

  case 252: /* video_flag: FULLREST  */
#line 1187 "parser.y"
                                        { config.fullrestore = 1; }
#line 4502 "parser.c"
    break;

  case 253: /* video_flag: PARTREST  */
#line 1188 "parser.y"
                                        { config.fullrestore = 0; }
#line 4508 "parser.c"
    break;

  case 254: /* video_flag: VBIOS_FILE string_expr  */
#line 1189 "parser.y"
                                                { free(config.vbios_file); config.vbios_file = (yyvsp[0].s_value);
					  config.mapped_bios = 1;
					  config.vbios_copy = 0; }
#line 4516 "parser.c"
    break;

  case 255: /* video_flag: VGAEMUBIOS_FILE string_expr  */
#line 1192 "parser.y"
                                                { free(config.vgaemubios_file); config.vgaemubios_file = (yyvsp[0].s_value); }
#line 4522 "parser.c"
    break;

  case 256: /* video_flag: VBIOS_COPY  */
#line 1193 "parser.y"
                                        { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4531 "parser.c"
    break;

  case 257: /* video_flag: VBIOS_MMAP  */
#line 1197 "parser.y"
                                        { free(config.vbios_file);
					  config.vbios_file = NULL;
					  config.mapped_bios = 1;
					  config.vbios_copy = 1; }
#line 4540 "parser.c"
    break;

  case 258: /* video_flag: VBIOS_SEG expression  */
#line 1202 "parser.y"
                   {
		   config.vbios_seg = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Segment %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0xe000) && ((yyvsp[0].i_value) != 0xc000))
		      {
		      config.vbios_seg = detect_vbios_seg();
		      if (config.vbios_seg == -1) config.vbios_seg = 0xc000;
		      c_printf("CONF: VGA-BIOS-Segment set to 0x%x\n", config.vbios_seg);
		      }
		   }
#line 4555 "parser.c"
    break;

  case 259: /* video_flag: VBIOS_SIZE_TOK expression  */
#line 1213 "parser.y"
                   {
		   config.vbios_size = (yyvsp[0].i_value);
		   c_printf("CONF: VGA-BIOS-Size %x\n", (yyvsp[0].i_value));
		   if (((yyvsp[0].i_value) != 0x8000) && ((yyvsp[0].i_value) != 0x10000))
		      {
		      config.vbios_size = detect_vbios_size();
		      if (config.vbios_size == -1) config.vbios_size = 0x10000;
		      c_printf("CONF: VGA-BIOS-Size set to 0x%x\n", config.vbios_size);
		      }
		   }
#line 4570 "parser.c"
    break;

  case 260: /* video_flag: VBIOS_POST  */
#line 1223 "parser.y"
                                        { config.vbios_post = 1; }
#line 4576 "parser.c"
    break;

  case 261: /* video_flag: DUALMON  */
#line 1224 "parser.y"
                                        { config.dualmon = 1; }
#line 4582 "parser.c"
    break;

  case 262: /* video_flag: FORCE_VT_SWITCH  */
#line 1225 "parser.y"
                                        { config.force_vt_switch = 1; }
#line 4588 "parser.c"
    break;

  case 263: /* video_flag: PCI  */
#line 1226 "parser.y"
                                        { config.pci_video = 1; }
#line 4594 "parser.c"
    break;

  case 264: /* video_flag: STRING  */
#line 1228 "parser.y"
                    { yyerror("unrecognized video option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 4601 "parser.c"
    break;

  case 268: /* term_flag: ESCCHAR expression  */
#line 1238 "parser.y"
                                           { config.term_esc_char = (yyvsp[0].i_value); }
#line 4607 "parser.c"
    break;

  case 269: /* term_flag: COLOR bool  */
#line 1239 "parser.y"
                                        { config.term_color = ((yyvsp[0].i_value)!=0); }
#line 4613 "parser.c"
    break;

  case 270: /* term_flag: STRING  */
#line 1241 "parser.y"
                    { yyerror("unrecognized terminal option '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 4620 "parser.c"
    break;

  case 274: /* debug_flag: VIDEO bool  */
#line 1255 "parser.y"
                                        { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 4626 "parser.c"
    break;

  case 275: /* debug_flag: L_OFF  */
#line 1256 "parser.y"
                                        { set_debug_level('a', 0); }
#line 4632 "parser.c"
    break;

  case 276: /* debug_flag: SERIAL bool  */
#line 1257 "parser.y"
                                        { set_debug_level('s', ((yyvsp[0].i_value)!=0)); }
#line 4638 "parser.c"
    break;

  case 277: /* debug_flag: CONFIG bool  */
#line 1258 "parser.y"
                                        { set_debug_level('c', ((yyvsp[0].i_value)!=0)); }
#line 4644 "parser.c"
    break;

  case 278: /* debug_flag: DISK bool  */
#line 1259 "parser.y"
                                        { set_debug_level('d', ((yyvsp[0].i_value)!=0)); }
#line 4650 "parser.c"
    break;

  case 279: /* debug_flag: READ bool  */
#line 1260 "parser.y"
                                        { set_debug_level('R', ((yyvsp[0].i_value)!=0)); }
#line 4656 "parser.c"
    break;

  case 280: /* debug_flag: WRITE bool  */
#line 1261 "parser.y"
                                        { set_debug_level('W', ((yyvsp[0].i_value)!=0)); }
#line 4662 "parser.c"
    break;

  case 281: /* debug_flag: KEYB bool  */
#line 1262 "parser.y"
                                        { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 4668 "parser.c"
    break;

  case 282: /* debug_flag: KEYBOARD bool  */
#line 1263 "parser.y"
                                        { set_debug_level('k', ((yyvsp[0].i_value)!=0)); }
#line 4674 "parser.c"
    break;

  case 283: /* debug_flag: PRINTER bool  */
#line 1264 "parser.y"
                                        { set_debug_level('p', ((yyvsp[0].i_value)!=0)); }
#line 4680 "parser.c"
    break;

  case 284: /* debug_flag: IO bool  */
#line 1265 "parser.y"
                                        { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 4686 "parser.c"
    break;

  case 285: /* debug_flag: PORT bool  */
#line 1266 "parser.y"
                                        { set_debug_level('i', ((yyvsp[0].i_value)!=0)); }
#line 4692 "parser.c"
    break;

  case 286: /* debug_flag: WARNING bool  */
#line 1267 "parser.y"
                                        { set_debug_level('w', ((yyvsp[0].i_value)!=0)); }
#line 4698 "parser.c"
    break;

  case 287: /* debug_flag: GENERAL bool  */
#line 1268 "parser.y"
                                        { set_debug_level('g', ((yyvsp[0].i_value)!=0)); }
#line 4704 "parser.c"
    break;

  case 288: /* debug_flag: L_XMS bool  */
#line 1269 "parser.y"
                                        { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 4710 "parser.c"
    break;

  case 289: /* debug_flag: L_DPMI bool  */
#line 1270 "parser.y"
                                        { set_debug_level('M', ((yyvsp[0].i_value)!=0)); }
#line 4716 "parser.c"
    break;

  case 290: /* debug_flag: MOUSE bool  */
#line 1271 "parser.y"
                                        { set_debug_level('m', ((yyvsp[0].i_value)!=0)); }
#line 4722 "parser.c"
    break;

  case 291: /* debug_flag: HARDWARE bool  */
#line 1272 "parser.y"
                                        { set_debug_level('h', ((yyvsp[0].i_value)!=0)); }
#line 4728 "parser.c"
    break;

  case 292: /* debug_flag: L_IPC bool  */
#line 1273 "parser.y"
                                        { set_debug_level('I', ((yyvsp[0].i_value)!=0)); }
#line 4734 "parser.c"
    break;

  case 293: /* debug_flag: L_EMS bool  */
#line 1274 "parser.y"
                                        { set_debug_level('E', ((yyvsp[0].i_value)!=0)); }
#line 4740 "parser.c"
    break;

  case 294: /* debug_flag: NETWORK bool  */
#line 1275 "parser.y"
                                        { set_debug_level('n', ((yyvsp[0].i_value)!=0)); }
#line 4746 "parser.c"
    break;

  case 295: /* debug_flag: L_X bool  */
#line 1276 "parser.y"
                                        { set_debug_level('X', ((yyvsp[0].i_value)!=0)); }
#line 4752 "parser.c"
    break;

  case 296: /* debug_flag: L_SDL bool  */
#line 1277 "parser.y"
                                        { set_debug_level('v', ((yyvsp[0].i_value)!=0)); }
#line 4758 "parser.c"
    break;

  case 297: /* debug_flag: SOUND bool  */
#line 1278 "parser.y"
                                        { set_debug_level('S', ((yyvsp[0].i_value)!=0)); }
#line 4764 "parser.c"
    break;

  case 298: /* debug_flag: JOYSTICK bool  */
#line 1279 "parser.y"
                                        { set_debug_level('j', ((yyvsp[0].i_value)!=0)); }
#line 4770 "parser.c"
    break;

  case 299: /* debug_flag: STRING  */
#line 1281 "parser.y"
                    { yyerror("unrecognized debug flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 4776 "parser.c"
    break;

  case 303: /* mouse_flag: DEVICE string_expr  */
#line 1290 "parser.y"
                                        { free(mptr->dev); mptr->dev = (yyvsp[0].s_value); }
#line 4782 "parser.c"
    break;

  case 304: /* mouse_flag: INTERNALDRIVER  */
#line 1291 "parser.y"
                                        { mptr->intdrv = TRUE; }
#line 4788 "parser.c"
    break;

  case 305: /* mouse_flag: EMULATE3BUTTONS  */
#line 1292 "parser.y"
                                        { mptr->emulate3buttons = TRUE; }
#line 4794 "parser.c"
    break;

  case 306: /* mouse_flag: BAUDRATE expression  */
#line 1293 "parser.y"
                                        { mptr->baudRate = (yyvsp[0].i_value); }
#line 4800 "parser.c"
    break;

  case 307: /* mouse_flag: CLEARDTR  */
#line 1295 "parser.y"
                    { if (mptr->type == MOUSE_MOUSESYSTEMS)
			 mptr->cleardtr = TRUE;
		      else
			 yyerror("option CLEARDTR is only valid for MicroSystems-mice");
		    }
#line 4810 "parser.c"
    break;

  case 308: /* mouse_flag: MICROSOFT  */
#line 1301 "parser.y"
                  {
		  mptr->type = MOUSE_MICROSOFT;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 4819 "parser.c"
    break;

  case 309: /* mouse_flag: MS3BUTTON  */
#line 1306 "parser.y"
                  {
		  mptr->type = MOUSE_MS3BUTTON;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 4828 "parser.c"
    break;

  case 310: /* mouse_flag: MOUSESYSTEMS  */
#line 1311 "parser.y"
                  {
		  mptr->type = MOUSE_MOUSESYSTEMS;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
/* is cstopb needed?  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL; */
		  }
#line 4838 "parser.c"
    break;

  case 311: /* mouse_flag: MMSERIES  */
#line 1317 "parser.y"
                  {
		  mptr->type = MOUSE_MMSERIES;
		  mptr->flags = CS8 | PARENB | PARODD | CREAD | CLOCAL | HUPCL;
		  }
#line 4847 "parser.c"
    break;

  case 312: /* mouse_flag: LOGITECH  */
#line 1322 "parser.y"
                  {
		  mptr->type = MOUSE_LOGITECH;
		  mptr->flags = CS8 | CSTOPB | CREAD | CLOCAL | HUPCL;
		  }
#line 4856 "parser.c"
    break;

  case 313: /* mouse_flag: PS2  */
#line 1327 "parser.y"
                  {
		  mptr->type = MOUSE_PS2;
		  mptr->flags = 0;
		  }
#line 4865 "parser.c"
    break;

  case 314: /* mouse_flag: IMPS2  */
#line 1332 "parser.y"
                  {
		  mptr->type = MOUSE_IMPS2;
		  mptr->flags = 0;
		  }
#line 4874 "parser.c"
    break;

  case 315: /* mouse_flag: MOUSEMAN  */
#line 1337 "parser.y"
                  {
		  mptr->type = MOUSE_MOUSEMAN;
		  mptr->flags = CS7 | CREAD | CLOCAL | HUPCL;
		  }
#line 4883 "parser.c"
    break;

  case 316: /* mouse_flag: HITACHI  */
#line 1342 "parser.y"
                  {
		  mptr->type = MOUSE_HITACHI;
		  mptr->flags = CS8 | CREAD | CLOCAL | HUPCL;
		  }
#line 4892 "parser.c"
    break;

  case 317: /* mouse_flag: BUSMOUSE  */
#line 1347 "parser.y"
                  {
		  mptr->type = MOUSE_BUSMOUSE;
		  mptr->flags = 0;
		  }
#line 4901 "parser.c"
    break;

  case 318: /* mouse_flag: STRING  */
#line 1352 "parser.y"
                    { yyerror("unrecognized mouse flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 4907 "parser.c"
    break;

  case 322: /* keyboard_flag: LAYOUT KEYB_LAYOUT  */
#line 1361 "parser.y"
                                        { keyb_layout((yyvsp[0].i_value)); }
#line 4913 "parser.c"
    break;

  case 323: /* $@13: %empty  */
#line 1362 "parser.y"
                                     {keyb_layout((yyvsp[0].i_value));}
#line 4919 "parser.c"
    break;

  case 325: /* keyboard_flag: LAYOUT L_NO  */
#line 1363 "parser.y"
                                        { keyb_layout(KEYB_NO); }
#line 4925 "parser.c"
    break;

  case 326: /* keyboard_flag: LAYOUT L_AUTO  */
#line 1364 "parser.y"
                                        { keyb_layout(-1); }
#line 4931 "parser.c"
    break;

  case 327: /* keyboard_flag: RAWKEYBOARD bool  */
#line 1365 "parser.y"
                                        { config.console_keyb = (yyvsp[0].i_value); }
#line 4937 "parser.c"
    break;

  case 328: /* keyboard_flag: STRING  */
#line 1367 "parser.y"
                    { yyerror("unrecognized keyboard flag '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value));}
#line 4944 "parser.c"
    break;

  case 332: /* $@14: %empty  */
#line 1376 "parser.y"
                                          { keyb_mod('C', (yyvsp[-1].i_value), 0); }
#line 4950 "parser.c"
    break;

  case 334: /* $@15: %empty  */
#line 1377 "parser.y"
                                               { keyb_mod('a', (yyvsp[-1].i_value), 0); }
#line 4956 "parser.c"
    break;

  case 336: /* $@16: %empty  */
#line 1378 "parser.y"
                                              { keyb_mod('c', (yyvsp[-1].i_value), 0); }
#line 4962 "parser.c"
    break;

  case 338: /* $@17: %empty  */
#line 1379 "parser.y"
                                 { keyb_mod(' ', (yyvsp[-1].i_value), 0); }
#line 4968 "parser.c"
    break;

  case 340: /* $@18: %empty  */
#line 1380 "parser.y"
                                           { keyb_mod('S', (yyvsp[-1].i_value), 0); }
#line 4974 "parser.c"
    break;

  case 342: /* $@19: %empty  */
#line 1381 "parser.y"
                                         { keyb_mod('A', (yyvsp[-1].i_value), 0); }
#line 4980 "parser.c"
    break;

  case 344: /* $@20: %empty  */
#line 1382 "parser.y"
                                            { keyb_mod('N', (yyvsp[-1].i_value), 0); }
#line 4986 "parser.c"
    break;

  case 348: /* keyboard_modval: UNICODE  */
#line 1389 "parser.y"
                          { keyb_mod(0, (yyvsp[0].i_value), 1); }
#line 4992 "parser.c"
    break;

  case 349: /* keyboard_modval: DGRAVE  */
#line 1390 "parser.y"
                         { keyb_mod(0, DKY_DEAD_GRAVE, 1); }
#line 4998 "parser.c"
    break;

  case 350: /* keyboard_modval: DACUTE  */
#line 1391 "parser.y"
                         { keyb_mod(0, DKY_DEAD_ACUTE, 1); }
#line 5004 "parser.c"
    break;

  case 351: /* keyboard_modval: DCIRCUM  */
#line 1392 "parser.y"
                          { keyb_mod(0, DKY_DEAD_CIRCUMFLEX, 1); }
#line 5010 "parser.c"
    break;

  case 352: /* keyboard_modval: DTILDE  */
#line 1393 "parser.y"
                         { keyb_mod(0, DKY_DEAD_TILDE, 1); }
#line 5016 "parser.c"
    break;

  case 353: /* keyboard_modval: DBREVE  */
#line 1394 "parser.y"
                         { keyb_mod(0, DKY_DEAD_BREVE, 1); }
#line 5022 "parser.c"
    break;

  case 354: /* keyboard_modval: DABOVED  */
#line 1395 "parser.y"
                          { keyb_mod(0, DKY_DEAD_ABOVEDOT, 1); }
#line 5028 "parser.c"
    break;

  case 355: /* keyboard_modval: DDIARES  */
#line 1396 "parser.y"
                          { keyb_mod(0, DKY_DEAD_DIAERESIS, 1); }
#line 5034 "parser.c"
    break;

  case 356: /* keyboard_modval: DABOVER  */
#line 1397 "parser.y"
                          { keyb_mod(0, DKY_DEAD_ABOVERING, 1); }
#line 5040 "parser.c"
    break;

  case 357: /* keyboard_modval: DDACUTE  */
#line 1398 "parser.y"
                          { keyb_mod(0, DKY_DEAD_DOUBLEACUTE, 1); }
#line 5046 "parser.c"
    break;

  case 358: /* keyboard_modval: DCEDILLA  */
#line 1399 "parser.y"
                           { keyb_mod(0, DKY_DEAD_CEDILLA, 1); }
#line 5052 "parser.c"
    break;

  case 359: /* keyboard_modval: DIOTA  */
#line 1400 "parser.y"
                        { keyb_mod(0, DKY_VOID, 1); }
#line 5058 "parser.c"
    break;

  case 360: /* keyboard_modval: DOGONEK  */
#line 1401 "parser.y"
                          { keyb_mod(0,DKY_DEAD_OGONEK, 1); }
#line 5064 "parser.c"
    break;

  case 361: /* keyboard_modval: DCARON  */
#line 1402 "parser.y"
                         { keyb_mod(0, DKY_DEAD_CARON, 1); }
#line 5070 "parser.c"
    break;

  case 362: /* keyboard_modval: INTEGER  */
#line 1403 "parser.y"
                          { keyb_mod(0, (yyvsp[0].i_value), 0); }
#line 5076 "parser.c"
    break;

  case 363: /* keyboard_modval: '(' expression ')'  */
#line 1404 "parser.y"
                                     { keyb_mod(0, (yyvsp[-1].i_value), 0); }
#line 5082 "parser.c"
    break;

  case 364: /* keyboard_modval: string_unquoted  */
#line 1405 "parser.y"
                                  {
			char *p = (yyvsp[0].s_value);
			while (*p) keyb_mod(0, *p++, 0);
			free((yyvsp[0].s_value));
		}
#line 5092 "parser.c"
    break;

  case 367: /* ttylocks_flag: DIRECTORY string_expr  */
#line 1417 "parser.y"
                                        { free(config.tty_lockdir); config.tty_lockdir = (yyvsp[0].s_value); }
#line 5098 "parser.c"
    break;

  case 368: /* ttylocks_flag: NAMESTUB string_expr  */
#line 1418 "parser.y"
                                        { free(config.tty_lockfile); config.tty_lockfile = (yyvsp[0].s_value); }
#line 5104 "parser.c"
    break;

  case 369: /* ttylocks_flag: BINARY  */
#line 1419 "parser.y"
                                        { config.tty_lockbinary = TRUE; }
#line 5110 "parser.c"
    break;

  case 370: /* ttylocks_flag: STRING  */
#line 1421 "parser.y"
                    { yyerror("unrecognized ttylocks flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5116 "parser.c"
    break;

  case 374: /* serial_flag: DEVICE string_expr  */
#line 1430 "parser.y"
                                                { free(sptr->dev); sptr->dev = (yyvsp[0].s_value); }
#line 5122 "parser.c"
    break;

  case 375: /* serial_flag: VIRTUAL  */
#line 1431 "parser.y"
                                          {
					   if (isatty(0)) {
					     sptr->virtual = TRUE;
					     sptr->pseudo = TRUE;
					     no_local_video = 1;
					     sptr->dev = strdup(ttyname(0));
					   } else {
					     error("FD 0 is not a tty, can't "
					           "use a virtual com port\n");
					     exit(1);
					   }
					  }
#line 5139 "parser.c"
    break;

  case 376: /* serial_flag: PSEUDO  */
#line 1443 "parser.y"
                                          { sptr->pseudo = TRUE; }
#line 5145 "parser.c"
    break;

  case 377: /* serial_flag: VMODEM  */
#line 1444 "parser.y"
                                          { sptr->vmodem = TRUE; }
#line 5151 "parser.c"
    break;

  case 378: /* serial_flag: RTSCTS  */
#line 1445 "parser.y"
                                          { sptr->system_rtscts = TRUE; }
#line 5157 "parser.c"
    break;

  case 379: /* serial_flag: LOWLAT  */
#line 1446 "parser.y"
                                          { sptr->low_latency = TRUE; }
#line 5163 "parser.c"
    break;

  case 380: /* serial_flag: PCCOM  */
#line 1447 "parser.y"
                                          { sptr->custom = SER_CUSTOM_PCCOM; }
#line 5169 "parser.c"
    break;

  case 381: /* serial_flag: COM expression  */
#line 1448 "parser.y"
                                          { sptr->real_comport = (yyvsp[0].i_value); }
#line 5175 "parser.c"
    break;

  case 382: /* serial_flag: BASE expression  */
#line 1449 "parser.y"
                                                { sptr->base_port = (yyvsp[0].i_value); }
#line 5181 "parser.c"
    break;

  case 383: /* serial_flag: IRQ expression  */
#line 1450 "parser.y"
                                                { sptr->irq = (yyvsp[0].i_value); }
#line 5187 "parser.c"
    break;

  case 384: /* serial_flag: MOUSE  */
#line 1451 "parser.y"
                                        { sptr->mouse = 1; }
#line 5193 "parser.c"
    break;

  case 385: /* serial_flag: STRING  */
#line 1453 "parser.y"
                    { yyerror("unrecognized serial flag '%s'", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5199 "parser.c"
    break;

  case 389: /* printer_flag: LPT expression  */
#line 1462 "parser.y"
                                        { c_printers = (yyvsp[0].i_value) - 1; }
#line 5205 "parser.c"
    break;

  case 390: /* printer_flag: COMMAND string_expr  */
#line 1463 "parser.y"
                                        { pptr->prtcmd = (yyvsp[0].s_value); }
#line 5211 "parser.c"
    break;

  case 391: /* printer_flag: TIMEOUT expression  */
#line 1464 "parser.y"
                                        { pptr->delay = (yyvsp[0].i_value); }
#line 5217 "parser.c"
    break;

  case 392: /* printer_flag: L_FILE string_expr  */
#line 1465 "parser.y"
                                                { pptr->dev = (yyvsp[0].s_value); }
#line 5223 "parser.c"
    break;

  case 393: /* printer_flag: BASE expression  */
#line 1466 "parser.y"
                                                { pptr->base_port = (yyvsp[0].i_value); }
#line 5229 "parser.c"
    break;

  case 394: /* printer_flag: STRING  */
#line 1468 "parser.y"
                    { yyerror("unrecognized printer flag %s", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5235 "parser.c"
    break;

  case 398: /* floppy_flag: READONLY  */
#line 1477 "parser.y"
                                        { dptr->wantrdonly = 1; }
#line 5241 "parser.c"
    break;

  case 399: /* floppy_flag: THREEINCH  */
#line 1478 "parser.y"
                                { dptr->default_cmos = THREE_INCH_FLOPPY; }
#line 5247 "parser.c"
    break;

  case 400: /* floppy_flag: THREEINCH_2880  */
#line 1479 "parser.y"
                                        { dptr->default_cmos = THREE_INCH_2880KFLOP; }
#line 5253 "parser.c"
    break;

  case 401: /* floppy_flag: THREEINCH_720  */
#line 1480 "parser.y"
                                { dptr->default_cmos = THREE_INCH_720KFLOP; }
#line 5259 "parser.c"
    break;

  case 402: /* floppy_flag: FIVEINCH  */
#line 1481 "parser.y"
                                { dptr->default_cmos = FIVE_INCH_FLOPPY; }
#line 5265 "parser.c"
    break;

  case 403: /* floppy_flag: FIVEINCH_360  */
#line 1482 "parser.y"
                                { dptr->default_cmos = FIVE_INCH_360KFLOP; }
#line 5271 "parser.c"
    break;

  case 404: /* floppy_flag: L_FLOPPY string_expr  */
#line 1484 "parser.y"
                  {
		  struct stat st;

		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a floppy-device given.");
		  if (stat((yyvsp[0].s_value), &st) < 0) {
		    yyerror("Could not stat floppy device.");
		  }
		  if (S_ISREG(st.st_mode)) {
		    dptr->type = IMAGE;
		  } else if (S_ISBLK(st.st_mode)) {
		    dptr->type = FLOPPY;
		  } else if (S_ISDIR(st.st_mode)) {
		    dptr->type = DIR_TYPE;
		  } else {
		    yyerror("Floppy device/file %s is wrong type", (yyvsp[0].s_value));
		  }
		  dptr->dev_name = (yyvsp[0].s_value);
		  dptr->floppy = 1;  // tell IMAGE and DIR we are a floppy
		  }
#line 5296 "parser.c"
    break;

  case 405: /* floppy_flag: DEVICE string_expr  */
#line 1505 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5306 "parser.c"
    break;

  case 406: /* floppy_flag: DIRECTORY string_expr  */
#line 1511 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5317 "parser.c"
    break;

  case 407: /* floppy_flag: STRING  */
#line 1518 "parser.y"
                    { yyerror("unrecognized floppy disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5323 "parser.c"
    break;

  case 411: /* disk_flag: READONLY  */
#line 1525 "parser.y"
                                        { dptr->wantrdonly = 1; }
#line 5329 "parser.c"
    break;

  case 412: /* disk_flag: DISKCYL4096  */
#line 1526 "parser.y"
                                { dptr->diskcyl4096 = 1; }
#line 5335 "parser.c"
    break;

  case 413: /* disk_flag: HDTYPE1  */
#line 1527 "parser.y"
                                { dptr->hdtype = 1; }
#line 5341 "parser.c"
    break;

  case 414: /* disk_flag: HDTYPE2  */
#line 1528 "parser.y"
                                { dptr->hdtype = 2; }
#line 5347 "parser.c"
    break;

  case 415: /* disk_flag: HDTYPE9  */
#line 1529 "parser.y"
                                { dptr->hdtype = 9; }
#line 5353 "parser.c"
    break;

  case 416: /* disk_flag: SECTORS expression  */
#line 1530 "parser.y"
                                        { dptr->sectors = (yyvsp[0].i_value); }
#line 5359 "parser.c"
    break;

  case 417: /* disk_flag: CYLINDERS expression  */
#line 1531 "parser.y"
                                        { dptr->tracks = (yyvsp[0].i_value); }
#line 5365 "parser.c"
    break;

  case 418: /* disk_flag: TRACKS expression  */
#line 1532 "parser.y"
                                        { dptr->tracks = (yyvsp[0].i_value); }
#line 5371 "parser.c"
    break;

  case 419: /* disk_flag: HEADS expression  */
#line 1533 "parser.y"
                                                { dptr->heads = (yyvsp[0].i_value); }
#line 5377 "parser.c"
    break;

  case 420: /* disk_flag: OFFSET expression  */
#line 1534 "parser.y"
                                        { dptr->header = (yyvsp[0].i_value); }
#line 5383 "parser.c"
    break;

  case 421: /* disk_flag: DEVICE string_expr  */
#line 1536 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5393 "parser.c"
    break;

  case 422: /* disk_flag: L_FILE string_expr  */
#line 1542 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a disk-image file or device given.");
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5403 "parser.c"
    break;

  case 423: /* disk_flag: HDIMAGE string_expr  */
#line 1548 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk-image file given.");
		  dptr->type = IMAGE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5414 "parser.c"
    break;

  case 424: /* disk_flag: WHOLEDISK STRING  */
#line 1555 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a harddisk given.");
		  dptr->type = HDISK;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5425 "parser.c"
    break;

  case 425: /* disk_flag: L_PARTITION string_expr INTEGER  */
#line 1562 "parser.y"
                  {
                  yywarn("{ partition \"%s\" %d } the"
			 " token '%d' is ignored and can be removed.",
			 (yyvsp[-1].s_value),(yyvsp[0].i_value),(yyvsp[0].i_value));
		  do_part((yyvsp[-1].s_value));
		  }
#line 5436 "parser.c"
    break;

  case 426: /* disk_flag: L_PARTITION string_expr  */
#line 1569 "parser.y"
                  { do_part((yyvsp[0].s_value)); }
#line 5442 "parser.c"
    break;

  case 427: /* disk_flag: DIRECTORY string_expr  */
#line 1571 "parser.y"
                  {
		  if (dptr->dev_name != NULL)
		    yyerror("Two names for a directory given.");
		  dptr->type = DIR_TYPE;
		  dptr->dev_name = (yyvsp[0].s_value);
		  }
#line 5453 "parser.c"
    break;

  case 428: /* disk_flag: STRING  */
#line 1578 "parser.y"
                    { yyerror("unrecognized disk flag '%s'\n", (yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5459 "parser.c"
    break;

  case 432: /* port_flag: INTEGER  */
#line 1588 "parser.y"
                   {
		   c_printf("CONF: I/O port 0x%04x\n", (unsigned short)(yyvsp[0].i_value));
	           allow_io((yyvsp[0].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (portspeed) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5470 "parser.c"
    break;

  case 433: /* port_flag: '(' expression ')'  */
#line 1595 "parser.y"
                   {
	           allow_io((yyvsp[-1].i_value), 1, ports_permission, ports_ormask,
	                    ports_andmask, portspeed, (char*)dev_name);
		   if (portspeed) portspeed += ((portspeed>0) ? 1 : -1);
	           }
#line 5480 "parser.c"
    break;

  case 434: /* port_flag: RANGE INTEGER INTEGER  */
#line 1601 "parser.y"
                   {
		   if (portspeed > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-1].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5494 "parser.c"
    break;

  case 435: /* port_flag: RANGE expression ',' expression  */
#line 1611 "parser.y"
                   {
		   if (portspeed > 1) portspeed = 0;
		   c_printf("CONF: range of I/O ports 0x%04x-0x%04x\n",
			    (unsigned short)(yyvsp[-2].i_value), (unsigned short)(yyvsp[0].i_value));
		   allow_io((yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value) + 1, ports_permission, ports_ormask,
			    ports_andmask, portspeed, (char*)dev_name);
		   portspeed=0;
		   strcpy(dev_name,"");
		   }
#line 5508 "parser.c"
    break;

  case 436: /* port_flag: RDONLY  */
#line 1620 "parser.y"
                                        { ports_permission = IO_READ; }
#line 5514 "parser.c"
    break;

  case 437: /* port_flag: WRONLY  */
#line 1621 "parser.y"
                                        { ports_permission = IO_WRITE; }
#line 5520 "parser.c"
    break;

  case 438: /* port_flag: RDWR  */
#line 1622 "parser.y"
                                        { ports_permission = IO_RDWR; }
#line 5526 "parser.c"
    break;

  case 439: /* port_flag: ORMASK expression  */
#line 1623 "parser.y"
                                        { ports_ormask = (yyvsp[0].i_value); }
#line 5532 "parser.c"
    break;

  case 440: /* port_flag: ANDMASK expression  */
#line 1624 "parser.y"
                                        { ports_andmask = (yyvsp[0].i_value); }
#line 5538 "parser.c"
    break;

  case 441: /* port_flag: FAST  */
#line 1625 "parser.y"
                                        { portspeed = 1; }
#line 5544 "parser.c"
    break;

  case 442: /* port_flag: SLOW  */
#line 1626 "parser.y"
                                        { portspeed = -1; }
#line 5550 "parser.c"
    break;

  case 443: /* port_flag: DEVICE string_expr  */
#line 1627 "parser.y"
                                             { strcpy(dev_name,(yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5556 "parser.c"
    break;

  case 444: /* port_flag: STRING  */
#line 1629 "parser.y"
                    { yyerror("unrecognized port command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5563 "parser.c"
    break;

  case 448: /* trace_port_flag: INTEGER  */
#line 1638 "parser.y"
                        { register_port_traceing((yyvsp[0].i_value), (yyvsp[0].i_value)); }
#line 5569 "parser.c"
    break;

  case 449: /* trace_port_flag: '(' expression ')'  */
#line 1640 "parser.y"
                        { register_port_traceing((yyvsp[-1].i_value), (yyvsp[-1].i_value)); }
#line 5575 "parser.c"
    break;

  case 450: /* trace_port_flag: RANGE INTEGER INTEGER  */
#line 1642 "parser.y"
                        { register_port_traceing((yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5581 "parser.c"
    break;

  case 451: /* trace_port_flag: RANGE expression ',' expression  */
#line 1644 "parser.y"
                        { register_port_traceing((yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5587 "parser.c"
    break;

  case 452: /* trace_port_flag: CLEAR  */
#line 1645 "parser.y"
                        { clear_port_traceing(); }
#line 5593 "parser.c"
    break;

  case 453: /* trace_port_flag: STRING  */
#line 1647 "parser.y"
                    { yyerror("unrecognized port trace command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5600 "parser.c"
    break;

  case 457: /* sillyint_flag: INTEGER  */
#line 1657 "parser.y"
                          { set_irq_value(1, (yyvsp[0].i_value)); }
#line 5606 "parser.c"
    break;

  case 458: /* sillyint_flag: '(' expression ')'  */
#line 1658 "parser.y"
                                     { set_irq_value(1, (yyvsp[-1].i_value)); }
#line 5612 "parser.c"
    break;

  case 459: /* sillyint_flag: USE_SIGIO expression  */
#line 1659 "parser.y"
                                       { set_irq_value(0x10001, (yyvsp[0].i_value)); }
#line 5618 "parser.c"
    break;

  case 460: /* sillyint_flag: RANGE INTEGER INTEGER  */
#line 1660 "parser.y"
                                        { set_irq_range(1, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5624 "parser.c"
    break;

  case 461: /* sillyint_flag: RANGE expression ',' expression  */
#line 1661 "parser.y"
                                                  { set_irq_range(1, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5630 "parser.c"
    break;

  case 462: /* sillyint_flag: USE_SIGIO RANGE INTEGER INTEGER  */
#line 1662 "parser.y"
                                                  { set_irq_range(0x10001, (yyvsp[-1].i_value), (yyvsp[0].i_value)); }
#line 5636 "parser.c"
    break;

  case 463: /* sillyint_flag: USE_SIGIO RANGE expression ',' expression  */
#line 1663 "parser.y"
                                                            { set_irq_range(0x10001, (yyvsp[-2].i_value), (yyvsp[0].i_value)); }
#line 5642 "parser.c"
    break;

  case 464: /* sillyint_flag: STRING  */
#line 1665 "parser.y"
                    { yyerror("unrecognized irqpassing command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5649 "parser.c"
    break;

  case 468: /* ems_flag: INTEGER  */
#line 1676 "parser.y"
                   {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
	           }
#line 5658 "parser.c"
    break;

  case 469: /* ems_flag: '(' expression ')'  */
#line 1681 "parser.y"
                   {
		     config.ems_size = (yyvsp[-1].i_value);
		     if ((yyvsp[-1].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[-1].i_value));
	           }
#line 5667 "parser.c"
    break;

  case 470: /* ems_flag: EMS_SIZE expression  */
#line 1686 "parser.y"
                   {
		     config.ems_size = (yyvsp[0].i_value);
		     if ((yyvsp[0].i_value) > 0) c_printf("CONF: %dk bytes EMS memory\n", (yyvsp[0].i_value));
		   }
#line 5676 "parser.c"
    break;

  case 471: /* ems_flag: EMS_FRAME expression  */
#line 1691 "parser.y"
                   {
/* is there a technical reason why the EMS frame can't be at 0xC0000 or
   0xA0000 if there's space? */
#if 0
		     if ( (((yyvsp[0].i_value) & 0xfc00)>=0xc800) && (((yyvsp[0].i_value) & 0xfc00)<=0xe000) ) {
		       config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		       c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		     }
		     else yyerror("wrong EMS-frame: 0x%04x", (yyvsp[0].i_value));
#endif
	             config.ems_frame = (yyvsp[0].i_value) & 0xfc00;
		     c_printf("CONF: EMS-frame = 0x%04x\n", config.ems_frame);
		   }
#line 5694 "parser.c"
    break;

  case 472: /* ems_flag: EMS_UMA_PAGES expression  */
#line 1705 "parser.y"
                   {
		     config.ems_uma_pages = (yyvsp[0].i_value);
		   }
#line 5702 "parser.c"
    break;

  case 473: /* ems_flag: EMS_CONV_PAGES expression  */
#line 1709 "parser.y"
                   {
		     config.ems_cnv_pages = (yyvsp[0].i_value);
		   }
#line 5710 "parser.c"
    break;

  case 474: /* ems_flag: STRING  */
#line 1713 "parser.y"
                    { yyerror("unrecognized ems command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5717 "parser.c"
    break;

  case 478: /* hardware_ram_flag: INTEGER  */
#line 1724 "parser.y"
                   {
                     if (!register_hardware_ram('h', (yyvsp[0].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[0].i_value));
                     }
	           }
#line 5727 "parser.c"
    break;

  case 479: /* hardware_ram_flag: '(' expression ')'  */
#line 1730 "parser.y"
                   {
                     if (!register_hardware_ram('h', (yyvsp[-1].i_value), PAGE_SIZE)) {
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
                     }
	           }
#line 5737 "parser.c"
    break;

  case 480: /* hardware_ram_flag: RANGE INTEGER INTEGER  */
#line 1736 "parser.y"
                   {
                     if (register_hardware_ram('h', (yyvsp[-1].i_value), (yyvsp[0].i_value) - (yyvsp[-1].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-1].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-1].i_value));
		   }
#line 5748 "parser.c"
    break;

  case 481: /* hardware_ram_flag: RANGE expression ',' expression  */
#line 1743 "parser.y"
                   {
                     if (register_hardware_ram('h', (yyvsp[-2].i_value), (yyvsp[0].i_value) - (yyvsp[-2].i_value)))
	               c_printf("CONF: hardware ram pages at 0x%08x-%08x\n", (yyvsp[-2].i_value), (yyvsp[0].i_value));
                     else
                       yyerror("wrong hardware ram address : 0x%08x", (yyvsp[-2].i_value));
		   }
#line 5759 "parser.c"
    break;

  case 482: /* hardware_ram_flag: STRING  */
#line 1750 "parser.y"
                    { yyerror("unrecognized hardware ram command '%s'", (yyvsp[0].s_value));
		      free((yyvsp[0].s_value)); }
#line 5766 "parser.c"
    break;

  case 486: /* int_bool: expression  */
#line 1764 "parser.y"
                {
			if ((yyvsp[0].i_value) == -2) {
				yyerror("got 'on', expected 'off' or an integer");
			}
		}
#line 5776 "parser.c"
    break;

  case 487: /* irq_bool: expression  */
#line 1771 "parser.y"
                           {
			if ( (yyvsp[0].i_value) && (((yyvsp[0].i_value) < 2) || ((yyvsp[0].i_value) > 15)) ) {
				yyerror("got '%d', expected 'off' or an integer 2..15", (yyvsp[0].i_value));
			} 
		}
#line 5786 "parser.c"
    break;

  case 488: /* speaker: L_OFF  */
#line 1780 "parser.y"
                                { (yyval.i_value) = SPKR_OFF; }
#line 5792 "parser.c"
    break;

  case 489: /* speaker: NATIVE  */
#line 1781 "parser.y"
                                { (yyval.i_value) = SPKR_NATIVE; }
#line 5798 "parser.c"
    break;

  case 490: /* speaker: EMULATED  */
#line 1782 "parser.y"
                                { (yyval.i_value) = SPKR_EMULATED; }
#line 5804 "parser.c"
    break;

  case 491: /* speaker: STRING  */
#line 1783 "parser.y"
                                { yyerror("got '%s', expected 'emulated' or 'native'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 5811 "parser.c"
    break;

  case 492: /* speaker: error  */
#line 1785 "parser.y"
                                { yyerror("expected 'emulated' or 'native'"); }
#line 5817 "parser.c"
    break;

  case 493: /* cpuemu: L_OFF  */
#line 1790 "parser.y"
                                { (yyval.i_value) = 0; }
#line 5823 "parser.c"
    break;

  case 494: /* cpuemu: VM86  */
#line 1791 "parser.y"
                                { (yyval.i_value) = 3; }
#line 5829 "parser.c"
    break;

  case 495: /* cpuemu: FULL  */
#line 1792 "parser.y"
                                { (yyval.i_value) = 4; }
#line 5835 "parser.c"
    break;

  case 496: /* cpuemu: VM86SIM  */
#line 1793 "parser.y"
                                { (yyval.i_value) = 5; }
#line 5841 "parser.c"
    break;

  case 497: /* cpuemu: FULLSIM  */
#line 1794 "parser.y"
                                { (yyval.i_value) = 6; }
#line 5847 "parser.c"
    break;

  case 498: /* cpuemu: STRING  */
#line 1795 "parser.y"
                                { yyerror("got '%s', expected 'off', 'vm86' or 'full'", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 5854 "parser.c"
    break;

  case 499: /* cpuemu: error  */
#line 1797 "parser.y"
                                { yyerror("expected 'off', 'vm86' or 'full'"); }
#line 5860 "parser.c"
    break;

  case 500: /* cpu_vm: L_AUTO  */
#line 1800 "parser.y"
                                { (yyval.i_value) = -1; }
#line 5866 "parser.c"
    break;

  case 501: /* cpu_vm: VM86  */
#line 1801 "parser.y"
                                { (yyval.i_value) = CPUVM_VM86; }
#line 5872 "parser.c"
    break;

  case 502: /* cpu_vm: KVM  */
#line 1802 "parser.y"
                                { (yyval.i_value) = CPUVM_KVM; }
#line 5878 "parser.c"
    break;

  case 503: /* cpu_vm: EMULATED  */
#line 1803 "parser.y"
                                { (yyval.i_value) = CPUVM_EMU; }
#line 5884 "parser.c"
    break;

  case 504: /* cpu_vm: STRING  */
#line 1804 "parser.y"
                                { yyerror("got '%s' for cpu_vm", (yyvsp[0].s_value));
				  free((yyvsp[0].s_value)); }
#line 5891 "parser.c"
    break;

  case 505: /* cpu_vm: error  */
#line 1806 "parser.y"
                                { yyerror("bad value for cpu_vm"); }
#line 5897 "parser.c"
    break;

  case 508: /* charset_flag: INTERNAL STRING  */
#line 1813 "parser.y"
                                  { set_internal_charset ((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5903 "parser.c"
    break;

  case 509: /* charset_flag: EXTERNAL STRING  */
#line 1814 "parser.y"
                                  { set_external_charset ((yyvsp[0].s_value)); free((yyvsp[0].s_value)); }
#line 5909 "parser.c"
    break;


#line 5913 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1817 "parser.y"


	/* features */

static void handle_features(int which, int value)
{
  if ((which < 0)
	|| (which >= (sizeof(config.features) / sizeof(config.features[0])))) {
    c_printf("CONF: wrong feature number %d\n", which);
    return;
  }
  config.features[which] = value;
  c_printf("CONF: feature %d set to %d\n", which, value);
}

	/* joystick */

static void set_joy_device(char *devstring)
{
  char *spacepos;

  free(config.joy_device[0]);
  config.joy_device[0] = devstring;
  config.joy_device[1] = NULL;
  spacepos = strchr(devstring, ' ');
  if (spacepos != NULL) {
    *spacepos = '\0';
    config.joy_device[1] = spacepos + 1;
  }
}

	/* mouse */

static void start_mouse(void)
{
  mptr = &config.mouse;
  mptr->fd = -1;
  mptr->com = -1;
  mptr->has3buttons = 1;	// drivers can disable this
}

static void stop_mouse(void)
{
  char *p, *p1;
  if (mptr->dev && (p = strstr(mptr->dev, "com")) && strlen(p) > 3) {
    /* parse comX setting */
    mptr->com = atoi(p + 3);
    /* see if something else is specified and remove comX */
    if (p > mptr->dev) {
      p[-1] = 0;
    } else if ((p1 = strchr(p, ','))) {
      int l;
      p1++;
      l = strlen(p1);
      memmove(mptr->dev, p1, l + 1);
    } else {
      free(mptr->dev);
      mptr->dev = NULL;
    }
    c_printf("MOUSE: using COM%i\n", mptr->com);
  }
  c_printf("MOUSE: %s, type %x using internaldriver: %s, emulate3buttons: %s baudrate: %d\n", 
        mptr->dev && mptr->dev[0] ? mptr->dev : "no device specified",
        mptr->type, mptr->intdrv ? "yes" : "no", 
        mptr->emulate3buttons ? "yes" : "no", mptr->baudRate);
}

	/* debug */

static void start_ports(void)
{
  if (priv_lvl)
    yyerror("Can not change port privileges in user config file");
  ports_permission = IO_RDWR;
  ports_ormask = 0;
  ports_andmask = 0xFFFF;
}

	/* debug */

static void start_debug(void)
{
  set_debug_level('a', 0);	      /* Default is no debugging output at all */
}

	/* video */

static void start_video(void)
{
  free(config.vbios_file);
  config.vbios_file = NULL;
  config.vbios_copy = 0;
  config.vbios_seg  = 0xc000;
  config.vbios_size = 0x10000;
  config.console_video = 0;
  config.cardtype = CARD_NONE;
  config.chipset = PLAINVGA;
  config.mapped_bios = 0;
  config.vga = 0;
  config.gfxmemsize = 256;
  config.fullrestore = 0;
  config.dualmon = 0;
  config.force_vt_switch = 0;
}

static void stop_video(void)
{
  if (priv_lvl)
    config.console_video = 0;

  if ((config.cardtype != CARD_VGA) || !config.console_video) {
    config.vga = 0;
  }
}

	/* vesa modes */
static void set_vesamodes(int width, int height, int color_bits)
{
  vesamode_type *vmt = malloc(sizeof *vmt);
  if(vmt != NULL) {
    vmt->width = width;
    vmt->height = height;
    vmt->color_bits = color_bits;
    vmt->next = config.vesamode_list;
    config.vesamode_list = vmt;
  }
}

	/* vbios detection */
static int auto_vbios_seg = -1;
static int auto_vbios_size = -1;

static void detect_vbios(void)
{
  unsigned char c[0x21];
  int foffset;

  if (auto_vbios_seg != -1) return;
  if (!can_do_root_stuff || config.vbios_file) return;
  for (foffset = 0xc0000; foffset < 0xf0000; foffset += 0x800) {
    load_file("/dev/mem", foffset, c, sizeof(c));
    if (c[0]==0x55 && c[1]==0xaa
        && c[0x1e]=='I' && c[0x1f]=='B' && c[0x20]=='M') {
      auto_vbios_seg = foffset >> 4;
      auto_vbios_size = c[2]*0x200;
      break;
    }
  }
}

static int detect_vbios_seg(void)
{
  detect_vbios();
  return auto_vbios_seg;
}

static int detect_vbios_size(void)
{
  detect_vbios();
  return auto_vbios_size;
}

static void stop_ttylocks(void)
{
  c_printf("SER: directory %s namestub %s binary %s\n", config.tty_lockdir,
	   config.tty_lockfile,(config.tty_lockbinary?"Yes":"No"));
}

	/* serial */

static void start_serial(void)
{
  if (c_ser >= MAX_SER)
    sptr = &nullser;
  else {
    /* The defaults for interrupt, base_port, real_comport and dev are 
    ** automatically filled in inside the do_ser_init routine of serial.c
    */
    sptr = &com_cfg[c_ser];
    sptr->dev = NULL;
    sptr->irq = 0; 
    sptr->base_port = 0;
    sptr->end_port = 0;
    sptr->real_comport = 0;
    sptr->mouse = 0;
    sptr->virtual = FALSE;
    sptr->pseudo = FALSE;
    sptr->system_rtscts = FALSE;
    sptr->low_latency = FALSE;
    sptr->dmx_port = 0;
    sptr->custom = SER_CUSTOM_NONE;
  }
}


static void stop_serial(void)
{
  if (c_ser >= MAX_SER) {
    c_printf("SER: too many ports, ignoring %s\n", sptr->dev);
    return;
  }
  c_printf("SER%d: %s", c_ser, sptr->dev ?: "none");
  if (sptr->base_port)
    c_printf(" port %x", sptr->base_port);
  if (sptr->irq)
    c_printf(" irq %x", sptr->irq);
  c_printf("\n");
  c_ser++;
  config.num_ser = c_ser;
}

	/* keyboard */

static int keyboard_statement_already = 0;

static void start_keyboard(void)
{
  keyb_layout(KEYB_USER); /* NOTE: the default has changed, --Hans, 971204 */
  config.console_keyb = 0;
  keyboard_statement_already = 1;
}

static void stop_terminal(void)
{
}

	/* printer */

static void start_printer(void)
{
  pptr->prtcmd = NULL;
  pptr->dev = NULL;
  pptr->remaining = -1;
  pptr->delay = 10;
}

static void stop_printer(void)
{
  printer_config(c_printers, pptr);
  c_printf("CONF(LPT%d) f: %s   c: %s  t: %d  port: %x\n",
           c_printers, pptr->dev, pptr->prtcmd,
           pptr->delay, pptr->base_port);
  c_printers++;
  if (c_printers > config.num_lpt)
    config.num_lpt = c_printers;
}

	/* disk */

static void start_floppy(void)
{
  if (c_fdisks >= MAX_FDISKS)
    {
    yyerror("There are too many floppy disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &disktab[c_fdisks];

  dptr->sectors = 0;             /* setup default values */
  dptr->heads   = 0;
  dptr->tracks  = 0;
  dptr->type    = FLOPPY;
  dptr->default_cmos = THREE_INCH_FLOPPY;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->wantrdonly = 0;
  dptr->header = 0;
}

static void start_disk(void)
{
  if (c_hdisks >= MAX_HDISKS) 
    {
    yyerror("There are too many hard disks defined");
    dptr = &nulldisk;          /* Dummy-Entry to avoid core-dumps */
    }
  else
    dptr = &hdisktab[c_hdisks];

  dptr->type    =  NODISK;
  dptr->sectors = -1;
  dptr->heads   = -1;
  dptr->tracks  = -1;
  dptr->fdesc   = -1;
  dptr->hdtype = 0;
  dptr->timeout = 0;
  dptr->dev_name = NULL;              /* default-values */
  dptr->wantrdonly = 0;
  dptr->header = 0;
  dptr->dexeflags = 0;
}

static void start_vnet(char *mode) {
  if (strcmp(mode, "") == 0) {
    config.vnet = VNET_TYPE_AUTO;
    return;
  }
  if (strcmp(mode, "tap") == 0) {
    config.vnet = VNET_TYPE_TAP;
    return;
  }
  if (strcmp(mode, "vde") == 0) {
    config.vnet = VNET_TYPE_VDE;
    return;
  }
  IFCLASS(CL_NET) {}
  if (strcmp(mode, "eth") == 0)
    config.vnet = VNET_TYPE_ETH;
  else {
    error("Unknown vnet mode \"%s\"\n", mode);
    config.exitearly = 1;
  }
}

static void do_part(char *dev)
{
  if (dptr->dev_name != NULL)
    yyerror("Two names for a partition given.");
  dptr->type = PARTITION;
  dptr->dev_name = dev;
#ifdef __linux__
  dptr->part_info.number = atoi(dptr->dev_name+8);
#endif
  if (dptr->part_info.number == 0)
    yyerror("%s must be a PARTITION, can't find number suffix!\n",
	    dptr->dev_name);
}

static void stop_disk(int token)
{
#ifdef __linux__
  FILE   *f;
  struct mntent *mtab;
#endif
  int    mounted_rw;

  if (dexe_running && dexe_forbid_disk)
    return;
  if (dptr == &nulldisk)              /* is there any disk? */
    return;                           /* no, nothing to do */

  if (!dptr->dev_name)                /* Is there a file/device-name? */
    yyerror("disk: no device/file-name given!");
  else                                /* check the file/device for existance */
    {
      struct stat st;

      if (stat(dptr->dev_name, &st) != 0) { /* Does this file exist? */
        yyerror("disk: device/file %s doesn't exist.", dptr->dev_name);
      }
    }

  if (dptr->type == NODISK)    /* Is it one of image, floppy, harddisk ? */
    yyerror("disk: no device/file-name given!"); /* No, error */
  else
    c_printf("CONF: disk type '%s'", disk_t_str(dptr->type));

  if (dptr->type == PARTITION) {
    c_printf(" partition# %d", dptr->part_info.number);
#ifdef __linux__
    mtab = NULL;
    if ((f = setmntent(MOUNTED, "r")) != NULL) {
      while ((mtab = getmntent(f)))
        if (!strcmp(dptr->dev_name, mtab->mnt_fsname)) break;
      endmntent(f);
    }
    if (mtab) {
      mounted_rw = ( hasmntopt(mtab, MNTOPT_RW) != NULL );
      if (mounted_rw && !dptr->wantrdonly) 
        yyerror("\n\nYou specified '%s' for read-write Direct Partition Access,"
                "\nit is currently mounted read-write on '%s' !!!\n",
                dptr->dev_name, mtab->mnt_dir);
      else if (mounted_rw) 
        yywarn("You specified '%s' for read-only Direct Partition Access,"
               "\n         it is currently mounted read-write on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
      else if (!dptr->wantrdonly) 
        yywarn("You specified '%s' for read-write Direct Partition Access,"
               "\n         it is currently mounted read-only on '%s'.\n",
               dptr->dev_name, mtab->mnt_dir);
    }
#endif
  }

  if (dptr->type == IMAGE) {
    char buf[HEADER_SIZE];
    struct image_header *header = (struct image_header *)&buf;
    int fd;

    dptr->header = 0;

    fd = open(dptr->dev_name, O_RDONLY);
    if (fd != -1) {
      if (read(fd, &buf, sizeof buf) == HEADER_SIZE) {
        if (memcmp(header->sig, IMAGE_MAGIC, IMAGE_MAGIC_SIZE) == 0)
          dptr->header = header->header_end;
        c_printf(" header_size: %ld", (long)dptr->header);
      }
      close(fd);
    }
  }

  if (token == L_FLOPPY) {
    c_printf(" floppy %c:\n", 'A'+c_fdisks);
    c_fdisks++;
    config.fdisks = c_fdisks;
  }
  else {
    c_printf(" drive %c:\n", 'C'+c_hdisks);
    c_hdisks++;
    config.hdisks = c_hdisks;
  }
}

	/* keyboard */

void keyb_layout(int layout)
{
  struct keytable_entry *kt = keytable_list;
  if (layout == -1) {
    /* auto: do it later */
    config.keytable = NULL;
    return;
  }
  while (kt->name) {
    if (kt->keyboard == layout) {
      if (kt->flags & KT_ALTERNATE) {
        c_printf("CONF: Alternate keyboard-layout %s\n", kt->name);
        config.altkeytable = kt;
      } else {
      c_printf("CONF: Keyboard-layout %s\n", kt->name);
      config.keytable = kt;
      }
      return;
    }
    kt++;
  }
  c_printf("CONF: ERROR -- Keyboard has incorrect number!!!\n");
}

static void keytable_start(int layout)
{
  static struct keytable_entry *saved_kt = 0;
  if (layout == -1) {
    if (keyboard_statement_already) {
      if (config.keytable != saved_kt) {
        yywarn("keytable changed to %s table, but previously was defined %s\n",
                config.keytable->name, saved_kt->name);
      }
    }
  }
  else {
    saved_kt = config.keytable;
    keyb_layout(layout);
  }
}

static void keytable_stop(void)
{
  keytable_start(-1);
}

static void dump_keytables_to_file(char *name)
{
  FILE * f;
  struct keytable_entry *kt = keytable_list;

  f = fopen(name, "w");
  if (!f) {
    error("cannot create keytable file %s\n", name);
    exit(1);
  }
  
  while (kt->name) {
    dump_keytable(f, kt);
    kt++;
  }
  fclose(f);
  exit(0);
}

static void set_irq_value(int bits, int i1)
{
  if ((i1>2) && (i1<=15)) {
    config.sillyint |= (bits << i1);
    c_printf("CONF: IRQ %d for irqpassing", i1);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
  else yyerror("wrong IRQ for irqpassing command: %d", i1);
}

static void set_irq_range(int bits, int i1, int i2) {
  int i;
  if ( (i1<3) || (i1>15) || (i2<3) || (i2>15) || (i1 > i2 ) ) {
    yyerror("wrong IRQ range for irqpassing command: %d .. %d", i1, i2);
  }
  else {
    for (i=i1; i<=i2; i++) config.sillyint |= (bits << i);
    c_printf("CONF: range of IRQs for irqpassing %d .. %d", i1, i2);
    if (bits & 0x10000)  c_printf(" uses SIGIO\n");
    else c_printf("\n");
  }
}


	/* errors & warnings */

void yywarn(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  fprintf(stderr, "Warning: ");
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  warnings++;
}

void yyerror(char* string, ...)
{
  va_list vars;
  va_start(vars, string);
  if (include_stack_ptr != 0 && !last_include) {
	  int i;
	  fprintf(stderr, "In file included from %s:%d\n",
		  include_fnames[0], include_lines[0]);
	  for(i = 1; i < include_stack_ptr; i++) {
		  fprintf(stderr, "                 from %s:%d\n",
			  include_fnames[i], include_lines[i]);
	  }
	  last_include = 1;
  }
  fprintf(stderr, "Error in %s: (line %.3d) ", 
	  include_fnames[include_stack_ptr], line_count);
  vfprintf(stderr, string, vars);
  fprintf(stderr, "\n");
  va_end(vars);
  errors++;
}


/*
 * open_file - opens the configuration-file named *filename and returns
 *             a file-pointer. The error/warning-counters are reset to zero.
 */

static FILE *open_file(char *filename)
{
  errors   = 0;                  /* Reset error counter */
  warnings = 0;                  /* Reset counter for warnings */

  if (!filename) return 0;
  return fopen(filename, "r"); /* Open config-file */
}

/*
 * close_file - Close the configuration file and issue a message about
 *              errors/warnings that occured. If there were errors, the
 *              flag early-exit is that, so dosemu won't really.
 */

static void close_file(FILE * file)
{
  if (file) fclose(file);                  /* Close the config-file */

  if(errors)
    fprintf(stderr, "%d error(s) detected while parsing the configuration-file\n",
	    errors);
  if(warnings)
    fprintf(stderr, "%d warning(s) detected while parsing the configuration-file\n",
	    warnings);

  if (errors != 0)               /* Exit dosemu on errors */
    {
      config.exitearly = TRUE;
    }
}

/* write_to_syslog */
static void write_to_syslog(char *message)
{
  openlog("dosemu", LOG_PID, LOG_USER | LOG_NOTICE);
  syslog(LOG_PID | LOG_USER | LOG_NOTICE, "%s", message);
  closelog();
}

static void move_dosemu_lib_dir(char *path)
{
  char *commands_path;
  if (dosemu_lib_dir_path != path) {
    if (dosemu_lib_dir_path != dosemulib_default)
      free(dosemu_lib_dir_path);
    dosemu_lib_dir_path = strdup(path);
  }
  fddir_default = assemble_path(dosemu_lib_dir_path, FREEDOS_DIR, 0);
  setenv("DOSEMU_LIB_DIR", dosemu_lib_dir_path, 1);
  commands_path = assemble_path(dosemu_lib_dir_path, CMDS_SUFF, 0);
  setenv("DOSEMU_COMMANDS_DIR", commands_path, 1);
  free(commands_path);

  if (keymap_load_base_path != keymaploadbase_default)
    free(keymap_load_base_path);
  keymap_load_base_path = assemble_path(path, "", 0);
}

static FILE *open_dosemu_users(void)
{
  FILE *fp;
  fp = open_file(DOSEMU_USERS_FILE);
  if (fp) return fp;
  return 0;
}

static void setup_home_directories(void)
{
  setenv("DOSEMU_HDIMAGE_DIR", dosemu_hdimage_dir_path, 1);
  LOCALDIR = get_dosemu_local_home();
  RUNDIR = mkdir_under(LOCALDIR, "run", 0);
  DOSEMU_MIDI_PATH = assemble_path(RUNDIR, DOSEMU_MIDI, 0);
  DOSEMU_MIDI_IN_PATH = assemble_path(RUNDIR, DOSEMU_MIDI_IN, 0);
}

static void lax_user_checking(void)
{
  char *p;
  define_config_variable("c_all");
  p = getenv("USER");
  if (!p) p = "guest";
  setenv("DOSEMU_USER", p, 1);
  setenv("DOSEMU_REAL_USER", p, 1);
  setup_home_directories();
}

/* Parse TimeMode, Paul Crawford and Andrew Brooks 2004-08-01 */
/* Accepts "bios", "pit", "linux", default is "bios". Use with TIMEMODE token */
int parse_timemode(const char *timemodestr)
{
   if (timemodestr == NULL || timemodestr[0] == '\0')
     return(TM_BIOS); /* default */
   if (strcmp(timemodestr, "linux")==0)
     return(TM_LINUX);
   if (strcmp(timemodestr, "pit")==0)
     return(TM_PIT);
   if (strcmp(timemodestr, "bios")==0)
     return(TM_BIOS);
   yyerror("Unrecognised time mode (not bios, pit or linux)");
   return(TM_BIOS);
}

/* Parse Users for DOSEMU, by Alan Hourihane, alanh@fairlite.demon.co.uk */
/* Jan-17-1996: Erik Mouw (J.A.K.Mouw@et.tudelft.nl)
 *  - added logging facilities
 * In 1998:     Hans
 *  - havy changes and re-arangments
 */
void
parse_dosemu_users(void)
{
#define ALL_USERS "all"
#define PBUFLEN 256

  FILE *volatile fp;
  struct passwd *pwd;
  char buf[PBUFLEN];
  int userok = 0;
  char *ustr;
  int uid;
  int have_vars=0;

  /* We come here _very_ early (at top of main()) to avoid security conflicts.
   * priv_init() has already been called, but nothing more.
   *
   * We will exit, if /etc/dosemu.users says that the user has no right
   * to run a suid root dosemu (and we are on), but will continue, if the user
   * is running a non-suid copy _and_ is mentioned in dosemu users.
   * The dosemu.users entry for such a user is:
   *
   *      joeodd  ... nosuidroot
   *
   * The functions we call rely on the following setting:
   */
  after_secure_check = 0;
  priv_lvl = 0;

  setenv("DOSEMU_CONF_DIR", DOSEMU_CONF_DIR, 1);
  /* we check for some vital global settings
   * which we need before proceeding
   */
  setenv("DOSEMU_LIB_DIR", dosemulib_default, 1);
  move_dosemu_lib_dir(dosemu_lib_dir_path);

  fp = open_dosemu_users();
  if (fp) while (fgets(buf, PBUFLEN, fp) != NULL) {
    int l = strlen(buf);
    if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
    ustr = strtok(buf, " \t\n=,;:");
    if (ustr && (ustr[0] != '#')) {
      if (!strcmp(ustr, "default_lib_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_lib_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          move_dosemu_lib_dir(ustr);
        }
      }
      if (!strcmp(ustr, "default_hdimage_dir")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          if (!exists_dir(ustr)) {
            char *tx = "default_hdimage_dir %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
          if (dosemu_hdimage_dir_path != dosemuhdimage_default)
            free(dosemu_hdimage_dir_path);
          dosemu_hdimage_dir_path = strdup(ustr);
	  dexe_load_path = dosemu_hdimage_dir_path;
        }
      }
      else if (!strcmp(ustr, "log_level")) {
        int ll = 0;
        ustr=strtok(0, " \t\n=,;:");
        if (ustr) {
          ll = atoi(ustr);
          if (ll < 0) ll = 0;
          if (ll > 2) ll = 2;
        }
      }
      else if (!strcmp(ustr, "config_script")) {
        ustr=strtok(0, " \t\n=,;:");
        if (ustr && strcmp(ustr, DEFAULT_CONFIG_SCRIPT)) {
          config_script_path = strdup(ustr);
          if (!exists_file(config_script_path)) {
            char *tx = "config_script %s does not exist\n";
            fprintf(stderr, tx, ustr);
            fprintf(stdout, tx, ustr);
            exit(1);
          }
	  config_script_name = strdup(ustr);
	}
      }
    }
  }
  if (fp) fclose(fp);

  if (!can_do_root_stuff || under_root_login) {
     /* simply ignore -- we're not suid-root */
     lax_user_checking();
     after_secure_check = 1;
     return;
  }

  /* We want to test if the _user_ is allowed to do certain privileged    */
  /* things, o check if the username connected to the get_orig_uid() is   */
  /* in the DOSEMU_USERS_FILE file (usually /etc/dosemu.users).           */
   
  uid = get_orig_uid();

  errno = 0; /* man says this is necessary?! */
  pwd = getpwuid(uid);

  /* Sanity Check, Shouldn't be anyone logged in without a userid */
  if (!pwd) 
     {
       error("Illegal User: uid=%i, error=%s\n", uid, strerror(errno));
       sprintf(buf, "Illegal DOSEMU user: uid=%i", uid);
       write_to_syslog(buf);
       exit(1);
     }

  /* preset DOSEMU_*USER env, such that a user can't fake it */
  setenv("DOSEMU_USER", "unknown", 1);
  setenv("DOSEMU_REAL_USER", pwd->pw_name, 1);

  {
       int can_have_privsetup = 0;
       fp = open_dosemu_users();
       if (fp) {
	   for(userok=0; fgets(buf, PBUFLEN, fp) != NULL && !userok; ) {
	     int l = strlen(buf);
	     if (l && (buf[l-1] == '\n')) buf[l-1] = 0;
	     ustr = strtok(buf, " \t\n,;:");
	     if (ustr && (ustr[0] != '#')) {
	       if (strcmp(ustr, pwd->pw_name)== 0) 
		 userok = 1;
	       else if (strcmp(ustr, ALL_USERS)== 0)
		 userok = 1;
	       if (userok) {
		 setenv("DOSEMU_USER", ustr, 1);
		 while ((ustr=strtok(0, " \t,;:")) !=0) {
		   if (ustr[0] == '#') break;
		   define_config_variable(ustr);
		   have_vars = 1;
                   if (!strcmp(ustr,"private_setup")) {
                     can_have_privsetup = 1;
                   }
		 }
	         if (!have_vars && !using_sudo)
		   define_config_variable("restricted");
	       }
	     }
	   }
           fclose(fp);
       }
       

       if (can_have_privsetup
              && (   get_config_variable("unrestricted")
                  || under_root_login || !can_do_root_stuff)) {
         /* this user is allowed to have a privat ~/.dosemu/lib
          * (which replaces DOSEMULIB_DEFAULT if existing).
          * Hence this user can have its own global.conf e.t.c.
          * However, this is only possible with non-suid-root
          * binary or when running under root loggin or when 'unrestricted'
          * also is set.       -- Hans
          */
         char *lpath = get_path_in_HOME(LOCALDIR_BASE_NAME "/lib");
         if (exists_dir(lpath)) move_dosemu_lib_dir(lpath);
         free(lpath);
       }
  }

  define_config_variable("c_all");
  if(userok==0 && !using_sudo) {
    define_config_variable("restricted");
  }
  if (get_config_variable("nosuidroot") || (get_config_variable("restricted") && !on_console())) {
    fprintf(stderr, "Dropping root privileges: guest or a restricted user not on console.\n");
    priv_drop();
    lax_user_checking();
    after_secure_check = 1;
    return;
  }

  /* now we setup up our local DOSEMU home directory, where we
   * have (among other things) all temporary stuff in
   * (since 0.97.10.2)
   */
  setup_home_directories();
  after_secure_check = 1;
}


char *commandline_statements=0;

static int has_dexe_magic(char *name)
{
  int fd, magic, ret;
  fd = open(name, O_RDONLY);
  if (fd <0) return 0;
  ret = (read(fd, &magic, 4) == 4) && (magic == DEXE_MAGIC);
  close(fd);
  return ret;
}

static int stat_dexe(char *name)
{
  struct stat s;
  if (stat(name, &s)) return 0;
  if ( ! S_ISREG(s.st_mode)) return 0;
  if ((s.st_mode & S_IXUSR) && (s.st_uid == get_orig_uid()))
    return has_dexe_magic(name);
  if ((s.st_mode & S_IXGRP) && (is_in_groups(s.st_gid)))
    return  has_dexe_magic(name); 
  if (s.st_mode & S_IXOTH) return has_dexe_magic(name);
  return 0;
}

static char *resolve_exec_path(char *dexename, char *ext)
{
  enum { maxn=0x255 };
  static char n[maxn+1];
  static char name[maxn+1];
  char *p, *path=getenv("PATH");

  strncpy(name,dexename,maxn);
  name[maxn] = 0;
  n[maxn] = 0;
  p = rindex(name, '.');
  if ( ext && ((p && strcmp(p, ext)) || !p) )
    strncat(name,ext,maxn);


  /* first try the pure file name */
  if (!path || (name[0] == '/') || (!strncmp(name, "./", 2))) {
    if (stat_dexe(name)) return name;
    return 0;
  }

  /* next try the standard path for DEXE files */
  snprintf(n, maxn, "%s/%s", dexe_load_path, name);
  if (stat_dexe(n)) return n;

  /* now search in the users normal PATH */
  path = strdup(path);
  p= strtok(path,":");
  while (p) {
    snprintf(n, maxn, "%s/%s", p, name);
    if (stat_dexe(n)) {
      free(path);
      return n;
    }
    p=strtok(0,":");
  }
  free(path);
  return 0;
}

void prepare_dexe_load(char *name)
{
  char *n, *cbuf;
  int fd, csize;
  struct image_header ihdr;

  n = resolve_exec_path(name, ".dexe");
  if (!n) {
    n = resolve_exec_path(name, 0);
    if (!n) {
      error("DEXE file not found or not executable\n");
      exit(1);
    }
  }

  /* now we extract the configuration file and the access flags */
  fd = open(n, O_RDONLY);
  if (read(fd, &ihdr, sizeof(struct image_header)) != sizeof(struct image_header)) {
    error("broken DEXE format, can't read image header\n");
    close(fd);
    exit(1);
  }

  lseek(fd, HEADER_SIZE + 0x200, SEEK_SET); /* just behind the MBR */
  if ((read(fd, &csize, 4) != 4) || (csize > 0x2000)) {
    error("broken DEXE format, configuration not found\n");
    close(fd);
    exit(1);
  }
  
  /* we use the -I option to feed in the configuration,
   * and we put ours in front of eventually existing options
   */
  if (commandline_statements) {
    cbuf = malloc(csize+1+strlen(commandline_statements)+1);
    read(fd, cbuf, csize);
    cbuf[csize] = '\n';
    strcpy(cbuf+csize+1, commandline_statements);
  }
  else {
    cbuf = malloc(csize+1);
    read(fd, cbuf, csize);
    cbuf[csize] = 0;
  }
  commandline_statements = cbuf;
  close(fd);

  start_disk();
  dptr->type = IMAGE;
  dptr->header = HEADER_SIZE;
  dptr->dev_name = n;
  dptr->dexeflags = ihdr.dexeflags | DISK_IS_DEXE;
  stop_disk(DISK);
  dexe_running = 1;
}


static void do_parse(FILE* fp, char *confname, char *errtx)
{
        yyin = fp;
        line_count = 1;
	include_stack_ptr = 0;
        c_printf("CONF: Parsing %s file.\n", confname);
	file_being_parsed = strdup(confname);
	include_fnames[include_stack_ptr] = file_being_parsed;
	yyrestart(fp);
        if (yyparse()) yyerror(errtx, confname);
        close_file(fp);
	include_stack_ptr = 0;
	include_fnames[include_stack_ptr] = 0;
	free(file_being_parsed);
}

int parse_config(char *confname, char *dosrcname)
{
  FILE *fd;
  int is_user_config;
#if YYDEBUG != 0
  yydebug  = 1;
#endif

  define_config_variable(PARSER_VERSION_STRING);

  /* Let's try confname if not null, and fail if not found */
  /* Else try the user's own .dosrc (old) or .dosemurc (new) */
  /* If that doesn't exist we will default to CONFIG_FILE */

  { 
    if (!dosrcname) {
      char *name = get_path_in_HOME(DOSEMU_RC);
      setenv("DOSEMU_RC", name, 1);
      free(name);
    }
    else {
      setenv("DOSEMU_RC",dosrcname,1);
    }

    /* privileged options allowed? */
    is_user_config = (confname && config_script_path && strcmp(confname, config_script_path));
    priv_lvl = !under_root_login && can_do_root_stuff && is_user_config;

    /* DEXE together with option F ? */
    if (priv_lvl && dexe_running) {
      /* for security reasons we cannot allow this */
      fprintf(stderr, "user cannot load DEXE file together with option -F\n");
      exit(1);
    }

    if (is_user_config) define_config_variable("c_user");
    else define_config_variable("c_system");
    if (dexe_running) define_config_variable("c_dexerun");

    yy_vbuffer = dosemu_conf;
    do_parse(NULL, "built-in dosemu.conf", "error in built-in dosemu.conf");
    yy_vbuffer = global_conf;
    do_parse(NULL, "built-in global.conf", "error in built-in global.conf");
    if (confname) {
      yy_vbuffer = NULL;
      fd = open_file(confname);
      if (!fd) {
        if (!dexe_running) {
          fprintf(stderr, "Cannot open base config file %s, Aborting DOSEMU.\n",confname);
          exit(1);
        }
      }
      do_parse(fd, confname, "error in configuration file %s");
    }

    if (priv_lvl) undefine_config_variable("c_user");
    else undefine_config_variable("c_system");

    if (!get_config_variable(CONFNAME_V3USED)) {
	/* we obviously have an old configuration file
         * ( or a too simple one )
	 * giving up
	 */
	yyerror("\nYour %s script or configuration file is obviously\n"
		"an old style or a too simple one\n"
		"Please read README.txt on how to upgrade\n", confname);
	exit(1);
    }

    /* privileged options allowed for user's config? */
    priv_lvl = !under_root_login && can_do_root_stuff;
    if (priv_lvl) define_config_variable("c_user");

    /* Now we parse any commandline statements from option '-I'
     * We do this under priv_lvl set above, so we have the same secure level
     * as with .dosrc
     */

    if (commandline_statements) {
      #define XX_NAME "commandline"

      open_file(0);
      define_config_variable("c_comline");
      c_printf("Parsing " XX_NAME  " statements.\n");
      yyin=0;				 /* say: we have no input file */
      yy_vbuffer=commandline_statements; /* this is the input to scan */
      do_parse(0, XX_NAME, "error in user's %s statement");
      undefine_config_variable("c_comline");
    }
  }

  /* check for global settings, that should know the whole settings
   * This we only can do, after having parsed all statements
   */

  if (dexe_running) {
    /* force a BootC,
     * regardless what ever was set in the config files
     */
    config.hdiskboot = 2;
  }
  else {
    if (get_config_variable("c_dexeonly")) {
       c_printf("CONF: only execution of DEXE files allowed\n");
       fprintf(stderr, "only execution of DEXE files allowed\n");
       exit(99);
    }
  }

#ifdef TESTING
  error("TESTING: parser is terminating program\n");
  exit(0);
#endif
  return 1;
}

#define MAX_CONFIGVARIABLES 128
char *config_variables[MAX_CONFIGVARIABLES+1] = {0};
static int config_variables_count = 0;
static int config_variables_last = 0;
static int allowed_classes = -1;
static int saved_allowed_classes = -1;



static int is_in_allowed_classes(int mask)
{
  if (!(allowed_classes & mask)) {
    yyerror("insufficient class privilege to use this configuration option\n");
    exit(99);
  }
  return 1;
}

struct config_classes {
	char *class;
	int mask;
} config_classes[] = {
	{"c_all", CL_ALL},
	{"c_normal", CL_ALL & (~(CL_VAR | CL_VPORT | CL_IRQ | CL_HARDRAM | CL_PCI | CL_NET))},
	{"c_var", CL_VAR},
	{"c_system", CL_ALL},
	{"c_vport", CL_VPORT},
	{"c_port", CL_PORT},
	{"c_irq", CL_IRQ},
	{"c_pci", CL_PCI},
	{"c_hardram", CL_HARDRAM},
	{"c_net", CL_NET},
	{0,0}
};

static int get_class_mask(char *name)
{
  struct config_classes *p = &config_classes[0];
  while (p->class) {
    if (!strcmp(p->class,name)) return p->mask;
    p++;
  }
  return 0;
}

static void update_class_mask(void)
{
  int i, m;
  allowed_classes = 0;
  for (i=0; i< config_variables_count; i++) {
    if ((m=get_class_mask(config_variables[i])) != 0) {
      allowed_classes |= m;
    }
  }
}

static void enter_user_scope(int incstackptr)
{
  if (user_scope_level) return;
  saved_priv_lvl = priv_lvl;
  priv_lvl = 1;
  saved_allowed_classes = allowed_classes;
  allowed_classes = 0;
  user_scope_level = incstackptr;
  c_printf("CONF: entered user scope, includelevel %d\n", incstackptr-1);
}

static void leave_user_scope(int incstackptr)
{
  if (user_scope_level != incstackptr) return;
  priv_lvl = saved_priv_lvl;
  allowed_classes = saved_allowed_classes;
  user_scope_level = 0;
  c_printf("CONF: left user scope, includelevel %d\n", incstackptr-1);
}

char *get_config_variable(char *name)
{
  int i;
  for (i=0; i< config_variables_count; i++) {
    if (!strcmp(name, config_variables[i])) {
      config_variables_last = i;
      return config_variables[i];
    }
  }
  return 0;
}

int define_config_variable(char *name)
{
  if (priv_lvl) {
    if (strcmp(name, CONFNAME_V3USED) && strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to define config variable %s\n", name);
      return 0;
    }
  }
  if (!get_config_variable(name)) {
    if (config_variables_count < MAX_CONFIGVARIABLES) {
      config_variables[config_variables_count++] = strdup(name);
      if (!priv_lvl) update_class_mask();
    }
    else {
      if (after_secure_check)
        c_printf("CONF: overflow on config variable list\n");
      return 0;
    }
  }
  if (after_secure_check)
    c_printf("CONF: config variable %s set\n", name);
  return 1;
}

static int undefine_config_variable(char *name)
{
  if (priv_lvl) {
    if (strncmp(name, "u_", 2)) {
      c_printf("CONF: not enough privilege to undefine config variable %s\n", name);
      return 0;
    }
  }
  if (get_config_variable(name)) {
    int i;
    if (!strcmp(name, CONFNAME_V3USED)) parser_version_3_style_used = 0;
    free(config_variables[config_variables_last]);
    for (i=config_variables_last; i<(config_variables_count-1); i++) {
      config_variables[i] = config_variables[i+1];
    }
    config_variables_count--;
    if (!priv_lvl) update_class_mask();
    c_printf("CONF: config variable %s unset\n", name);
    return 1;
  }
  return 0;
}

char *checked_getenv(const char *name)
{
  if (user_scope_level) {
     char *s, *name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
     strcpy(name_, USERVAR_PREF);
     strcat(name_, name);
     s = getenv(name_);
     free(name_);
     if (s) return s;
  }
  return getenv(name);
}

static void check_user_var(char *name)
{
	char *name_;
	char *s;

	if (user_scope_level) return;
	name_ = malloc(strlen(name)+sizeof(USERVAR_PREF));
	strcpy(name_, USERVAR_PREF);
	strcat(name_, name);
	s = getenv(name_);
	if (s) {
		if (getenv(name))
			c_printf("CONF: variable %s replaced by user\n", name);
		setenv(name, s, 1);
		unsetenv(name_);
	}
	free(name_);
}


static char *run_shell(char *command)
{
	int pipefds[2];
	pid_t pid;
	char excode[16] = "1";

	setenv("DOSEMU_SHELL_RETURN", excode, 1);
	if (pipe(pipefds)) return strdup("");
	pid = fork();
	if (pid == -1) return strdup("");
	if (!pid) {
		/* child */
		int ret;
		close(pipefds[0]);	/* we won't read from the pipe */
		dup2(pipefds[1], 1);	/* make the pipe child's stdout */
		priv_drop();	/* drop any priviledges */
		ret = system(command);
			/* tell the parent: "we have finished",
			 * this way we need not to play games with select()
			 */
		if (ret == -1) ret = errno;
		else ret >>=8;
		write(pipefds[1],"\0\0\0",4);
		close(pipefds[1]);
		_exit(ret);
	}
	else {
		/* parent */
		char *buf = 0;
		int recsize = 128;
		int bufsize = 0;
		int ptr =0;
		int ret;
		int status;

		close(pipefds[1]);	/* we won't write to the pipe */
		do {
			bufsize = ptr + recsize;
			if (!buf) buf = malloc(bufsize);
			else buf = realloc(buf, bufsize);
			ret = read(pipefds[0], buf+ptr, recsize -1);
			if (ret > 0) {
				ptr += ret;
			}
		} while (ret >0 && (ret < 4 || memcmp(buf+ptr-4,"\0\0\0",4)));
		close(pipefds[0]);
		waitpid(pid, &status, 0);
		buf[ptr] = 0;
		if (!buf[0]) {
			free(buf);
			buf = strdup("");
		}
		sprintf(excode, "%d", WEXITSTATUS(status));
		setenv("DOSEMU_SHELL_RETURN", excode, 1);
		return buf;
	}
}


struct for_each_entry {
	char *list;
	char *ptr;
	int skip_restart;
};

#define FOR_EACH_DEPTH	16
static struct for_each_entry *for_each_list = 0;

static int for_each_handling(int loopid, char *varname, char *delim, char *list)
{
	struct for_each_entry *fe;
	char * new;
	char saved;
	if (!for_each_list) {
		int size = FOR_EACH_DEPTH * sizeof(struct for_each_entry);
		for_each_list = malloc(size);
		memset(for_each_list, 0, size);
	}
	if (loopid > FOR_EACH_DEPTH) {
		yyerror("too deeply nested foreach\n");
		return 0;
	}
	fe = for_each_list + loopid;
	if (!fe->list) {
		/* starting the loop */
		fe->ptr = fe->list = strdup(list);
		fe->skip_restart = 0;
		if (loopid) {
			/* in inner loops we need to skip the restart */
			fe->skip_restart = 1;
		}
	}
	else {
		if (fe->skip_restart) {
			fe->skip_restart = 0;
			return 1;
		}
	}
	while (fe->ptr[0] && strchr(delim,fe->ptr[0])) fe->ptr++;
	/* subsequent call */
	if (!fe->ptr[0]) {
		/* loop end */
		free(fe->list);
		fe->list = 0;
		return (0);
	}
	new = strpbrk(fe->ptr, delim);
	if (!new) new = strchr(fe->ptr,0);
	saved = *new;
	*new = 0;
	setenv(varname,fe->ptr,1);
	if (saved) new++;
	fe->ptr = new;
	return (1);
}

#ifdef TESTING_MAIN

static void die(char *reason)
{
  error("par dead: %s\n", reason);
  exit(0);
}

int
main(int argc, char **argv)
{
  if (argc != 2)
    die("no filename!");

  if (!parse_config(argv[1], argv[2] /* will be NULL if not given */))
    die("parse failed!\n");
}

#endif

/* for keyboard plugin */



static void keyb_mod(int wich, t_keysym keynum, int unicode)
{
	static t_keysym *table = 0;
	static int count = 0;
	
	if (wich == ' ') {
		switch (keynum & 0xFF00) {
		case 0x000: wich = ' '; break;
		case 0x100: wich = 'S'; break;
		case 0x200: wich = 'A'; break;
		case 0x300: wich = 'N'; break;
		case 0x400: wich = 'C'; break;
		case 0x500: wich = 'a'; break;
		case 0x600: wich = 'c'; break;
		default: 
			/* It's a bad value ditch it */
			wich ='X'; table = 0; count = 0; break;
		}
		keynum &= 0xFF;
	}

	switch (wich) {
	case ' ': table = config.keytable->key_map;
		count=config.keytable->sizemap;
		break;
	case 'S': table = config.keytable->shift_map;
		count=config.keytable->sizemap;
		break;
	case 'A': table = config.keytable->alt_map;
		count=config.keytable->sizemap;
		break;
	case 'C': table = config.keytable->ctrl_map;
		count=config.keytable->sizemap;
		break;
	case 'a': table = config.keytable->shift_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'c': table = config.keytable->ctrl_alt_map;
		count=config.keytable->sizemap;
		break;
	case 'N': table = config.keytable->num_table;
		count=config.keytable->sizepad;
		break;
	}


	if (!table || (count == 0) || (wich != 0 && keynum >= count)) {
		count = 0;
		table = 0;
		return;
	}
	if (wich != 0) {
		table += keynum;
		count -= keynum;
		return;
	}
	if (!unicode) {
		if (keynum == 0) {
			keynum = DKY_VOID;
		} else {
			keynum = keynum + 0xEF00;
		}
	}
	if (count > 0) {
		*table++ = keynum;
		count--;
	}
}


static char *get_key_name(t_keysym key)
{
	struct key_names {
		t_keysym key;
		char *name;
	};
	static struct key_names names[] =
	{
		{ DKY_DEAD_GRAVE,	"dgrave"},
		{ DKY_DEAD_ACUTE,	"dacute"},
		{ DKY_DEAD_CIRCUMFLEX,	"dcircum"},
		{ DKY_DEAD_TILDE,	"dtilde"},
		{ DKY_DEAD_BREVE,	"dbreve"},
		{ DKY_DEAD_ABOVEDOT,	"daboved"},
		{ DKY_DEAD_DIAERESIS,	"ddiares"},
		{ DKY_DEAD_ABOVERING,	"dabover"},
		{ DKY_DEAD_DOUBLEACUTE,	"ddacute"},
		{ DKY_DEAD_CEDILLA,	"dcedilla"},
		{ DKY_DEAD_OGONEK,	"dogonek"},
		{ DKY_DEAD_CARON,	"dcaron"},
	};
	int i;
	for(i = 0; i < sizeof(names)/sizeof(names[0]); i++) {
		if (names[i].key == key) {
			return names[i].name;
		}
	}
	return 0;
}

static void dump_keytable_part(FILE *f, t_keysym *map, int size)
{
  int i, in_string=0;
  t_keysym c;
  char *cc, comma=' ', buf[16];

  /* Note: This code assumes every font is a superset of ascii */
  if (!map) {
	  return;
  }
  size--;
  for (i=0; i<=size; i++) {
    c = map[i];
    if (!(i & 15)) fprintf(f,"    ");
    cc = get_key_name(c);
    if (!cc && (c < 128) && isprint(c) && !strchr("\\\"\'`", c)) {
      if (in_string) fputc(c,f);
      else {
        fprintf(f, "%c\"%c", comma, c);
        in_string = 1;
      }
    }
    else {
      if (!cc) {
	if (((c > 0) && (c < 128)) || ((c >= 0xEF00) && (c <= 0xEFFF))) {
	  sprintf(buf, "%d", c & 0xFF);
	} else if (c == DKY_VOID) {
	  strcpy(buf, "0");
	} else {
	  sprintf(buf, "\\u%04x", c);
	}
	cc = buf;
      }
      if (!in_string) fprintf(f, "%c%s", comma, cc);
      else {
        fprintf(f, "\",%s", cc);
        in_string = 0;
      }
    }
    if ((i & 15) == 15) {
      if (in_string) fputc('"', f);
      if (i < size) fputc(',', f);
      fputc('\n', f);
      in_string = 0;
      comma = ' ';
    }
    else comma = ',';
  }
  if (in_string) fputc('"', f);
  fputc('\n', f);
}


void dump_keytable(FILE *f, struct keytable_entry *kt)
{
    fprintf(f, "keytable %s {\n", kt->name);
    fprintf(f, "  0=\n");
    dump_keytable_part(f, kt->key_map, kt->sizemap);
    fprintf(f, "  shift 0=\n");
    dump_keytable_part(f, kt->shift_map, kt->sizemap);
    fprintf(f, "  alt 0=\n");
    dump_keytable_part(f, kt->alt_map, kt->sizemap);
    fprintf(f, "  numpad 0=\n");
    dump_keytable_part(f, kt->num_table, kt->sizepad-1);
    fprintf(f, "  ctrl 0=\n");
    dump_keytable_part(f, kt->ctrl_map, kt->sizemap);
    fprintf(f, "  shift-alt 0=\n");
    dump_keytable_part(f, kt->shift_alt_map, kt->sizemap);
    fprintf(f, "  ctrl-alt 0=\n");
    dump_keytable_part(f, kt->ctrl_alt_map, kt->sizemap);
    fprintf(f, "}\n\n\n");
}



	/* charset */
static struct char_set *get_charset(char *name)
{
	struct char_set *charset;

	charset = lookup_charset(name);
	if (!charset) {
		yyerror("Can't find charset %s", name);
	}
	return charset;

}

static void set_external_charset(char *charset_name)
{
	struct char_set *charset;
	charset = get_charset(charset_name);
	charset = get_terminal_charset(charset);
	if (charset) {
		if (!trconfig.output_charset) {
			trconfig.output_charset = charset;
		}
		if (!trconfig.keyb_charset) {
			trconfig.keyb_charset = charset;
		}
	}
	return;
}

static void set_internal_charset(char *charset_name)
{
	struct char_set *charset_video, *charset_config;
	charset_video = get_charset(charset_name);
	if (!is_display_charset(charset_video)) {
		yyerror("%s not suitable as an internal charset", charset_name);
	}
	charset_config = get_terminal_charset(charset_video);
	if (charset_video && !trconfig.video_mem_charset) {
		trconfig.video_mem_charset = charset_video;
	}
	if (charset_config && !trconfig.keyb_config_charset) {
		trconfig.keyb_config_charset = charset_config;
	}
	if (charset_config && !trconfig.dos_charset) {
		trconfig.dos_charset = charset_config;
	}
	return;
}

